dnl $Id: config.m4,v 1.2 2005/04/12 15:14:36 jlacroix Exp $
dnl config.m4 for extension chameleon

PHP_ARG_WITH(chameleon, for chameleon support,
[  --with-chameleon=DIR             Include chameleon support (DIR=Chameleon directory)])
PHP_ARG_WITH(chameleon_libxml, xml2-config path for chameleon support,
[  --with-chameleon_libxml=DIR             xml2-config (from libxml) path for chameleon])

  dnl Build as a module
  ext_shared=yes

  dnl Get the Chameleon path
  if test "$PHP_CHAMELEON" != "no" -a "$PHP_CHAMELEON" != "yes"; then
    CHAMELEON_DIR=$PHP_CHAMELEON
  else
    CHAMELEON_DIR="../.."
  fi

  dnl Check if the chamleon path is correct.
  if test ! -d "$CHAMELEON_DIR" ; then
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([$CHAMELEON_DIR Please provide a valid Chameleon directory. eg. --with-chameleon=/Chameleon/directory])
  fi

  if test ! -d "$CHAMELEON_DIR/ext" ; then
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([Chameleon extension directory does not exist])
  fi

  if test ! -e $CHAMELEON_DIR/ext/src/libchameleon.a ; then
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([$CHAMELEON_DIR/ext/src/libchameleon.a Please compile chameleon extensions first])
  fi

  dnl Check if port library is compiled
  if test ! -e "$CHAMELEON_DIR/ext/port/cpl_error.o" ; then
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([$CHAMELEON_DIR/ext/port/cpl_error.o Please compile the CPL library first])
  fi

  dnl Include libxml2
  SEARCH_PATH="/usr/local/bin /usr/bin"
  SEARCH_FOR="xml2-config"

  if test -r $PHP_CHAMELEON_LIBXML; then
    LIBXML=$PHP_CHAMELEON_LIBXML
  else 
    AC_MSG_CHECKING([for xml2-config files in default path])
    for i in $SEARCH_PATH ; do
      if test -r $i/$SEARCH_FOR; then
        LIBXML=$i/$SEARCH_FOR
        AC_MSG_RESULT(found $i)
        break
      fi
    done
  fi

  dnl Test for LIBXML results
  if test -z "$LIBXML"; then
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([Please install the libxml2 distribution (Normally you have done so to compile chameleon!?!)])
  fi

  if ! $LIBXML --libs print > /dev/null 2>&1; then
    AC_MSG_RESULT([does not work])
    AC_MSG_ERROR([$LIBXML --libs does not work])
  fi

  if ! $LIBXML --cflags print > /dev/null 2>&1; then
    AC_MSG_RESULT([does not work])
    AC_MSG_ERROR([$LIBXML --cflags does not work])
  fi

  dnl Add the libxml library in the Include lines
  PHP_EVAL_INCLINE(`$LIBXML --cflags`)
  PHP_EVAL_LIBLINE(`$LIBXML --libs`, CHAMELEON_SHARED_LIBADD)

  dnl Add the CPL library
  PHP_EVAL_INCLINE(-I$CHAMELEON_DIR/ext/port)
  PHP_ADD_LIBRARY_WITH_PATH(cpl, $CHAMELEON_DIR/ext/port, CHAMELEON_SHARED_LIBADD)

  dnl Add the chameleon library
  PHP_EVAL_INCLINE(-I$CHAMELEON_DIR/ext/src)
  PHP_ADD_LIBRARY_WITH_PATH(chameleon, $CHAMELEON_DIR/ext/src, CHAMELEON_SHARED_LIBADD)

  PHP_SUBST(CHAMELEON_SHARED_LIBADD)

  dnl to add the extension
  PHP_NEW_EXTENSION(chameleon, chameleon.c, $ext_shared)

