<?php
/**
  _____________________________________________________________________________
 |
 | MapNotes Widget
 |
 | @project     Chameleon
 | @revision    $Id: properties.php,v 1.19 2006/04/25 15:06:40 jlacroix Exp $
 | @purpose     Creates annotations on map.
 | @author      DM Solutions Group (wbronsema@dmsolutions.ca)
 | @copyright
 | <b>Copyright (c) 2004 DM Solutions Group Inc.</b>
 | Permission is hereby granted, free of charge, to any person obtaining a
 | copy of this software and associated documentation files (the "Software"),
 | to deal in the Software without restriction, including without limitation
 | the rights to use, copy, modify, merge, publish, distribute, sublicense,
 | and/or sell copies of the Software, and to permit persons to whom the
 | Software is furnished to do so, subject to the following conditions:
 |
 | The above copyright notice and this permission notice shall be included
 | in all copies or substantial portions of the Software.
 |
 | THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 | IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 | FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 | THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 | LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 | FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 | DEALINGS IN THE SOFTWARE.
 |_____________________________________________________________________________

 **/

 //set the language resource file
$szLanguageResource = str_replace("\\","/",dirname(__FILE__))."/MapNotes";

// set the flag to setup the mapsession
if ( !defined("LOAD_MAPSESSION") )
    define("LOAD_MAPSESSION", 1);

// include the session handling file (currently only required for MLT)
include_once(dirname(__FILE__)."/../session.inc.php");
include_once(dirname(__FILE__)."/../CWC2ButtonCache.php");
include_once( COMMON."wrapper/map_query.php" );

if (!extension_loaded('dbase'))
{
    $dbasemodulename = 'php_dbase.'.PHP_SHLIB_SUFFIX;
    dl( $dbasemodulename );
}

// debug
//echo '<br><br><br><br><br><br><br><br><br><br><br><br><br><br>'.
//    '<br><br><br><br><br><br>';

/* ============================================================================
 * Get form variables
 * ========================================================================= */
$_FORM = array_merge( $_GET, $_POST );

/* ============================================================================
 * Convert pixels to geo
 * ========================================================================= */
$dGeoX = pixel_to_geo( $_FORM['mouse_x'], 0, $oMapSession->oMap->width,
    $oMapSession->oMap->extent->minx, $oMapSession->oMap->extent->maxx );
$dGeoY = pixel_to_geo( $_FORM['mouse_y'], 0, $oMapSession->oMap->height,
    $oMapSession->oMap->extent->miny, $oMapSession->oMap->extent->maxy, 1 );

/* ============================================================================
 * Default values
 * ========================================================================= */
$txtLabel = isset( $_FORM['label'] ) ? rawurldecode( $_FORM['label']) : $oMLT->get( 'MapNotes', '2', 'New Map Note' );
$txtFont = $_FORM['font'];
$txtFontSize = $_FORM['fontsize'];
$txtFontColor = $_FORM['fontcolor'];
$txtFontOutlineColor = $_FORM['fontoutlinecolor'];
$txtSymbol = $_FORM['symbol'];
$txtSymbolSize = $_FORM['symbolsize'];
$txtSymbolColor = $_FORM['symbolcolor'];
$txtSymbolOutlineColor = $_FORM['symboloutlinecolor'];
$txtMarquee = $_FORM['marquee'];
$txtOffsetX = $_FORM['offsetx'];
$txtOffsetY = $_FORM['offsety'];
$txtLabelPosition = $_FORM['labelposition'];
$szSID = session_id();
$nPointID = isset( $_FORM['point_id'] )?$_FORM['point_id']: -1;
$szDisableEditButtons = 'disabled';
$szMode = isset( $_FORM['mode'] )?$_FORM['mode']: 'ADD';
$szTitle = '';
$szSubmitCaption = '';
$szHelpText = '';

/* ============================================================================
 * Process updates
 * ========================================================================= */
// verify layer
verifyLayer( $oMapSession->oMap, $_FORM['layer'] );

// process
if ( !isset( $_FORM['update'] ) || $_FORM['update'] != '1' )
{
    // query the database and get point
    $aPoint = getPoint( $oMapSession, $_FORM['layer'],
                                $_FORM['mouse_x'], $_FORM['mouse_y'] );

    // set mode according to
    $szMode =  is_array( $aPoint[0] ) ? 'EDIT' : 'ADD';

    // set values
    switch ( $szMode )
    {
        case 'ADD':
            // default values
            $szSubmitCaption = $oMLT->get( 'MapNotes', '4', 'Add' );
            $szTitle = $oMLT->get( 'MapNotes', '8', 'Add Map Note' );
            $szHelpText = $oMLT->get( 'MapNotes', '10','This tool allows you to add a new Map Note to '.
                'your map.  Please enter a label in the box provided.  '.
                'You can also style the point using the tools below.' );
            break;

        case 'EDIT':
            // set properties
            $szSubmitCaption = $oMLT->get( 'MapNotes', '5', 'Update' );
            $szTitle = $oMLT->get( 'MapNotes', '9', 'Edit Map Note' );
            $szHelpText = $oMLT->get( 'MapNotes', '11', 'This tool allows you to edit the selected '.
                'Map Note.  You can update the label as necessary as well '.
                'as the point style.  Use the "Add as New" button to '.
                'commit the changes to a new Map Note or use the "Delete" '.
                'button to remove the currently selected Map Note.' );
            $txtFont = $aPoint[0]['font'];
            $txtFontSize = $aPoint[0]['f_size'];
            $txtFontColor = $aPoint[0]['f_color'];
            $txtFontOutlineColor = $aPoint[0]['f_ocolor'];
            $txtSymbol = $aPoint[0]['symbol'];
            $txtSymbolSize = $aPoint[0]['s_size'];
            $txtSymbolColor = $aPoint[0]['s_color'];
            $txtSymbolOutlineColor = $aPoint[0]['s_ocolor'];
            $txtMarquee = $aPoint[0]['marquee'];
            $txtOffsetX = $aPoint[0]['offsetx'];
            $txtOffsetY = $aPoint[0]['offsety'];
            $txtLabel = rawurlencode($aPoint[0]['label']);
            $txtLabelPosition = $aPoint[0]['l_pos'];
            $nPointID = $aPoint[0]['id'];

            // show delete link
            $szDisableEditButtons = '';
            break;
    }
}
else
{
    // get new temp shapefile name
    $szFileName = getUniqueName();

    // add/update point
    switch ( $szMode )
    {
        case 'ADD':
            // add point to dbf
            updateDBFRecord( $szFileName, array( $dGeoX, $dGeoY, -1, $txtFont,
                 $txtFontSize, $txtFontColor, $txtFontOutlineColor, $txtSymbol,
                 $txtSymbolSize, $txtSymbolColor, $txtSymbolOutlineColor,
                 $txtMarquee, $txtOffsetX, $txtOffsetY, $txtLabel,
                 $txtLabelPosition) );

            break;
        case 'EDIT':
            // edit point in dbf
            updateDBFRecord( $szFileName, array( $dGeoX, $dGeoY, -1, $txtFont,
                 $txtFontSize, $txtFontColor, $txtFontOutlineColor, $txtSymbol,
                 $txtSymbolSize, $txtSymbolColor, $txtSymbolOutlineColor,
                 $txtMarquee, $txtOffsetX, $txtOffsetY, $txtLabel,
                 $txtLabelPosition), $nPointID );

            break;
        case 'DELETE':
            // delete point from dbf
            updateDBFRecord( $szFileName, array(), $nPointID );
            break;
    }

    // create new shapefile
    updateShapeFile( $szFileName );

    // register entry into session
    $_SESSION['MapNotesLayerDataPath'] = $szFileName;

    // manage layer
    manageLayer( $oMapSession->oMap, $_FORM['layer'], $szFileName );

    // save the map state
    $_SESSION['gszCurrentState'] = $oMapSession->saveState();
}

/* ============================================================================
 * Create color pickers
 * ========================================================================= */
$szFontColorPicker = createColorPicker('fontcolor', $txtFontColor);
$szFontOutlineColorPicker = createColorPicker('fontoutlinecolor', $txtFontOutlineColor);
$szSymbolColorPicker = createColorPicker('symbolcolor', $txtSymbolColor);
$szSymbolOutlineColorPicker = createColorPicker('symboloutlinecolor', $txtSymbolOutlineColor);
$szSymbolPicker = createSymbolPicker( 'symbol', $txtSymbol);
/* ============================================================================
 * Build symbol size pick list
 * ========================================================================= */
$szSymbolSizeSelector = '';
for( $i=1; $i<=50; $i++ )
{
  // select if $i matches
  if ( $i != $txtSymbolSize )
  {
      $szSymbolSizeSelector .= '<option value="'.$i.'">'.$i.'</option>';
  }
  else
  {
      $szSymbolSizeSelector .= '<option value="'.$i.'" selected>'.$i.'</option>';
  }
}

/**
  _____________________________________________________________________________
 |
 |  updateDBFRecord()
 |
 |  Postcondition:  This function updates the the given dbf file.
 |
 |  @params $szFileName string - dbf path and filename.
 |  @params $aszPointProperties array - Array of point properties.
 |  @return boolean - True if successful, false if not.
 |  @desc Updates given dbf file.
 |_____________________________________________________________________________

 **/
function updateDBFRecord( $szFileName, $aszPointProperties, $nId = -1 )
{
    // init vars
    $bCreateDBF = true;

    // delete file if it exists
    if ( file_exists( $szFileName.".dbf" ) )
    {
        // remove & flag
        unlink( $szFileName.".dbf" );
        $bCreateDBF = true;
    }

    // check if previous file exists in session
    if ( isset( $_SESSION['MapNotesLayerDataPath'] ) )
    {
        // copy dbf
        if ( file_exists( $_SESSION['MapNotesLayerDataPath'].'.dbf' ) )
        {
            // copy
            $bCreateDBF = !@copy( $_SESSION['MapNotesLayerDataPath'].'.dbf',
                                                            $szFileName.'.dbf' );
            // delete original
            //unlink( $_SESSION['MapNotesLayerDataPath'].'.dbf' );

        }
    }

    // create if neessary
    if ( $bCreateDBF )
    {
        // create an array for the dbf structure
        $aDbfStruct =   array(
                            array( 'x'       ,'N', 19, 9),
                            array( 'y'       ,'N', 19, 9),
                            array( 'id'      ,'N', 7, 0 ),
                            array( 'font'    ,'C', 50   ),
                            array( 'f_size'  ,'C', 2    ),
                            array( 'f_color' ,'C', 11   ),
                            array( 'f_ocolor','C', 11   ),
                            array( 'symbol'  ,'C', 50   ),
                            array( 's_size'  ,'C', 2    ),
                            array( 's_color' ,'C', 11   ),
                            array( 's_ocolor','C', 11   ),
                            array( 'marquee', 'N', 1, 0 ),
                            array( 'offsetx', 'N', 5, 0 ),
                            array( 'offsety', 'N', 5, 0 ),
                            array( 'label'   ,'C', 255  ),
                            array( 'l_pos'   ,'C', 2    ),
                        );

        // create the dbase file
        $dbfFile = dbase_create( $szFileName.'.dbf', $aDbfStruct);
    }

    // open the dbase file if necessary
    if ( !isset( $dbfFile ) )
    {
        $dbfFile = dbase_open( $szFileName.'.dbf', 2 );
    }

    // loop through the database and match the id
    $nCount = dbase_numrecords( $dbfFile );
    $nMaxID = 0;
    for ( $i=1; $i<=$nCount; $i++ )
    {
        // get next record
        $aRec = dbase_get_record_with_names( $dbfFile, $i );

        // check for match on id
        if ( $aRec['id'] == $nId )
        {
            // delete record
            dbase_delete_record( $dbfFile, $i );

            // pack the db
            dbase_pack( $dbfFile );

            // exit loop if id is ok
            if ( $aszPointProperties[2] != -1 )
            {
                break;
            }
        }

        // update max id
        $nMaxID = max( $aRec['id'], $nMaxID );
    }

    // set id if necessary
    if ( $aszPointProperties[2] == -1 )
    {
        $aszPointProperties[2] = $nMaxID + 1;
    }

    // add the record to the dbase file if the array is populated
    if ( count($aszPointProperties) > 0 )
    {
        dbase_add_record( $dbfFile, array_values( $aszPointProperties ) );
    }

    // close the dbf
    dbase_close( $dbfFile );

    // return success
    return true;

// end updateDBFRecord() function
}

/**
  _____________________________________________________________________________
 |
 |  updateShapeFile()
 |
 |  Postcondition:  This function updates the the given shape file.
 |
 |  @params $szFileName string - dbf path and filename.
 |  @return boolean - True if successful, false if not.
 |  @desc Updates given shape file.
 |_____________________________________________________________________________

 **/
function updateShapeFile( $szFileName )
{
    // delete files of they exist
    if ( file_exists( $szFileName.".shp" ) )  unlink( $szFileName.".shp" );
    if ( file_exists( $szFileName.".shx" ) )  unlink( $szFileName.".shx" );

    // create new file
    $shpFile = ms_newShapeFileObj( $szFileName, MS_SHP_POINT );
    $shpFile->free();

    // reopen for editing
    $shpFile = ms_newShapeFileObj( $szFileName, -2 );

    // open dbf and create from scratch
    $dbfFile = dbase_open( $szFileName.'.dbf', 2 );

    // loop through the database and match the id
    $nCount = dbase_numrecords( $dbfFile );
    for ( $i=1; $i<=$nCount; $i++ )
    {
        // get next record
        $aRec = dbase_get_record_with_names( $dbfFile, $i );

        // add next point
        $oShp = ms_newShapeObj( MS_SHP_POINT );
        $oLine = ms_newLineObj();
        $oLine->addXY( $aRec['x'], $aRec['y'] );
        $oShp->add( $oLine );
        $shpFile->addShape( $oShp );


    }

    // close
    dbase_close( $dbfFile );
    $shpFile->free();

    // return success
    return true;

// end updateShapeFile() function
}

/**
  _____________________________________________________________________________
 |
 |  manageLayer()
 |
 |  Postcondition:  This function updates the layer with the new shapfile and
 |                  adds the necessary classes to display the points.
 |
 |  @params $oMap object - Map object.
 |  @params $szLayer string - Layer name to manage.
 |  @params $szShapeFile string - The shapefile to assign WITHOUT extension.
 |  @return boolean - True if successful, false if not.
 |  @desc Draws points on layer.
 |_____________________________________________________________________________

 **/
function manageLayer( &$oMap, $szLayer, $szShapeFile )
{
    // open the dbase file
    $dbfFile = dbase_open( $szShapeFile.".dbf", 0 );

    // get record count
    $nCount = dbase_numrecords( $dbfFile );

    // open temp layer
    $oLayer = $oMap->getlayerbyname( $szLayer );

    //remove existing classes ...
    $nClasses = $oLayer->numclasses;
    for($i=0;$i<$nClasses;$i++)
    {
        $oClass = $oLayer->getClass($i);
        $oClass->set( "status", MS_DELETE );
    }

    // set properties
    $oLayer->set( 'data', $szShapeFile );
    $oLayer->set( 'type', MS_LAYER_POINT );

    // only continue if there are points
    if ( $nCount < 1 )
    {
        // close and return
        dbase_close( $dbfFile );
        return true;
    }

    $oLayer->set( 'status', MS_ON );
    $oLayer->set( 'labelitem', 'label');
    $oLayer->set( 'labelcache', MS_ON );
    $oLayer->set( 'classitem', 'id' );
    $oLayer->set( 'tolerance', '5' );

    // loop through each point and add a class
    for ( $i=0; $i<$nCount; $i++ )
    {
        // get tne next record
        $aRec = dbase_get_record_with_names( $dbfFile, $i + 1 );

        // create the class object
    	$oClass = ms_newClassObj($oLayer);

    	// set class properties
    	$aColor = explode( ' ', trim($aRec['f_color']) );
    	$oClass->label->color->setRGB( $aColor[0], $aColor[1], $aColor[2] );
    	$aColor = explode( ' ', trim($aRec['f_ocolor']) );
    	$oClass->label->outlinecolor->setRGB( $aColor[0], $aColor[1], $aColor[2] );
    	$oClass->label->set( 'offsetx', $aRec['offsetx'] );
    	$oClass->label->set( 'offsety', $aRec['offsety'] );
    	$oClass->label->set( 'size' , trim($aRec['f_size']) );
    	$oClass->label->set( 'font' , trim($aRec['font']) );
    	$oClass->label->set( 'type' , MS_TRUETYPE );
    	$oClass->label->set( 'position' , translateLabelPosition( trim($aRec['l_pos']) ) );
    	$oClass->label->set( 'partials' , MS_TRUE );
    	$oClass->label->set( 'force', MS_TRUE );
    	$oClass->label->set( 'mindistance', 100 );
    	$oClass->label->set( 'buffer', 3 );
    	$oClass->setexpression( '([id] = '.$aRec['id'].')' );

    	// add the marqee as necessary
    	if ( $aRec['marquee'] == 1 )
    	{
            $oClass->label->backgroundcolor->setRGB( 255, 255, 204 );
            $oClass->label->backgroundshadowcolor->setRGB( 0, 0, 0 );
            $oClass->label->set("backgroundshadowsizex", 1 );
            $oClass->label->set("backgroundshadowsizey", 1 );
    	}

    	// create style object
    	$oStyle = ms_newStyleObj($oClass);

    	// set style properties
    	$aColor = explode( ' ', trim($aRec['s_color']) );
    	$oStyle->color->setRGB( $aColor[0], $aColor[1], $aColor[2] );
    	$aColor = explode( ' ', trim($aRec['s_ocolor']) );
    	$oStyle->outlinecolor->setRGB( $aColor[0], $aColor[1], $aColor[2] );

    	// set symbol
    	if (is_numeric(trim($aRec['symbol'])))
        {
            $oStyle->set("symbol", trim( $aRec['symbol'] ) );
        }
        else
        {
            $oStyle->set("symbolname", trim( $aRec['symbol'] ) );
        }
    	$oStyle->set('size'   , trim($aRec['s_size']) );
    }

    // close the dbase file
    dbase_close( $dbfFile );



// end manageLayer() function
}

/**
  _____________________________________________________________________________
 |
 |  getPoint()
 |
 |  Postcondition:  This function Queries the given layer at the given
 |                  location and returns properties.
 |
 |  @params $oMapSession object - Map session object.
 |  @params $szLayer string - Layer name to query.
 |  @return integer - Id if successful, -1 if not.
 |  @desc Gets id of point at requested location.
 |_____________________________________________________________________________

 **/
function getPoint( $oMapSession, $szLayer, $nPixX, $nPixY )
{
    // create query object
    $oQuery = new MapQuery( $oMapSession );

    // set the layers to query
    $aszLayers[0] = $szLayer;
    $oQuery->setQueryLayersByName( $aszLayers );

    // execute query
    $oResultSet = $oQuery->executePointQuery( $nPixX, $nPixY );

    // get the results, there should be only one row
    $aResults = $oResultSet->getResultSet( 0 );

    // return results
    return $aResults;

// end getPoint() function
}

 /**
  _____________________________________________________________________________
 |
 |  verifyLayer()
 |
 |  Postcondition:  This function checks to see if the layer exists and creates
 |                  it if necessary.
 |
 |  @params $oMap object - Map object.
 |  @params $szLayer string - Layer name to verify.
 |  @return boolean - true if successful, false if not.
 |  @desc Verifies given layer.
 |_____________________________________________________________________________

 **/
function verifyLayer( &$oMap, $szLayer )
{
    // get layer
    $oLayer = @$oMap->getLayerByName( $szLayer );

    // create the new layer if necessary
    if ( $oLayer === false )
    {
        $oLayer = ms_newLayerObj( $oMap );
    }

    // set the template
    $oLayer->set( 'template', 'ttt' );

    // set the type
    $oLayer->set( 'type', MS_LAYER_POINT );

    // set the name
    $oLayer->set( 'name', $szLayer );

    // set data if set in session
    if ( isset( $_SESSION['MapNotesLayerDataPath'] ) )
    {
        $oLayer->set( 'data', $_SESSION['MapNotesLayerDataPath'] );
    }

    // return success
    return true;

// end verifyLayer() function
}

/******************************************************************************
 * convert a pixel position to geocoded position
 *
 * @param nPixPos double pixel position
 * @param dfPixMin double minimum map pixel value
 * @param dfPixMax double maximum map pixel value
 * @param dfGeoMin double minimum map geocoded value
 * @param dfGeoMax double maximum map geocoded value
 * @param nInversePix integer optional flag to inverse , set to 1 for
 *                            Y pixel coordinates where UL > LR
 * @return double geocoded position
 *****************************************************************************/
function pixel_to_geo($nPixPos, $dfPixMin, $dfPixMax, $dfGeoMin, $dfGeoMax,
                     $nInversePix = "")
{
    // calculate the geocoded & pixel width
    $dfWidthGeo = $dfGeoMax - $dfGeoMin;
    $dfWidthPix = $dfPixMax - $dfPixMin;

    // get ratio
    $dfPixToGeo = $dfWidthGeo / $dfWidthPix;

    // get difference
    if (!$nInversePix)
        $dfDeltaPix = $nPixPos - $dfPixMin;
    else
        $dfDeltaPix = $dfPixMax - $nPixPos;

    // calculate
    $dfDeltaGeo = $dfDeltaPix * $dfPixToGeo;
    $dfPosGeo = $dfGeoMin + $dfDeltaGeo;

    // return value
    return ($dfPosGeo);

// end pixel_to_geo function
}

 /**
  _____________________________________________________________________________
 |
 |  getUniqueName()
 |
 |  Postcondition:  This function determines the path and filename of the
 |                  temporary file without extension.
 |
 |  @return string - Path and filename without extension.
 |  @desc Gets unique filename without extension.
 |_____________________________________________________________________________

 **/
function getUniqueName()
{
    // get path
    return $_SESSION['gszTmpPath'].md5(uniqid(rand(), true));

// end getUniqueName() function
}

 /**
  _____________________________________________________________________________
 |
 |  translateLabelPosition()
 |
 |  Postcondition:  This function determines the path and filename of the
 |                  temporary file without extension.
 |
 |  @return string - Path and filename without extension.
 |  @desc Gets unique filename without extension.
 |_____________________________________________________________________________

 **/

function translateLabelPosition( $szPos )
{
    // translate
    switch ( $szPos )
    {
        case 'UL':
            return MS_UL;
            break;
        case 'LR':
            return MS_LR;
            break;
        case 'UR':
            return MS_UR;
            break;
        case 'LL':
            return MS_LL;
            break;
        case 'CR':
            return MS_CR;
            break;
        case 'CL':
            return MS_CL;
            break;
        case 'UC':
            return MS_UC;
            break;
        case 'LC':
            return MS_LC;
            break;
        case 'CC':
            return MS_CC;
            break;
        case 'AUTO':
            return MS_AUTO;
            break;
    }

// end translate position function
}

function createColorPicker( $szInputName, $szColor )
{
    list($r, $g, $b) = explode( " ", $szColor);
    $szColorSwatch = $_SESSION['gszCoreWebPath']."/common/colorpicker/color.php";
    $szResult = <<<EOT
<input type="hidden" name="{$szInputName}" value="{$szColor}">
<a href="javascript:void(0);" onclick="openColorPicker( '{$szInputName}' )"><img id="{$szInputName}_img" src="{$szColorSwatch}?x=30&y=20&red={$r}&green={$g}&blue={$b}" width="30" height="20" border="0"></a>
EOT;
    return $szResult;
}

function createSymbolPicker( $szInputName, $szSymbol )
{
    $szSymbolSwatch = $_SESSION['gszCoreWebPath']."/common/picker/symbol.php";
    $szSID = SID;
    $szResult = <<<EOT
<input type="hidden" name="{$szInputName}" value="{$szSymbol}">
<a href="javascript:void(0);" onclick="openSymbolPicker( '{$szInputName}' )"><img id="{$szInputName}_img" src="{$szSymbolSwatch}?{$szSID}&width=30&height=20&nSymbolName={$szSymbol}" width="30" height="20" border="0"></a>
EOT;
    return $szResult;
}
?>
