<?php
/**
 * MapTitle Widget class
 *
 * @project     CWC2
 * @revision    $Id: MapTitle.widget.php,v 1.5 2005/01/11 12:32:20 pspencer Exp $
 * @purpose     MapTitle displays the name of the map.
 * @author      DM Solutions Group (pspencer@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
include_once(dirname(__FILE__)."/../Widget.php");

/**
 * a widget to display the map's name
 */
class MapTitle extends CWCWidget
{
    var $mszClass = "";
    var $mszStyle = "";

    /**
     * construct a new MapTitle widget
     */
    function MapTitle( )
    {
        // invoke constructor of parent
        parent::CWCWidget();

        // set the description for this widget
        $this->szWidgetDescription = <<<EOT
The MapTitle widget displays the name of the map.
EOT;

        $this->maAttributes["WIDGETCLASS"] = new StringAttribute( "WIDGETCLASS", false );
        $this->maAttributes["WIDGETSTYLE"] = new StringAttribute( "WIDGETSTYLE", false );
        $this->mnMaturityLevel = MATURITY_TECHNICALRELEASE;
    }

    /**
     * Initialize default values from tag
     */
    function InitDefaults()
    {
        parent::InitDefaults();
        
        if (isset($this->maParams["WIDGETCLASS"]))
            $this->mszClass = $this->maParams["WIDGETCLASS"];
        if (isset($this->maParams["WIDGETSTYLE"]))
            $this->mszStyle = $this->maParams["WIDGETSTYLE"];
    }

    /**
     * draw the MapTitle in published state
     */
    function DrawPublish()
    {
        if (!$this->mbVisible)
            return "<!-- MapTitle hidden -->";

        $szClass = "";
        $szStyle = "";

        $szClass = "";
        if ( strlen($this->mszClass) > 0 )
            $szClass = " CLASS=\"$this->mszClass\"";
        $szStyle = "";
        if ( strlen($this->mszStyle) > 0 )
            $szStyle = " STYLE=\"$this->mszStyle\"";
            
        $szMapTitle = $this->moMapObject->oMap->getMetaData( "wms_title" );
        if ($szMapTitle == "")
            $szMapTitle = $this->moMapObject->oMap->name;
        
        $szContents="<span".$szClass.$szStyle." name=\"txtMapTitle".$this->mnId."\">".$szMapTitle."</span>";
        return $szContents;

    }
}
?>
