<?php
/**
* Nom du fichier	indexSQRC.php
* @author Marie-Eve Levesque <marieeve_83@hotmail.com>
*
* Historique des modifications :
* 2006-09-05	Creation
* 2006-08-06	Ajout test reverse et arr__2__
* 2006-09-07	Transfert des tests vers testsSQRC
*
* Description de la classe :
* Page principale pour appeller les fonctions SQRC
**/
include_once("SQRCLookup.php");

if(isset($_GET["request"])) {
	$request=$_GET["request"];
	$parametres=$_GET;
} elseif(isset($_POST["request"])) {
	$request=$_POST["request"];
	$parametres=$_POST;
	
}

$sqrc=new SQRCLookup();
$sqrc->__construct();

switch($request) {
	case "GetCapabilities":
		$xml=$sqrc->GetCapabilities($parametres["version"]);
		if (sizeof($xml) > 0) {
			print $xml;
		} else {
			echo "Parametres invalides<br>";
		}
		break;
		
	case "GetSqrc":
		$xml=$sqrc->GetSqrc($parametres["numeroSqrc"],$parametres["type"],$parametres["tic"],$parametres["version"]);
		if (sizeof($xml) > 0) {
			print $xml;
		} else {
			echo "Parametres invalides<br>";
		}
		break;
		
	case "Geo2Sqrc":
		$sOutput=$sqrc->Geo2Sqrc($parametres["latitude"],$parametres["longitude"],$parametres["echelle"]);
		if(strlen($sOutput) > 0) {
			echo "FeuilletSQRC: ".nl2br($sOutput)."<br>";
		} else {
			echo "<br>Parametres invalides<br>";
		}
		break;
		
	case "Sqrc2Geo":
		$aOutput=$sqrc->Sqrc2Geo($parametres["numeroSqrc"],$parametres["type"],$parametres["tic"]);
		if (sizeof($aOutput) > 0) {
			echo "Geometrie:<br>";
			print_r($aOutput);
		} else {
			echo "Parametres invalides<br>";
		}
		break;
		
	default:
		echo "La commande Sqrc2Geo doit etre utilisee avec 3 parametres<br>";
		echo "Usage:<br>";
		echo "	&nbsp;&nbsp;&nbsp;&nbsp; <b>numeroSqrc:</b> Nom feuillet SQRC<br> 
				&nbsp;&nbsp;&nbsp;&nbsp; <b>type:</b> Type de geometrie<br>
				&nbsp;&nbsp;&nbsp;&nbsp; <b>tic:</b> Intervalle pour les tics (non impl&eacute;ment&eacute; pour l'instant)<br>" ;
		echo "<br>";
		
		echo "La commande Geo2Sqrc doit etre utilisee avec 3 parametres<br>";
		echo "Usage:<br>";
		echo "	&nbsp;&nbsp;&nbsp;&nbsp; <b>latitude:</b> Latitude en degres decimaux <br>
				&nbsp;&nbsp;&nbsp;&nbsp; <b>longitude:</b> Longitude en degres decimaux <br>
				&nbsp;&nbsp;&nbsp;&nbsp; <b>echelle:</b> Echelle SQRC<br>" ;
		break;
}
?>