<?php
/**
* Nom du fichier	testsSQRC.php
* @author Marie-Eve Levesque <marieeve_83@hotmail.com>
*
* Historique des modifications :
* 2006-09-07	Creation (transfert de indexSQRC)
*
* Description de la classe :
* Page principale pour appeller les fonctions SQRC
**/
include_once("SQRCLookup.php");

$sqrc=new SQRCLookup();
$sqrc->__construct();


$aOutput=$sqrc->Sqrc2Geo("31H12-005-2845",2,0);

print "<br><hr><b>deg2dec dec2deg</b><br>";
print "-45°35'12'' = ".$sqrc->deg2dec("-45°35'12''")."<br>";
print "-45.5866666667 = ".$sqrc->dec2deg("-45.5866666667")."<br>";

dl("php_mapscript.so");

print "<hr><b>deg2xy xy2deg</b><br>";
$coord=$sqrc->deg2xy("-73°43'28''","45°35'12''");
print_r($coord);
print "<br>";
$coord=$sqrc->xy2deg(287286.542,5049664.539);
print_r($coord);
print "<br>";

print "<hr><b>reverse simple deg2xy</b> -73°43'28'', 45°35'12''<br>";
$coord=$sqrc->deg2xy("-73°43'28''","45°35'12''");
$coord=$sqrc->xy2deg($coord["x"],$coord["y"]);
print_r($coord);
print "<br>";

print "<hr><b>reverse simple dec2xy</b> -73.7244444444, 45.5866666667<br>";
$coord=$sqrc->dec2xy("-73.7244444444","45.5866666667");
$coord=$sqrc->xy2dec($coord["x"],$coord["y"]);
print_r($coord);
print "<br>";

print "<hr><b>reverse simple deg2xy</b> -50°, 60°<br>";
$coord=$sqrc->deg2xy("-50°","60°");
$coord=$sqrc->xy2deg($coord["x"],$coord["y"]);
print_r($coord);
print "<br>";

print "<hr><b>reverse simple dec2xy</b> -50, 60<br>";
$coord=$sqrc->dec2xy("-50","60");
$coord=$sqrc->xy2dec($coord["x"],$coord["y"]);
print_r($coord);
print "<br>";

print "<hr><b>reverse multiple</b> -73°43'28'',45°35'12'' => 287286.542052, 5049664.53876<br>";
$coord=$sqrc->deg2xy("-73°43'28''","45°35'12''");
for($i=0;$i<20;$i++) {
	$coord=$sqrc->xy2dec($coord["x"],$coord["y"]);
	$coord=$sqrc->dec2xy($coord["long"],$coord["lat"]);
}
$coord=$sqrc->xy2dec($coord["x"],$coord["y"]);
print_r($coord);
print "<br>";
$long=$sqrc->dec2deg($coord["long"]);
$lat=$sqrc->dec2deg($coord["lat"]);
print "valeurs finales: long: $long, lat: $lat<br>";


print "<hr><b>reverse multiple</b> -50,60 =><br>";
$coord=$sqrc->deg2xy("-50","60");
for($i=0;$i<20;$i++) {
	$coord=$sqrc->xy2dec($coord["x"],$coord["y"]);
	$coord=$sqrc->dec2xy($coord["long"],$coord["lat"]);
}
$coord=$sqrc->xy2dec($coord["x"],$coord["y"]);
print_r($coord);
print "<br>";
$long=$sqrc->dec2deg($coord["long"]);
$lat=$sqrc->dec2deg($coord["lat"]);
print "valeurs finales: long: $long, lat: $lat<br>";


print "<hr><b>dec2xy xy2dec</b><br>";
$coord=$sqrc->dec2xy("-50","60");
print_r($coord);
print "<br>";
$coord=$sqrc->xy2dec($coord["x"],$coord["y"]);
print_r($coord);
print "<br>";

print "<hr><b>arrays</b><br>";
print "<b>output direct:</b> ";
//$aOutput=array(array(50,60),array(51,61));
print_r($aOutput);
print "<br>";
print "<b>arrDec2xy:</b> ";
$arr=$sqrc->arrDec2xy($aOutput,"W","N");
print_r($arr);
print "<br>";

print "<b>arrXy2dec:</b> ";
$arr=$sqrc->arrXy2dec($arr,"W","N");
print_r($arr);
print "<br>";
?>
