<?php

class TableRenderer_dualframes_horizontal extends TableRenderer 
{
        /**
        *Displays a column for each recordset
        *Used when the "layout" attribute is set to "horizontal"
        *
        *@return string
        *@author Reto Zahner 
        *@param array $aRows
        *@param string $sTableTitle
        *@param array $aHeaderMap
        */
        function render($aRows, $sTableTitle, $aHeaderMap, $szLayerName, $bSingleResult)
        {
            $nCol = count($aRows) + 1;

            $sTableHTML = null;
            
            // build title rows
            $sTableHTML .= '<table class="layoutTable" width="100%" border="0" cellspacing="1" cellpadding="2">';

            $sTableHTML .= '<tr>';
            $sTableHTML .= '<td colspan='.$nCol.' class="titleArea">';
            $sTableHTML .= '<span class="text"><b>'.$sTableTitle.'</b></span>';

            $sTableHTML .= '</td>';
            $sTableHTML .= '</tr>';
        
            // Change all keys to lowercase
            array_walk($aRows, array(&$this, '_array_change_key_case')); 
            
            // loop and add a cell for each result
            $iField=0;
            foreach ( $aHeaderMap as $key => $value ) 
            {
                    $sTableHTML .= '<tr>';
                    
                    // Add a header for each row
                    $sTableHTML .= '<td class="subContentArea2"><span class="text">'.$value.'</span></td>';
                    

                    // loop through the results and format each row
                    foreach ( $aRows as $aRow )
                    {
                        if ($iField == 0)
                        {
                            $sTableHTML .= '<td class="subContentArea1"><span class="text">';
                            $sTableHTML .= '<a href="javascript:ShowShapeDetail(&#34;'.$szLayerName.'&#34;,&#34;'.$aRow["shape_index"].'&#34;,&#34;'.$aRow[strtolower($key)].'&#34;,&#34;'.$aRow["tile_index"].'&#34;,true)">'.$aRow[strtolower($key)].'</a></span></td>';


                            if( (count($aRows) == 1) && $bSingleResult)
                            {
                                $sJSHTML = '<script language="javascript">';
                                $sJSHTML .= "ShowShapeDetail('".$szLayerName."','".$aRow["shape_index"]."','".$aRow[strtolower($key)]."','".$aRow["tile_index"]."',false)";
                                $sJSHTML .= '</script>';

                            }

                        }
                        else
                        {
                            // Changed by Abe Gillespie on 08/09/05.
                            // Added the formatValue() call.
                            $sTableHTML .= '<td class="subContentArea1"><span class="text">'.formatValue($aRow[strtolower($key)]).'</span></td>';
                        }


                    }        
                        $sTableHTML .= '</tr>';
                    $iField++;

            }
        
            // close the table
            $sTableHTML .= '</table>';
                


            if( (count($aRows) == 1) && $bSingleResult)
            {
                return $sTableHTML.$sJSHTML;
            }
            else
            {
                return $sTableHTML;

            }            
                
        } // End of method: render
}


?>

