<?php
/**
  _____________________________________________________________________________
 |
 | WFSSearch.php
 |
 | @project     Chameleon
 | @purpose     GUI for the search widget - supporting php code
 | @revision    $Id: WFSSearch.php,v 1.4 2005/12/02 14:33:50 wbronsema Exp $
 | @author      Bart van den Eijnden, bartvde@xs4all.nl
 | @updated     November 24, 2005 - William Bronsema (wbronsema@dmsolutions.ca)
 | @copyright
 | <b>Copyright (c) 2002-2005 DM Solutions Group Inc.</b>
 | Permission is hereby granted, free of charge, to any person obtaining a
 | copy of this software and associated documentation files (the "Software"),
 | to deal in the Software without restriction, including without limitation
 | the rights to use, copy, modify, merge, publish, distribute, sublicense,
 | and/or sell copies of the Software, and to permit persons to whom the
 | Software is furnished to do so, subject to the following conditions:
 |
 | The above copyright notice and this permission notice shall be included
 | in all copies or substantial portions of the Software.
 |
 | THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 | IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 | FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 | THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 | LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 | FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 | DEALINGS IN THE SOFTWARE.
 |_____________________________________________________________________________

 **/

//set the language resource file
$szLanguageResource = str_replace("\\","/",dirname(__FILE__))."/WFSSearch.dbf";

// include the supporting php functions
include_once("../session.inc.php");
include_once("../CWC2ButtonCache.php");

//echo '<pre>';
//print_r($_SESSION);
//echo '</pre>';

// init vars
$szSearchOptionList = '';
$szSelectedSearchOption = '';
$szSearchOptionDivlist = '';
$szSearchPickListRequests = '';
$aszSearchButtonParams = array();

/**
  _____________________________________________________________________________
 |
 |  Process search options from the session
 |_____________________________________________________________________________

 **/
if( isset( $_SESSION['wfs_search_widget_options'] ) &&
    is_array( $_SESSION['wfs_search_widget_options'] ) )
{
    // loop through and process each search option
    foreach ( $_SESSION['wfs_search_widget_options'] as $szSearchOption )
    {
        // check if is default
        if ( $szSelectedSearchOption == '' &&
             strtolower( $szSearchOption['DEFAULT'] ) == 'true' )
        {
            $szSelectedSearchOption = md5( $szSearchOption['TITLE'] );
        }

        /**
          _____________________________________________________________________
         |
         |   Create search options
         |_____________________________________________________________________
         **/
        $szSearchOptionList .= '<option value="'.md5( $szSearchOption['TITLE'] ).
            '">'.$szSearchOption['TITLE'].'</option>';


        /**
          _____________________________________________________________________
         |
         |   Create div
         |_____________________________________________________________________
         **/

        // get ID
        $szDivId = 'div_'.md5( $szSearchOption['TITLE'] );

        // get the help text
        $szHelpText = isset( $szSearchOption['INSTRUCTIONTEXT'] )?
                                        $szSearchOption['INSTRUCTIONTEXT']:'';

        // dump the online resource into the session by id
        $_SESSION[ 'online_res_'.md5( $szSearchOption['TITLE'] )] =
                                            $szSearchOption['ONLINERESOURCE'];
        $_SESSION[ 'typename_'.md5( $szSearchOption['TITLE'] )] =
                                            $szSearchOption['TYPENAME'];
        $_SESSION[ 'namespace_'.md5( $szSearchOption['TITLE'] )] =
                                            $szSearchOption['NAMESPACE_PREFIX'];

        // loop and add search fields
        $aszSearchButtonParams = array();
        $szSearchFields = '';
        if ( isset( $szSearchOption['CHILDREN'] ) &&
             is_array( $szSearchOption['CHILDREN'] ) )
        {
            // loop to find the searchfield child
            foreach( $szSearchOption['CHILDREN'] as $szSearchOptionChild )
            {
                // check to see if is searchfield
                if( isset( $szSearchOptionChild['SEARCHFIELD'] ) )
                {
                    // loop and process all search fields
                    foreach( $szSearchOptionChild['SEARCHFIELD'] as
                                                              $aszSearchField )
                    {
                        // determine properties of search field
                        $szMinChars = isset( $aszSearchField['MINCHARS'] ) &&
                            $aszSearchField['MINCHARS']!= '' &&
                            is_numeric( $aszSearchField['MINCHARS'] )?
                            $aszSearchField['MINCHARS']:0;
                        $szRequired = isset( $aszSearchField['REQUIRED'] ) &&
                            strtolower( $aszSearchField['REQUIRED'] ) == 'true'?
                            1:0;

                        // start string
                        $szSearchFields .= '<tr><td><span class="label">'.
                            $aszSearchField['LABEL'].':</span></td><td valign="middle" nowrap>';

                        // add an astrisk if field is required
                        $szAsterisk = $szRequired == 1?
                            '<span class="label" style="color:#F00;font-size:12px;" > *</span>':'';

                        // process types accordingly
                        switch ( strtolower( $aszSearchField['TYPE'] ) )
                        {
                            case 'propertyislike':
                                $szSearchFields .= '<input type="text" name="'.
                                    md5( $szSearchOption['TITLE'] ).'_'.
                                    $aszSearchField['PROPERTYNAME'].'" id="'.
                                    md5( $szSearchOption['TITLE'] ).'_'.
                                    $aszSearchField['PROPERTYNAME'].
                                    '" onKeyPress="KeyPressed(arguments[0],\'search_string_'.
                                    md5( $szSearchOption['TITLE'] ).'\')">'.
                                    $szAsterisk.'</td></tr>';
                                break;
                            case 'propertyisequalto':
                                // build drop down list
                                $szSearchFields .= '<select name="'.
                                    md5( $szSearchOption['TITLE'] ).'_'.
                                    $aszSearchField['PROPERTYNAME'].'" id="'.
                                    md5( $szSearchOption['TITLE'] ).'_'.
                                    $aszSearchField['PROPERTYNAME'].'"></select>'.$szAsterisk.
                                    '<span id="'.$szDivId.'_'.
                                    $aszSearchField['PROPERTYNAME'].'_processing" class="label" style="font-size:10px;color: #F00;">&nbsp;&nbsp;<img src="'.$_SESSION['gszCoreWebPath'].'/common/ajax/mini_spinner.gif" width="10" height="10">&nbsp;'.$oMLT->get( '14', 'building list...' ).'</span></td></tr>';

                                // check for normalize flag
                                $nNormalize = isset( $aszSearchField['NORMALIZE'] ) &&
                                    strtolower( $aszSearchField['NORMALIZE'] ) == 'true'?
                                    1:0;

                                // create AJAX request to populate the list
                                $szSearchPickListRequests .= 'call("searchoptionapi.php?'.
                                    'request=getlist&required='.$szRequired.'&id='.
                                    md5( $szSearchOption['TITLE'] ).'&propertyname='.
                                    $aszSearchField['PROPERTYNAME'].'&sid='.session_id().
                                    '&normalize='.$nNormalize.'",null, buildList);';

                        }

                        // add to button properties array
                        array_push( $aszSearchButtonParams,
                            $aszSearchField['PROPERTYNAME'].'|'.
                            $szMinChars.'|'.$szRequired.'|'.
                            rawurlencode($aszSearchField['LABEL']).
                            '|'.strtolower( $aszSearchField['TYPE'] ) );
                    }
                }
            }
        }

        // build the name and value for the hidden search string
        $szSearchButtonParams = count( $aszSearchButtonParams )>0?
            implode( ';', $aszSearchButtonParams ):'';
        $szSearchStringId = 'search_string_'.md5( $szSearchOption['TITLE'] );
        $szSearchString = md5( $szSearchOption['TITLE'] ).';'.$szSearchButtonParams;

        // make search button
        $szSearchButton = makeButton( 'search',
            $szSearchString,
            'WFSSearch',
            "icons/icon_locate.png", $oMLT->get("5", ""),
            $oMLT->get("6", ""), array( "width" => 75 ) );

        // assemble div
        $szSearchOptionDivlist .= <<<EOT
<div id="{$szDivId}" style="visibility:hidden;position:absolute;overflow:auto;width:90%;height:195px;margin:5px;">
  <table border="0" cellpadding="3" cellspacing="0" width="97%">
    <tr>
      <td align="center" colspan="2"><p class="helpArea" style="padding: 2px; width:100%;">{$szHelpText}</p></td>
    </tr>
    {$szSearchFields}
    <tr>
      <td align="center" colspan="2">&nbsp;</td>
    </tr>
    <tr>
      <td align="center" colspan="2">{$szSearchButton}<input type="hidden" id="{$szSearchStringId}" value="{$szSearchString}"></td>
    </tr>
  </table>
</div>
EOT;

    }
}

?>