<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ca2="http://localhost/chameleon/utils/xml/schemas" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:ca="http://localhost/chameleon/utils/xml/schemas" exclude-result-prefixes="ca2 xs">
	<xsl:output method="xml" encoding="UTF-8" indent="yes"/>
	<xsl:param name="widgetsampleInstance" select="document('arg:/xml2')"/>
	<xsl:param name="syntax1" select="' =&quot;['"/>
	<xsl:param name="syntax2" select="']&quot;'"/>
	<xsl:param name="frontspace" select="'   '"/>
	<xsl:template match="/ca2:widgetdoc">
		<ca:widgetdoc>
			<xsl:attribute name="xmlns:ca">http://localhost/chameleon/utils/xml/schemas</xsl:attribute> 		
			<xsl:attribute name="xsi:schemaLocation">http://localhost/chameleon/utils/xml/schemas ..\..\..\utils\xml\schemas\chameleon.xsd</xsl:attribute>
			<xsl:variable name="widgetdoc" select="."/>
			<xsl:for-each select="ca2:docinfo">
				<ca:docinfo>
					<xsl:for-each select="@title">
						<xsl:attribute name="title">
							<xsl:value-of select="."/>
						</xsl:attribute>
					</xsl:for-each>
					<xsl:for-each select="ca2:language">
						<ca:language>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="$widgetsampleInstance/ca2:widget">
								<xsl:for-each select="ca2:docinfo">
									<xsl:for-each select="ca2:language">
										<ca:value>
											<xsl:value-of select="."/>
										</ca:value>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
						</ca:language>
					</xsl:for-each>
					<xsl:for-each select="ca2:docbuilddate">
						<ca:docbuilddate>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="$widgetsampleInstance/ca2:widget">
								<xsl:for-each select="ca2:docinfo">
									<xsl:for-each select="ca2:docbuilddate">
										<ca:value>
											<xsl:value-of select="."/>
										</ca:value>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
						</ca:docbuilddate>
					</xsl:for-each>
					<xsl:for-each select="ca2:docversion">
						<ca:docversion>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:value">
								<ca:value>
									<xsl:value-of select="."/>
								</ca:value>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
						</ca:docversion>
					</xsl:for-each>
					<xsl:for-each select="ca2:authors">
						<ca:authors>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:person">
								<ca:person>
									<xsl:for-each select="ca2:name">
										<ca:name>
											<xsl:value-of select="."/>
										</ca:name>
									</xsl:for-each>
									<xsl:for-each select="ca2:company">
										<ca:company>
											<xsl:value-of select="."/>
										</ca:company>
									</xsl:for-each>
									<xsl:for-each select="ca2:contact">
										<ca:contact>
											<xsl:value-of select="."/>
										</ca:contact>
									</xsl:for-each>
									<xsl:for-each select="ca2:comment">
										<ca:comment>
											<xsl:value-of select="."/>
										</ca:comment>
									</xsl:for-each>
								</ca:person>
							</xsl:for-each>
						</ca:authors>
					</xsl:for-each>
					<xsl:for-each select="ca2:editors">
						<ca:editors>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:person">
								<ca:person>
									<xsl:for-each select="ca2:name">
										<ca:name>
											<xsl:value-of select="."/>
										</ca:name>
									</xsl:for-each>
									<xsl:for-each select="ca2:company">
										<ca:company>
											<xsl:value-of select="."/>
										</ca:company>
									</xsl:for-each>
									<xsl:for-each select="ca2:contact">
										<ca:contact>
											<xsl:value-of select="."/>
										</ca:contact>
									</xsl:for-each>
									<xsl:for-each select="ca2:comment">
										<ca:comment>
											<xsl:value-of select="."/>
										</ca:comment>
									</xsl:for-each>
								</ca:person>
							</xsl:for-each>
						</ca:editors>
					</xsl:for-each>
				</ca:docinfo>
			</xsl:for-each>
			<xsl:for-each select="ca2:identification">
				<ca:identification>
					<xsl:for-each select="@title">
						<xsl:attribute name="title">
							<xsl:value-of select="."/>
						</xsl:attribute>
					</xsl:for-each>
					<xsl:for-each select="ca2:name">
						<ca:name>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="$widgetsampleInstance/ca2:widget">
								<xsl:for-each select="ca2:identification">
									<xsl:for-each select="ca2:name">
										<ca:value>
											<xsl:value-of select="."/>
										</ca:value>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
						</ca:name>
					</xsl:for-each>
					<xsl:for-each select="ca2:chameleonpack">
						<ca:chameleonpack>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:value">
								<ca:value>
									<xsl:value-of select="."/>
								</ca:value>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
						</ca:chameleonpack>
					</xsl:for-each>
					<xsl:for-each select="ca2:parentgroup">
						<ca:parentgroup>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:value">
								<ca:value>
									<xsl:value-of select="."/>
								</ca:value>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
						</ca:parentgroup>
					</xsl:for-each>
					<xsl:for-each select="ca2:version">
						<ca:version>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:value">
								<ca:value>
									<xsl:value-of select="."/>
								</ca:value>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
						</ca:version>
					</xsl:for-each>
					<xsl:for-each select="ca2:releasedate">
						<ca:releasedate>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:value">
								<ca:value>
									<xsl:value-of select="."/>
								</ca:value>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
						</ca:releasedate>
					</xsl:for-each>
					<xsl:for-each select="ca2:maturitylevel">
						<ca:maturitylevel>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="$widgetsampleInstance/ca2:widget">
								<xsl:for-each select="ca2:identification">
									<xsl:for-each select="ca2:maturitylevel">
										<ca:value>
											<xsl:value-of select="."/>
										</ca:value>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
						</ca:maturitylevel>
					</xsl:for-each>
					<xsl:for-each select="ca2:developers">
						<ca:developers>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:intro">
								<ca:intro>
									<xsl:value-of select="."/>
								</ca:intro>
							</xsl:for-each>
							<xsl:for-each select="ca2:person">
								<ca:person>
									<xsl:for-each select="ca2:name">
										<ca:name>
											<xsl:value-of select="."/>
										</ca:name>
									</xsl:for-each>
									<xsl:for-each select="ca2:company">
										<ca:company>
											<xsl:value-of select="."/>
										</ca:company>
									</xsl:for-each>
									<xsl:for-each select="ca2:contact">
										<ca:contact>
											<xsl:value-of select="."/>
										</ca:contact>
									</xsl:for-each>
									<xsl:for-each select="ca2:comment">
										<ca:comment>
											<xsl:value-of select="."/>
										</ca:comment>
									</xsl:for-each>
								</ca:person>
							</xsl:for-each>
						</ca:developers>
					</xsl:for-each>
				</ca:identification>
			</xsl:for-each>
			<xsl:for-each select="ca2:descriptions">
				<ca:descriptions>
					<xsl:for-each select="@title">
						<xsl:attribute name="title">
							<xsl:value-of select="."/>
						</xsl:attribute>
					</xsl:for-each>
					<xsl:for-each select="ca2:description">
						<ca:description>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:paras">
								<ca:paras>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="$widgetsampleInstance/ca2:widget">
										<xsl:for-each select="ca2:identification">
											<xsl:for-each select="ca2:description">
												<ca:para>
													<xsl:value-of select="."/>
												</ca:para>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</ca:paras>
							</xsl:for-each>
						</ca:description>
					</xsl:for-each>
					<xsl:for-each select="ca2:techrequirements">
						<ca:techrequirements>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:paras">
								<ca:paras>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:para">
										<ca:para>
											<xsl:value-of select="."/>
										</ca:para>
									</xsl:for-each>
								</ca:paras>
							</xsl:for-each>
						</ca:techrequirements>
					</xsl:for-each>
					<xsl:for-each select="ca2:dependancies">
						<ca:dependancies>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:dependancy">
								<ca:dependancy>
									<xsl:for-each select="@type">
										<xsl:attribute name="type">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:para">
										<ca:para>
											<xsl:value-of select="."/>
										</ca:para>
									</xsl:for-each>
								</ca:dependancy>
							</xsl:for-each>
						</ca:dependancies>
					</xsl:for-each>
					<xsl:for-each select="ca2:sharedresources">
						<ca:sharedresources>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:paras">
								<ca:paras>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:para">
										<ca:para>
											<xsl:value-of select="."/>
										</ca:para>
									</xsl:for-each>
								</ca:paras>
							</xsl:for-each>
						</ca:sharedresources>
					</xsl:for-each>
					<xsl:for-each select="ca2:embeddedhelp">
						<ca:embeddedhelp>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:paras">
								<ca:paras>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:para">
										<ca:para>
											<xsl:value-of select="."/>
										</ca:para>
									</xsl:for-each>
								</ca:paras>
							</xsl:for-each>
						</ca:embeddedhelp>
					</xsl:for-each>
					<xsl:for-each select="ca2:guinotes">
						<ca:guinotes>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:guinote">
								<ca:guinote>
									<xsl:for-each select="@type">
										<xsl:attribute name="type">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:para">
										<ca:para>
											<xsl:value-of select="."/>
										</ca:para>
									</xsl:for-each>
								</ca:guinote>
							</xsl:for-each>
						</ca:guinotes>
					</xsl:for-each>
					<xsl:for-each select="ca2:qanotes">
						<ca:qanotes>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:paras">
								<ca:paras>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:para">
										<ca:para>
											<xsl:value-of select="."/>
										</ca:para>
									</xsl:for-each>
								</ca:paras>
							</xsl:for-each>
						</ca:qanotes>
					</xsl:for-each>
				</ca:descriptions>
			</xsl:for-each>
			<xsl:for-each select="ca2:tagstructures">
				<ca:tagstructures>
					<xsl:for-each select="@title">
						<xsl:attribute name="title">
							<xsl:value-of select="."/>
						</xsl:attribute>
					</xsl:for-each>
					<xsl:for-each select="ca2:tagstructure">
						<ca:tagstructure>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
							<xsl:for-each select="ca2:code">
								<ca:code>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:description">
										<ca:description>
											<xsl:value-of select="."/>
										</ca:description>
									</xsl:for-each>
									<ca:codeblock>
										<xsl:for-each select="ca2:codeblock">
											<xsl:for-each select="@bold">
												<xsl:attribute name="bold">
													<xsl:value-of select="."/>
												</xsl:attribute>
											</xsl:for-each>
										</xsl:for-each>
										<xsl:for-each select="$widgetsampleInstance/ca2:widget">
											<xsl:for-each select="ca2:attributes">
												<xsl:for-each select="ca2:attribute">
													<xsl:variable name="attribute" select="."/>
													<xsl:for-each select="ca2:type">
														<xsl:variable name="type" select="."/>
														<xsl:for-each select="$attribute/ca2:name">
															<xsl:variable name="name" select="."/>
															<ca:line>
																<xsl:variable name="concatResult" select="concat($frontspace, $name)"/>
																<xsl:variable name="concatResult1" select="concat($concatResult, $syntax1)"/>
																<xsl:variable name="concatResult2" select="concat($concatResult1, $type)"/>
																<xsl:variable name="concatResult3" select="concat($concatResult2, $syntax2)"/>
																<xsl:value-of select="$concatResult3"/>
															</ca:line>
														</xsl:for-each>
													</xsl:for-each>
												</xsl:for-each>
											</xsl:for-each>
										</xsl:for-each>
									</ca:codeblock>
								</ca:code>
							</xsl:for-each>
						</ca:tagstructure>
					</xsl:for-each>
				</ca:tagstructures>
			</xsl:for-each>
			<xsl:for-each select="ca2:examples">
				<ca:examples>
					<xsl:for-each select="@title">
						<xsl:attribute name="title">
							<xsl:value-of select="."/>
						</xsl:attribute>
					</xsl:for-each>
					<xsl:for-each select="ca2:description">
						<ca:description>
							<xsl:value-of select="."/>
						</ca:description>
					</xsl:for-each>
					<xsl:for-each select="ca2:widgetexamples">
						<ca:widgetexamples>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:example">
								<ca:example>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:description">
										<ca:description>
											<xsl:value-of select="."/>
										</ca:description>
									</xsl:for-each>
									<xsl:for-each select="ca2:code">
										<ca:code>
											<xsl:for-each select="@title">
												<xsl:attribute name="title">
													<xsl:value-of select="."/>
												</xsl:attribute>
											</xsl:for-each>
											<xsl:for-each select="ca2:description">
												<ca:description>
													<xsl:value-of select="."/>
												</ca:description>
											</xsl:for-each>
											<xsl:for-each select="ca2:codeblock">
												<ca:codeblock>
													<xsl:for-each select="@bold">
														<xsl:attribute name="bold">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:line">
														<ca:line>
															<xsl:value-of select="."/>
														</ca:line>
													</xsl:for-each>
												</ca:codeblock>
											</xsl:for-each>
										</ca:code>
									</xsl:for-each>
								</ca:example>
							</xsl:for-each>
						</ca:widgetexamples>
					</xsl:for-each>
					<xsl:for-each select="ca2:sharedresourceexamples">
						<ca:sharedresourceexamples>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:example">
								<ca:example>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:description">
										<ca:description>
											<xsl:value-of select="."/>
										</ca:description>
									</xsl:for-each>
									<xsl:for-each select="ca2:code">
										<ca:code>
											<xsl:for-each select="@title">
												<xsl:attribute name="title">
													<xsl:value-of select="."/>
												</xsl:attribute>
											</xsl:for-each>
											<xsl:for-each select="ca2:description">
												<ca:description>
													<xsl:value-of select="."/>
												</ca:description>
											</xsl:for-each>
											<xsl:for-each select="ca2:codeblock">
												<ca:codeblock>
													<xsl:for-each select="@bold">
														<xsl:attribute name="bold">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:line">
														<ca:line>
															<xsl:value-of select="."/>
														</ca:line>
													</xsl:for-each>
												</ca:codeblock>
											</xsl:for-each>
										</ca:code>
									</xsl:for-each>
								</ca:example>
							</xsl:for-each>
						</ca:sharedresourceexamples>
					</xsl:for-each>
					<xsl:for-each select="ca2:sampleapps">
						<ca:sampleapps>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:sampleapp">
								<ca:sampleapp>
									<xsl:for-each select="ca2:name">
										<ca:name>
											<xsl:value-of select="."/>
										</ca:name>
									</xsl:for-each>
									<xsl:for-each select="ca2:appurl">
										<ca:appurl>
											<xsl:value-of select="."/>
										</ca:appurl>
									</xsl:for-each>
									<xsl:for-each select="ca2:description">
										<ca:description>
											<xsl:value-of select="."/>
										</ca:description>
									</xsl:for-each>
								</ca:sampleapp>
							</xsl:for-each>
						</ca:sampleapps>
					</xsl:for-each>
					<xsl:for-each select="ca2:scriptexamples">
						<ca:scriptexamples>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:example">
								<ca:example>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:description">
										<ca:description>
											<xsl:value-of select="."/>
										</ca:description>
									</xsl:for-each>
									<xsl:for-each select="ca2:code">
										<ca:code>
											<xsl:for-each select="@title">
												<xsl:attribute name="title">
													<xsl:value-of select="."/>
												</xsl:attribute>
											</xsl:for-each>
											<xsl:for-each select="ca2:description">
												<ca:description>
													<xsl:value-of select="."/>
												</ca:description>
											</xsl:for-each>
											<xsl:for-each select="ca2:codeblock">
												<ca:codeblock>
													<xsl:for-each select="@bold">
														<xsl:attribute name="bold">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:line">
														<ca:line>
															<xsl:value-of select="."/>
														</ca:line>
													</xsl:for-each>
												</ca:codeblock>
											</xsl:for-each>
										</ca:code>
									</xsl:for-each>
								</ca:example>
							</xsl:for-each>
						</ca:scriptexamples>
					</xsl:for-each>
				</ca:examples>
			</xsl:for-each>
			<xsl:for-each select="ca2:attributegroups">
				<ca:attributegroups>
					<xsl:for-each select="@title">
						<xsl:attribute name="title">
							<xsl:value-of select="."/>
						</xsl:attribute>
					</xsl:for-each>
					<xsl:for-each select="ca2:description">
						<ca:description>
							<xsl:value-of select="."/>
						</ca:description>
					</xsl:for-each>
					<xsl:for-each select="$widgetsampleInstance/ca2:widget">
						<xsl:for-each select="ca2:attributegroups">
							<ca:attributegroup>
								<xsl:for-each select="ca2:attributegroup">
									<ca:name>
										<xsl:value-of select="."/>
									</ca:name>
								</xsl:for-each>
							</ca:attributegroup>
						</xsl:for-each>
					</xsl:for-each>
				</ca:attributegroups>
			</xsl:for-each>
			<xsl:for-each select="$widgetsampleInstance/ca2:widget">
				<xsl:for-each select="ca2:attributes">
					<ca:widgettag>
						<xsl:for-each select="$widgetdoc/ca2:widgettag">
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
						</xsl:for-each>
						<xsl:for-each select="$widgetdoc/ca2:widgettag">
							<xsl:for-each select="ca2:name">
								<ca:name>
									<xsl:value-of select="."/>
								</ca:name>
							</xsl:for-each>
						</xsl:for-each>
						<xsl:for-each select="$widgetdoc/ca2:widgettag">
							<xsl:for-each select="ca2:type">
								<ca:type>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:value">
										<ca:value>
											<xsl:value-of select="."/>
										</ca:value>
									</xsl:for-each>
									<xsl:for-each select="ca2:description">
										<ca:description>
											<xsl:value-of select="."/>
										</ca:description>
									</xsl:for-each>
								</ca:type>
							</xsl:for-each>
						</xsl:for-each>
						<xsl:for-each select="$widgetdoc/ca2:widgettag">
							<xsl:for-each select="ca2:required">
								<ca:required>
									<xsl:value-of select="."/>
								</ca:required>
							</xsl:for-each>
						</xsl:for-each>
						<xsl:for-each select="$widgetdoc/ca2:widgettag">
							<xsl:for-each select="ca2:class">
								<ca:class>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:value">
										<ca:value>
											<xsl:value-of select="."/>
										</ca:value>
									</xsl:for-each>
									<xsl:for-each select="ca2:description">
										<ca:description>
											<xsl:value-of select="."/>
										</ca:description>
									</xsl:for-each>
								</ca:class>
							</xsl:for-each>
						</xsl:for-each>
						<xsl:for-each select="$widgetdoc/ca2:widgettag">
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
						</xsl:for-each>
						<xsl:for-each select="ca2:attribute">
							<xsl:variable name="attribute1" select="."/>
							<ca:attribute>
								<xsl:for-each select="ca2:name">
									<ca:name>
										<xsl:value-of select="."/>
									</ca:name>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:widgettag">
									<xsl:for-each select="ca2:attribute">
										<xsl:for-each select="ca2:type">
											<ca:type>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="$attribute1/ca2:type">
													<ca:value>
														<xsl:value-of select="."/>
													</ca:value>
												</xsl:for-each>
												<xsl:for-each select="ca2:description">
													<ca:description>
														<xsl:value-of select="."/>
													</ca:description>
												</xsl:for-each>
											</ca:type>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:widgettag">
									<xsl:for-each select="ca2:attribute">
										<xsl:for-each select="ca2:class">
											<ca:class>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="$attribute1/ca2:class">
													<ca:value>
														<xsl:value-of select="."/>
													</ca:value>
												</xsl:for-each>
												<xsl:for-each select="ca2:description">
													<ca:description>
														<xsl:value-of select="."/>
													</ca:description>
												</xsl:for-each>
											</ca:class>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:widgettag">
									<xsl:for-each select="ca2:attribute">
										<xsl:for-each select="ca2:default">
											<ca:default>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="$attribute1/ca2:default">
													<ca:value>
														<xsl:value-of select="."/>
													</ca:value>
												</xsl:for-each>
												<xsl:for-each select="ca2:description">
													<ca:description>
														<xsl:value-of select="."/>
													</ca:description>
												</xsl:for-each>
											</ca:default>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="ca2:possvalues">
									<ca:possvalues>
										<xsl:for-each select="@type">
											<xsl:attribute name="type">
												<xsl:value-of select="."/>
											</xsl:attribute>
										</xsl:for-each>
										<xsl:for-each select="$widgetdoc/ca2:widgettag">
											<xsl:for-each select="ca2:attribute">
												<xsl:for-each select="ca2:possvalues">
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
												</xsl:for-each>
											</xsl:for-each>
										</xsl:for-each>
										<xsl:for-each select="ca2:minimum">
											<ca:minimum>
												<xsl:value-of select="."/>
											</ca:minimum>
										</xsl:for-each>
										<xsl:for-each select="ca2:maximum">
											<ca:maximum>
												<xsl:value-of select="."/>
											</ca:maximum>
										</xsl:for-each>
										<xsl:for-each select="ca2:value">
											<ca:value>
												<xsl:value-of select="."/>
											</ca:value>
										</xsl:for-each>
									</ca:possvalues>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:widgettag">
									<xsl:for-each select="ca2:attribute">
										<xsl:for-each select="ca2:description">
											<ca:description>
												<xsl:value-of select="."/>
											</ca:description>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</ca:attribute>
						</xsl:for-each>
						<xsl:for-each select="$widgetdoc/ca2:widgettag">
							<xsl:for-each select="ca2:subtag">
								<ca:subtag>
									<xsl:for-each select="ca2:name">
										<ca:name>
											<xsl:value-of select="."/>
										</ca:name>
									</xsl:for-each>
									<xsl:for-each select="ca2:type">
										<ca:type>
											<xsl:for-each select="@title">
												<xsl:attribute name="title">
													<xsl:value-of select="."/>
												</xsl:attribute>
											</xsl:for-each>
											<xsl:for-each select="ca2:value">
												<ca:value>
													<xsl:value-of select="."/>
												</ca:value>
											</xsl:for-each>
											<xsl:for-each select="ca2:description">
												<ca:description>
													<xsl:value-of select="."/>
												</ca:description>
											</xsl:for-each>
										</ca:type>
									</xsl:for-each>
									<xsl:for-each select="ca2:class">
										<ca:class>
											<xsl:for-each select="@title">
												<xsl:attribute name="title">
													<xsl:value-of select="."/>
												</xsl:attribute>
											</xsl:for-each>
											<xsl:for-each select="ca2:value">
												<ca:value>
													<xsl:value-of select="."/>
												</ca:value>
											</xsl:for-each>
											<xsl:for-each select="ca2:description">
												<ca:description>
													<xsl:value-of select="."/>
												</ca:description>
											</xsl:for-each>
										</ca:class>
									</xsl:for-each>
									<xsl:for-each select="ca2:description">
										<ca:description>
											<xsl:value-of select="."/>
										</ca:description>
									</xsl:for-each>
									<xsl:for-each select="ca2:attribute">
										<ca:attribute>
											<xsl:for-each select="ca2:name">
												<ca:name>
													<xsl:value-of select="."/>
												</ca:name>
											</xsl:for-each>
											<xsl:for-each select="ca2:type">
												<ca:type>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
													<xsl:for-each select="ca2:description">
														<ca:description>
															<xsl:value-of select="."/>
														</ca:description>
													</xsl:for-each>
												</ca:type>
											</xsl:for-each>
											<xsl:for-each select="ca2:class">
												<ca:class>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
													<xsl:for-each select="ca2:description">
														<ca:description>
															<xsl:value-of select="."/>
														</ca:description>
													</xsl:for-each>
												</ca:class>
											</xsl:for-each>
											<xsl:for-each select="ca2:default">
												<ca:default>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
													<xsl:for-each select="ca2:description">
														<ca:description>
															<xsl:value-of select="."/>
														</ca:description>
													</xsl:for-each>
												</ca:default>
											</xsl:for-each>
											<xsl:for-each select="ca2:possvalues">
												<ca:possvalues>
													<xsl:for-each select="@type">
														<xsl:attribute name="type">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:minimum">
														<ca:minimum>
															<xsl:value-of select="."/>
														</ca:minimum>
													</xsl:for-each>
													<xsl:for-each select="ca2:maximum">
														<ca:maximum>
															<xsl:value-of select="."/>
														</ca:maximum>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
												</ca:possvalues>
											</xsl:for-each>
											<xsl:for-each select="ca2:description">
												<ca:description>
													<xsl:value-of select="."/>
												</ca:description>
											</xsl:for-each>
										</ca:attribute>
									</xsl:for-each>
								</ca:subtag>
							</xsl:for-each>
						</xsl:for-each>
					</ca:widgettag>
				</xsl:for-each>
				<xsl:for-each select="ca2:formelements">
					<ca:formelements>
						<xsl:for-each select="$widgetdoc/ca2:formelements">
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
						</xsl:for-each>
						<xsl:for-each select="ca2:formelement">
							<ca:formelement>
								<xsl:for-each select="ca2:name">
									<ca:name>
										<xsl:value-of select="."/>
									</ca:name>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:formelements">
									<xsl:for-each select="ca2:formelement">
										<xsl:for-each select="ca2:type">
											<ca:type>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="ca2:value">
													<ca:value>
														<xsl:value-of select="."/>
													</ca:value>
												</xsl:for-each>
												<xsl:for-each select="ca2:description">
													<ca:description>
														<xsl:value-of select="."/>
													</ca:description>
												</xsl:for-each>
											</ca:type>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:formelements">
									<xsl:for-each select="ca2:formelement">
										<xsl:for-each select="ca2:default">
											<ca:default>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="ca2:value">
													<ca:value>
														<xsl:value-of select="."/>
													</ca:value>
												</xsl:for-each>
												<xsl:for-each select="ca2:description">
													<ca:description>
														<xsl:value-of select="."/>
													</ca:description>
												</xsl:for-each>
											</ca:default>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:formelements">
									<xsl:for-each select="ca2:formelement">
										<xsl:for-each select="ca2:possvalues">
											<ca:possvalues>
												<xsl:for-each select="@type">
													<xsl:attribute name="type">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="ca2:minimum">
													<ca:minimum>
														<xsl:value-of select="."/>
													</ca:minimum>
												</xsl:for-each>
												<xsl:for-each select="ca2:maximum">
													<ca:maximum>
														<xsl:value-of select="."/>
													</ca:maximum>
												</xsl:for-each>
												<xsl:for-each select="ca2:value">
													<ca:value>
														<xsl:value-of select="."/>
													</ca:value>
												</xsl:for-each>
											</ca:possvalues>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:formelements">
									<xsl:for-each select="ca2:formelement">
										<xsl:for-each select="ca2:description">
											<ca:description>
												<xsl:value-of select="."/>
											</ca:description>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</ca:formelement>
						</xsl:for-each>
					</ca:formelements>
				</xsl:for-each>
				<xsl:for-each select="ca2:jsvariables">
					<ca:jsvariables>
						<xsl:for-each select="$widgetdoc/ca2:jsvariables">
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
						</xsl:for-each>
						<xsl:for-each select="ca2:jsvariable">
							<xsl:variable name="jsvariable" select="."/>
							<ca:jsvariable>
								<xsl:for-each select="ca2:name">
									<ca:name>
										<xsl:value-of select="."/>
									</ca:name>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:jsvariables">
									<xsl:for-each select="ca2:jsvariable">
										<xsl:for-each select="ca2:type">
											<ca:type>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="$jsvariable/ca2:type">
													<ca:value>
														<xsl:value-of select="."/>
													</ca:value>
												</xsl:for-each>
												<xsl:for-each select="ca2:description">
													<ca:description>
														<xsl:value-of select="."/>
													</ca:description>
												</xsl:for-each>
											</ca:type>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:jsvariables">
									<xsl:for-each select="ca2:jsvariable">
										<xsl:for-each select="ca2:scope">
											<ca:scope>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="ca2:value">
													<ca:value>
														<xsl:value-of select="."/>
													</ca:value>
												</xsl:for-each>
												<xsl:for-each select="ca2:description">
													<ca:description>
														<xsl:value-of select="."/>
													</ca:description>
												</xsl:for-each>
											</ca:scope>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:jsvariables">
									<xsl:for-each select="ca2:jsvariable">
										<xsl:for-each select="ca2:default">
											<ca:default>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="$jsvariable/ca2:default">
													<ca:value>
														<xsl:value-of select="."/>
													</ca:value>
												</xsl:for-each>
												<xsl:for-each select="ca2:description">
													<ca:description>
														<xsl:value-of select="."/>
													</ca:description>
												</xsl:for-each>
											</ca:default>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:jsvariables">
									<xsl:for-each select="ca2:jsvariable">
										<xsl:for-each select="ca2:possvalues">
											<ca:possvalues>
												<xsl:for-each select="@type">
													<xsl:attribute name="type">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="ca2:minimum">
													<ca:minimum>
														<xsl:value-of select="."/>
													</ca:minimum>
												</xsl:for-each>
												<xsl:for-each select="ca2:maximum">
													<ca:maximum>
														<xsl:value-of select="."/>
													</ca:maximum>
												</xsl:for-each>
												<xsl:for-each select="ca2:value">
													<ca:value>
														<xsl:value-of select="."/>
													</ca:value>
												</xsl:for-each>
											</ca:possvalues>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:jsvariables">
									<xsl:for-each select="ca2:jsvariable">
										<xsl:for-each select="ca2:description">
											<ca:description>
												<xsl:value-of select="."/>
											</ca:description>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</ca:jsvariable>
						</xsl:for-each>
					</ca:jsvariables>
				</xsl:for-each>
				<xsl:for-each select="ca2:jsfunctions">
					<ca:jsfunctions>
						<xsl:for-each select="$widgetdoc/ca2:jsfunctions">
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
						</xsl:for-each>
						<xsl:for-each select="ca2:jsfunction">
							<ca:jsfunction>
								<xsl:for-each select="ca2:name">
									<ca:name>
										<xsl:value-of select="."/>
									</ca:name>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:jsfunctions">
									<xsl:for-each select="ca2:jsfunction">
										<xsl:for-each select="ca2:scope">
											<ca:scope>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="ca2:value">
													<ca:value>
														<xsl:value-of select="."/>
													</ca:value>
												</xsl:for-each>
												<xsl:for-each select="ca2:description">
													<ca:description>
														<xsl:value-of select="."/>
													</ca:description>
												</xsl:for-each>
											</ca:scope>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:jsfunctions">
									<xsl:for-each select="ca2:jsfunction">
										<xsl:for-each select="ca2:description">
											<ca:description>
												<xsl:value-of select="."/>
											</ca:description>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="ca2:parameters">
									<ca:parameters>
										<xsl:for-each select="$widgetdoc/ca2:jsfunctions">
											<xsl:for-each select="ca2:jsfunction">
												<xsl:for-each select="ca2:parameters">
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
												</xsl:for-each>
											</xsl:for-each>
										</xsl:for-each>
										<xsl:for-each select="ca2:parameter">
											<ca:parameter>
												<xsl:for-each select="ca2:name">
													<ca:name>
														<xsl:value-of select="."/>
													</ca:name>
												</xsl:for-each>
												<xsl:for-each select="$widgetdoc/ca2:jsfunctions">
													<xsl:for-each select="ca2:jsfunction">
														<xsl:for-each select="ca2:parameters">
															<xsl:for-each select="ca2:parameter">
																<xsl:for-each select="ca2:type">
																	<ca:type>
																		<xsl:for-each select="@title">
																			<xsl:attribute name="title">
																				<xsl:value-of select="."/>
																			</xsl:attribute>
																		</xsl:for-each>
																		<xsl:for-each select="ca2:value">
																			<ca:value>
																				<xsl:value-of select="."/>
																			</ca:value>
																		</xsl:for-each>
																		<xsl:for-each select="ca2:description">
																			<ca:description>
																				<xsl:value-of select="."/>
																			</ca:description>
																		</xsl:for-each>
																	</ca:type>
																</xsl:for-each>
															</xsl:for-each>
														</xsl:for-each>
													</xsl:for-each>
												</xsl:for-each>
												<xsl:for-each select="$widgetdoc/ca2:jsfunctions">
													<xsl:for-each select="ca2:jsfunction">
														<xsl:for-each select="ca2:parameters">
															<xsl:for-each select="ca2:parameter">
																<xsl:for-each select="ca2:required">
																	<ca:required>
																		<xsl:for-each select="@title">
																			<xsl:attribute name="title">
																				<xsl:value-of select="."/>
																			</xsl:attribute>
																		</xsl:for-each>
																		<xsl:for-each select="ca2:value">
																			<ca:value>
																				<xsl:value-of select="."/>
																			</ca:value>
																		</xsl:for-each>
																		<xsl:for-each select="ca2:description">
																			<ca:description>
																				<xsl:value-of select="."/>
																			</ca:description>
																		</xsl:for-each>
																	</ca:required>
																</xsl:for-each>
															</xsl:for-each>
														</xsl:for-each>
													</xsl:for-each>
												</xsl:for-each>
												<xsl:for-each select="$widgetdoc/ca2:jsfunctions">
													<xsl:for-each select="ca2:jsfunction">
														<xsl:for-each select="ca2:parameters">
															<xsl:for-each select="ca2:parameter">
																<xsl:for-each select="ca2:default">
																	<ca:default>
																		<xsl:for-each select="@title">
																			<xsl:attribute name="title">
																				<xsl:value-of select="."/>
																			</xsl:attribute>
																		</xsl:for-each>
																		<xsl:for-each select="ca2:value">
																			<ca:value>
																				<xsl:value-of select="."/>
																			</ca:value>
																		</xsl:for-each>
																		<xsl:for-each select="ca2:description">
																			<ca:description>
																				<xsl:value-of select="."/>
																			</ca:description>
																		</xsl:for-each>
																	</ca:default>
																</xsl:for-each>
															</xsl:for-each>
														</xsl:for-each>
													</xsl:for-each>
												</xsl:for-each>
												<xsl:for-each select="$widgetdoc/ca2:jsfunctions">
													<xsl:for-each select="ca2:jsfunction">
														<xsl:for-each select="ca2:parameters">
															<xsl:for-each select="ca2:parameter">
																<xsl:for-each select="ca2:possvalues">
																	<ca:possvalues>
																		<xsl:for-each select="@type">
																			<xsl:attribute name="type">
																				<xsl:value-of select="."/>
																			</xsl:attribute>
																		</xsl:for-each>
																		<xsl:for-each select="@title">
																			<xsl:attribute name="title">
																				<xsl:value-of select="."/>
																			</xsl:attribute>
																		</xsl:for-each>
																		<xsl:for-each select="ca2:minimum">
																			<ca:minimum>
																				<xsl:value-of select="."/>
																			</ca:minimum>
																		</xsl:for-each>
																		<xsl:for-each select="ca2:maximum">
																			<ca:maximum>
																				<xsl:value-of select="."/>
																			</ca:maximum>
																		</xsl:for-each>
																		<xsl:for-each select="ca2:value">
																			<ca:value>
																				<xsl:value-of select="."/>
																			</ca:value>
																		</xsl:for-each>
																	</ca:possvalues>
																</xsl:for-each>
															</xsl:for-each>
														</xsl:for-each>
													</xsl:for-each>
												</xsl:for-each>
												<xsl:for-each select="$widgetdoc/ca2:jsfunctions">
													<xsl:for-each select="ca2:jsfunction">
														<xsl:for-each select="ca2:parameters">
															<xsl:for-each select="ca2:parameter">
																<xsl:for-each select="ca2:description">
																	<ca:description>
																		<xsl:value-of select="."/>
																	</ca:description>
																</xsl:for-each>
															</xsl:for-each>
														</xsl:for-each>
													</xsl:for-each>
												</xsl:for-each>
											</ca:parameter>
										</xsl:for-each>
									</ca:parameters>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:jsfunctions">
									<xsl:for-each select="ca2:jsfunction">
										<xsl:for-each select="ca2:returnvalues">
											<ca:returnvalues>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="ca2:returnvalue">
													<ca:returnvalue>
														<xsl:for-each select="ca2:type">
															<ca:type>
																<xsl:for-each select="@title">
																	<xsl:attribute name="title">
																		<xsl:value-of select="."/>
																	</xsl:attribute>
																</xsl:for-each>
																<xsl:for-each select="ca2:value">
																	<ca:value>
																		<xsl:value-of select="."/>
																	</ca:value>
																</xsl:for-each>
																<xsl:for-each select="ca2:description">
																	<ca:description>
																		<xsl:value-of select="."/>
																	</ca:description>
																</xsl:for-each>
															</ca:type>
														</xsl:for-each>
														<xsl:for-each select="ca2:default">
															<ca:default>
																<xsl:for-each select="@title">
																	<xsl:attribute name="title">
																		<xsl:value-of select="."/>
																	</xsl:attribute>
																</xsl:for-each>
																<xsl:for-each select="ca2:value">
																	<ca:value>
																		<xsl:value-of select="."/>
																	</ca:value>
																</xsl:for-each>
																<xsl:for-each select="ca2:description">
																	<ca:description>
																		<xsl:value-of select="."/>
																	</ca:description>
																</xsl:for-each>
															</ca:default>
														</xsl:for-each>
														<xsl:for-each select="ca2:possvalues">
															<ca:possvalues>
																<xsl:for-each select="@type">
																	<xsl:attribute name="type">
																		<xsl:value-of select="."/>
																	</xsl:attribute>
																</xsl:for-each>
																<xsl:for-each select="@title">
																	<xsl:attribute name="title">
																		<xsl:value-of select="."/>
																	</xsl:attribute>
																</xsl:for-each>
																<xsl:for-each select="ca2:minimum">
																	<ca:minimum>
																		<xsl:value-of select="."/>
																	</ca:minimum>
																</xsl:for-each>
																<xsl:for-each select="ca2:maximum">
																	<ca:maximum>
																		<xsl:value-of select="."/>
																	</ca:maximum>
																</xsl:for-each>
																<xsl:for-each select="ca2:value">
																	<ca:value>
																		<xsl:value-of select="."/>
																	</ca:value>
																</xsl:for-each>
															</ca:possvalues>
														</xsl:for-each>
														<xsl:for-each select="ca2:description">
															<ca:description>
																<xsl:value-of select="."/>
															</ca:description>
														</xsl:for-each>
													</ca:returnvalue>
												</xsl:for-each>
											</ca:returnvalues>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
								<xsl:for-each select="$widgetdoc/ca2:jsfunctions">
									<xsl:for-each select="ca2:jsfunction">
										<xsl:for-each select="ca2:triggeredjsapievents">
											<ca:triggeredjsapievents>
												<xsl:for-each select="@title">
													<xsl:attribute name="title">
														<xsl:value-of select="."/>
													</xsl:attribute>
												</xsl:for-each>
												<xsl:for-each select="ca2:intro">
													<ca:intro>
														<xsl:value-of select="."/>
													</ca:intro>
												</xsl:for-each>
												<xsl:for-each select="ca2:triggeredjsapievent">
													<ca:triggeredjsapievent>
														<xsl:for-each select="@title">
															<xsl:attribute name="title">
																<xsl:value-of select="."/>
															</xsl:attribute>
														</xsl:for-each>
														<xsl:for-each select="ca2:name">
															<ca:name>
																<xsl:value-of select="."/>
															</ca:name>
														</xsl:for-each>
														<xsl:for-each select="ca2:description">
															<ca:description>
																<xsl:value-of select="."/>
															</ca:description>
														</xsl:for-each>
													</ca:triggeredjsapievent>
												</xsl:for-each>
											</ca:triggeredjsapievents>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</ca:jsfunction>
						</xsl:for-each>
					</ca:jsfunctions>
				</xsl:for-each>
			</xsl:for-each>
			<xsl:for-each select="ca2:jsfiles">
				<ca:jsfiles>
					<xsl:for-each select="@title">
						<xsl:attribute name="title">
							<xsl:value-of select="."/>
						</xsl:attribute>
					</xsl:for-each>
					<xsl:for-each select="ca2:jsfile">
						<ca:jsfile>
							<xsl:for-each select="ca2:name">
								<ca:name>
									<xsl:value-of select="."/>
								</ca:name>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
							<xsl:for-each select="ca2:jsvariables">
								<ca:jsvariables>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:jsvariable">
										<ca:jsvariable>
											<xsl:for-each select="ca2:name">
												<ca:name>
													<xsl:value-of select="."/>
												</ca:name>
											</xsl:for-each>
											<xsl:for-each select="ca2:type">
												<ca:type>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
													<xsl:for-each select="ca2:description">
														<ca:description>
															<xsl:value-of select="."/>
														</ca:description>
													</xsl:for-each>
												</ca:type>
											</xsl:for-each>
											<xsl:for-each select="ca2:scope">
												<ca:scope>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
													<xsl:for-each select="ca2:description">
														<ca:description>
															<xsl:value-of select="."/>
														</ca:description>
													</xsl:for-each>
												</ca:scope>
											</xsl:for-each>
											<xsl:for-each select="ca2:default">
												<ca:default>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
													<xsl:for-each select="ca2:description">
														<ca:description>
															<xsl:value-of select="."/>
														</ca:description>
													</xsl:for-each>
												</ca:default>
											</xsl:for-each>
											<xsl:for-each select="ca2:possvalues">
												<ca:possvalues>
													<xsl:for-each select="@type">
														<xsl:attribute name="type">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:minimum">
														<ca:minimum>
															<xsl:value-of select="."/>
														</ca:minimum>
													</xsl:for-each>
													<xsl:for-each select="ca2:maximum">
														<ca:maximum>
															<xsl:value-of select="."/>
														</ca:maximum>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
												</ca:possvalues>
											</xsl:for-each>
											<xsl:for-each select="ca2:description">
												<ca:description>
													<xsl:value-of select="."/>
												</ca:description>
											</xsl:for-each>
										</ca:jsvariable>
									</xsl:for-each>
								</ca:jsvariables>
							</xsl:for-each>
							<xsl:for-each select="ca2:jsfunctions">
								<ca:jsfunctions>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:jsfunction">
										<ca:jsfunction>
											<xsl:for-each select="ca2:name">
												<ca:name>
													<xsl:value-of select="."/>
												</ca:name>
											</xsl:for-each>
											<xsl:for-each select="ca2:scope">
												<ca:scope>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
													<xsl:for-each select="ca2:description">
														<ca:description>
															<xsl:value-of select="."/>
														</ca:description>
													</xsl:for-each>
												</ca:scope>
											</xsl:for-each>
											<xsl:for-each select="ca2:description">
												<ca:description>
													<xsl:value-of select="."/>
												</ca:description>
											</xsl:for-each>
											<xsl:for-each select="ca2:parameters">
												<ca:parameters>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:parameter">
														<ca:parameter>
															<xsl:for-each select="ca2:name">
																<ca:name>
																	<xsl:value-of select="."/>
																</ca:name>
															</xsl:for-each>
															<xsl:for-each select="ca2:type">
																<ca:type>
																	<xsl:for-each select="@title">
																		<xsl:attribute name="title">
																			<xsl:value-of select="."/>
																		</xsl:attribute>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:value">
																		<ca:value>
																			<xsl:value-of select="."/>
																		</ca:value>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:description">
																		<ca:description>
																			<xsl:value-of select="."/>
																		</ca:description>
																	</xsl:for-each>
																</ca:type>
															</xsl:for-each>
															<xsl:for-each select="ca2:required">
																<ca:required>
																	<xsl:for-each select="@title">
																		<xsl:attribute name="title">
																			<xsl:value-of select="."/>
																		</xsl:attribute>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:value">
																		<ca:value>
																			<xsl:value-of select="."/>
																		</ca:value>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:description">
																		<ca:description>
																			<xsl:value-of select="."/>
																		</ca:description>
																	</xsl:for-each>
																</ca:required>
															</xsl:for-each>
															<xsl:for-each select="ca2:default">
																<ca:default>
																	<xsl:for-each select="@title">
																		<xsl:attribute name="title">
																			<xsl:value-of select="."/>
																		</xsl:attribute>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:value">
																		<ca:value>
																			<xsl:value-of select="."/>
																		</ca:value>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:description">
																		<ca:description>
																			<xsl:value-of select="."/>
																		</ca:description>
																	</xsl:for-each>
																</ca:default>
															</xsl:for-each>
															<xsl:for-each select="ca2:possvalues">
																<ca:possvalues>
																	<xsl:for-each select="@type">
																		<xsl:attribute name="type">
																			<xsl:value-of select="."/>
																		</xsl:attribute>
																	</xsl:for-each>
																	<xsl:for-each select="@title">
																		<xsl:attribute name="title">
																			<xsl:value-of select="."/>
																		</xsl:attribute>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:minimum">
																		<ca:minimum>
																			<xsl:value-of select="."/>
																		</ca:minimum>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:maximum">
																		<ca:maximum>
																			<xsl:value-of select="."/>
																		</ca:maximum>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:value">
																		<ca:value>
																			<xsl:value-of select="."/>
																		</ca:value>
																	</xsl:for-each>
																</ca:possvalues>
															</xsl:for-each>
															<xsl:for-each select="ca2:description">
																<ca:description>
																	<xsl:value-of select="."/>
																</ca:description>
															</xsl:for-each>
														</ca:parameter>
													</xsl:for-each>
												</ca:parameters>
											</xsl:for-each>
											<xsl:for-each select="ca2:returnvalues">
												<ca:returnvalues>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:returnvalue">
														<ca:returnvalue>
															<xsl:for-each select="ca2:type">
																<ca:type>
																	<xsl:for-each select="@title">
																		<xsl:attribute name="title">
																			<xsl:value-of select="."/>
																		</xsl:attribute>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:value">
																		<ca:value>
																			<xsl:value-of select="."/>
																		</ca:value>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:description">
																		<ca:description>
																			<xsl:value-of select="."/>
																		</ca:description>
																	</xsl:for-each>
																</ca:type>
															</xsl:for-each>
															<xsl:for-each select="ca2:default">
																<ca:default>
																	<xsl:for-each select="@title">
																		<xsl:attribute name="title">
																			<xsl:value-of select="."/>
																		</xsl:attribute>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:value">
																		<ca:value>
																			<xsl:value-of select="."/>
																		</ca:value>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:description">
																		<ca:description>
																			<xsl:value-of select="."/>
																		</ca:description>
																	</xsl:for-each>
																</ca:default>
															</xsl:for-each>
															<xsl:for-each select="ca2:possvalues">
																<ca:possvalues>
																	<xsl:for-each select="@type">
																		<xsl:attribute name="type">
																			<xsl:value-of select="."/>
																		</xsl:attribute>
																	</xsl:for-each>
																	<xsl:for-each select="@title">
																		<xsl:attribute name="title">
																			<xsl:value-of select="."/>
																		</xsl:attribute>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:minimum">
																		<ca:minimum>
																			<xsl:value-of select="."/>
																		</ca:minimum>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:maximum">
																		<ca:maximum>
																			<xsl:value-of select="."/>
																		</ca:maximum>
																	</xsl:for-each>
																	<xsl:for-each select="ca2:value">
																		<ca:value>
																			<xsl:value-of select="."/>
																		</ca:value>
																	</xsl:for-each>
																</ca:possvalues>
															</xsl:for-each>
															<xsl:for-each select="ca2:description">
																<ca:description>
																	<xsl:value-of select="."/>
																</ca:description>
															</xsl:for-each>
														</ca:returnvalue>
													</xsl:for-each>
												</ca:returnvalues>
											</xsl:for-each>
											<xsl:for-each select="ca2:triggeredjsapievents">
												<ca:triggeredjsapievents>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:triggeredjsapievent">
														<ca:triggeredjsapievent>
															<xsl:for-each select="@title">
																<xsl:attribute name="title">
																	<xsl:value-of select="."/>
																</xsl:attribute>
															</xsl:for-each>
															<xsl:for-each select="ca2:name">
																<ca:name>
																	<xsl:value-of select="."/>
																</ca:name>
															</xsl:for-each>
															<xsl:for-each select="ca2:description">
																<ca:description>
																	<xsl:value-of select="."/>
																</ca:description>
															</xsl:for-each>
														</ca:triggeredjsapievent>
													</xsl:for-each>
												</ca:triggeredjsapievents>
											</xsl:for-each>
										</ca:jsfunction>
									</xsl:for-each>
								</ca:jsfunctions>
							</xsl:for-each>
						</ca:jsfile>
					</xsl:for-each>
				</ca:jsfiles>
			</xsl:for-each>
			<xsl:for-each select="ca2:listenedjsapievents">
				<ca:listenedjsapievents>
					<xsl:for-each select="@title">
						<xsl:attribute name="title">
							<xsl:value-of select="."/>
						</xsl:attribute>
					</xsl:for-each>
					<xsl:for-each select="ca2:listenedjsapievent">
						<ca:listenedjsapievent>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:name">
								<ca:name>
									<xsl:value-of select="."/>
								</ca:name>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
							<xsl:for-each select="ca2:calledfunctions">
								<ca:calledfunctions>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:intro">
										<ca:intro>
											<xsl:value-of select="."/>
										</ca:intro>
									</xsl:for-each>
									<xsl:for-each select="ca2:calledfunction">
										<ca:calledfunction>
											<xsl:for-each select="ca2:name">
												<ca:name>
													<xsl:value-of select="."/>
												</ca:name>
											</xsl:for-each>
											<xsl:for-each select="ca2:description">
												<ca:description>
													<xsl:value-of select="."/>
												</ca:description>
											</xsl:for-each>
										</ca:calledfunction>
									</xsl:for-each>
								</ca:calledfunctions>
							</xsl:for-each>
						</ca:listenedjsapievent>
					</xsl:for-each>
				</ca:listenedjsapievents>
			</xsl:for-each>
			<xsl:for-each select="ca2:widgetevents">
				<ca:widgetevents>
					<xsl:for-each select="@title">
						<xsl:attribute name="title">
							<xsl:value-of select="."/>
						</xsl:attribute>
					</xsl:for-each>
					<xsl:for-each select="ca2:widgetevent">
						<ca:widgetevent>
							<xsl:for-each select="ca2:name">
								<ca:name>
									<xsl:value-of select="."/>
								</ca:name>
							</xsl:for-each>
							<xsl:for-each select="ca2:parameters">
								<ca:parameters>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:parameter">
										<ca:parameter>
											<xsl:for-each select="ca2:name">
												<ca:name>
													<xsl:value-of select="."/>
												</ca:name>
											</xsl:for-each>
											<xsl:for-each select="ca2:type">
												<ca:type>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
													<xsl:for-each select="ca2:description">
														<ca:description>
															<xsl:value-of select="."/>
														</ca:description>
													</xsl:for-each>
												</ca:type>
											</xsl:for-each>
											<xsl:for-each select="ca2:required">
												<ca:required>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
													<xsl:for-each select="ca2:description">
														<ca:description>
															<xsl:value-of select="."/>
														</ca:description>
													</xsl:for-each>
												</ca:required>
											</xsl:for-each>
											<xsl:for-each select="ca2:default">
												<ca:default>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
													<xsl:for-each select="ca2:description">
														<ca:description>
															<xsl:value-of select="."/>
														</ca:description>
													</xsl:for-each>
												</ca:default>
											</xsl:for-each>
											<xsl:for-each select="ca2:possvalues">
												<ca:possvalues>
													<xsl:for-each select="@type">
														<xsl:attribute name="type">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="@title">
														<xsl:attribute name="title">
															<xsl:value-of select="."/>
														</xsl:attribute>
													</xsl:for-each>
													<xsl:for-each select="ca2:minimum">
														<ca:minimum>
															<xsl:value-of select="."/>
														</ca:minimum>
													</xsl:for-each>
													<xsl:for-each select="ca2:maximum">
														<ca:maximum>
															<xsl:value-of select="."/>
														</ca:maximum>
													</xsl:for-each>
													<xsl:for-each select="ca2:value">
														<ca:value>
															<xsl:value-of select="."/>
														</ca:value>
													</xsl:for-each>
												</ca:possvalues>
											</xsl:for-each>
											<xsl:for-each select="ca2:description">
												<ca:description>
													<xsl:value-of select="."/>
												</ca:description>
											</xsl:for-each>
										</ca:parameter>
									</xsl:for-each>
								</ca:parameters>
							</xsl:for-each>
							<xsl:for-each select="ca2:description">
								<ca:description>
									<xsl:value-of select="."/>
								</ca:description>
							</xsl:for-each>
						</ca:widgetevent>
					</xsl:for-each>
				</ca:widgetevents>
			</xsl:for-each>
			<xsl:for-each select="ca2:errors">
				<ca:errors>
					<xsl:for-each select="@title">
						<xsl:attribute name="title">
							<xsl:value-of select="."/>
						</xsl:attribute>
					</xsl:for-each>
					<xsl:for-each select="ca2:error">
						<ca:error>
							<xsl:for-each select="@title">
								<xsl:attribute name="title">
									<xsl:value-of select="."/>
								</xsl:attribute>
							</xsl:for-each>
							<xsl:for-each select="ca2:type">
								<ca:type>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:value">
										<ca:value>
											<xsl:value-of select="."/>
										</ca:value>
									</xsl:for-each>
									<xsl:for-each select="ca2:description">
										<ca:description>
											<xsl:value-of select="."/>
										</ca:description>
									</xsl:for-each>
								</ca:type>
							</xsl:for-each>
							<xsl:for-each select="ca2:severity">
								<ca:severity>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:value">
										<ca:value>
											<xsl:value-of select="."/>
										</ca:value>
									</xsl:for-each>
									<xsl:for-each select="ca2:description">
										<ca:description>
											<xsl:value-of select="."/>
										</ca:description>
									</xsl:for-each>
								</ca:severity>
							</xsl:for-each>
							<xsl:for-each select="ca2:message">
								<ca:message>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:paras">
										<ca:paras>
											<xsl:for-each select="@title">
												<xsl:attribute name="title">
													<xsl:value-of select="."/>
												</xsl:attribute>
											</xsl:for-each>
											<xsl:for-each select="ca2:para">
												<ca:para>
													<xsl:value-of select="."/>
												</ca:para>
											</xsl:for-each>
										</ca:paras>
									</xsl:for-each>
								</ca:message>
							</xsl:for-each>
							<xsl:for-each select="ca2:meaning">
								<ca:meaning>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:paras">
										<ca:paras>
											<xsl:for-each select="@title">
												<xsl:attribute name="title">
													<xsl:value-of select="."/>
												</xsl:attribute>
											</xsl:for-each>
											<xsl:for-each select="ca2:para">
												<ca:para>
													<xsl:value-of select="."/>
												</ca:para>
											</xsl:for-each>
										</ca:paras>
									</xsl:for-each>
								</ca:meaning>
							</xsl:for-each>
							<xsl:for-each select="ca2:solution">
								<ca:solution>
									<xsl:for-each select="@title">
										<xsl:attribute name="title">
											<xsl:value-of select="."/>
										</xsl:attribute>
									</xsl:for-each>
									<xsl:for-each select="ca2:paras">
										<ca:paras>
											<xsl:for-each select="@title">
												<xsl:attribute name="title">
													<xsl:value-of select="."/>
												</xsl:attribute>
											</xsl:for-each>
											<xsl:for-each select="ca2:para">
												<ca:para>
													<xsl:value-of select="."/>
												</ca:para>
											</xsl:for-each>
										</ca:paras>
									</xsl:for-each>
								</ca:solution>
							</xsl:for-each>
						</ca:error>
					</xsl:for-each>
				</ca:errors>
			</xsl:for-each>
		</ca:widgetdoc>
	</xsl:template>
</xsl:stylesheet>
