<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
	xmlns:ca2="http://localhost/chameleon/utils/xml/schemas"
	xmlns:db="http://localhost/chameleon/utils/xml/schemas"
	xmlns:xs="http://www.w3.org/2001/XMLSchema" 
	xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
	exclude-result-prefixes="ca ca2 xs">
	<xsl:output method="xml" encoding="UTF-8" indent="yes"/>
	
	<!-- SECTIONS OF A DOCTUMENT -->
	<!-- paths for Doc Builder -->
   <xsl:include href= "../../utils/xml/mergers/includes/docinfo.xslt"/> 
	<xsl:include href="../../utils/xml/mergers/includes/identification.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/descriptions.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/tagstructures.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/examples.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/attributegroups.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/widgetattributes.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/formelements.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/jsvariables.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/jsfunctions.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/parameters.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/jsfiles.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/jsapievents.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/widgetevents.xslt"/>
	<xsl:include href="../../utils/xml/mergers/includes/widgeterrors.xslt"/>

	<!-- paths For Testing Outside DocBuilder -->
<!--
	<xsl:include href= "db2ca-docinfo.xslt"/> 
	<xsl:include href="db2ca-identification.xslt"/>
	<xsl:include href="db2ca-descriptions.xslt"/>
	<xsl:include href="db2ca-tagstructures.xslt"/>
	<xsl:include href="db2ca-examples.xslt"/>
	<xsl:include href="db2ca-attributegroups.xslt"/>
	<xsl:include href="db2ca-widgetattributes.xslt"/>
	<xsl:include href="db2ca-formelements.xslt"/>
	<xsl:include href="db2ca-jsvariables.xslt"/>
	<xsl:include href="db2ca-jsfunctions.xslt"/>
	<xsl:include href="db2ca-jsfiles.xslt"/>
	<xsl:include href="db2ca-jsapievents.xslt"/>
	<xsl:include href="db2ca-widgetevents.xslt"/>
	<xsl:include href="db2ca-widgeterrors.xslt"/>
-->
	<!-- for testing outside of docbuilder.php -->
    <!--<xsl:param name="dbdoc" select="document('D:\ms4w\apps\_cvsdev\chameleon\utils\xml\mergers\widget_sample2.xml')"/> -->

	<!--DOCUMENT  FLAVOURS (Widget vs Att Grp Doc) -->
	<!-- Global Parameters Defined -->	
	<!-- db: Doc Builder File Call -->
	<xsl:param name="dbdoc" select="document('arg:/xml2')"/>  
    <!-- removing white space and returns-->
  	<xsl:param name="glob_szattgrp" select="translate(normalize-space($dbdoc/db:widget/db:attributegroups),' ','')"/>
  	<xsl:param name="glob_szattgrpold" select="translate(normalize-space(/ca2:widgetdoc/ca2:attributegroups),' ','')"/>

	<!-- Tag Syntax Paramters Defined -->
	<xsl:param name="syntax1" select="' =&quot;['"/>
	<xsl:param name="syntax2" select="']&quot;'"/>
	<xsl:param name="frontspace" select="'   '"/>
	<xsl:param name="comment1" select="'&lt;-- '"/>
	<xsl:param name="comment2" select="' Attributes --&gt;'"/>
	
	<!-- first line widget tag -->
	<xsl:param name="wigtag" select="'&lt;CWC2 TYPE=&quot;'"/>
	<xsl:param name="quot" select="'&quot;'"/>
	<xsl:param name="tagend" select="' /&gt;'"/>
	

   
	<!-- GENERAL DECLARED TEMPLATES (they could be match, but need to understand what that means) -->
	<xsl:template name="AttTitleBlock">
		<xsl:attribute name="title">
			<xsl:value-of select="@title"/>
		</xsl:attribute>
	</xsl:template>

	<xsl:template name="AttTypeBlock">
		<xsl:attribute name="type">
			<xsl:value-of select="@type"/>
		</xsl:attribute>
	</xsl:template>
		
	<xsl:template name="DescriptionBlock">
		<ca:description>
			<xsl:value-of select="ca2:description"/>
		</ca:description>
	</xsl:template>	
	 
   <!-- Parent Template to all widgetdocs -->
	<xsl:template match="/ca2:widgetdoc">
	    <!-- Widget Doc Header -->
		<ca:widgetdoc>
			<xsl:attribute name="xmlns:ca">http://localhost/chameleon/utils/xml/schemas</xsl:attribute> 		
			<xsl:attribute name="xsi:schemaLocation">http://localhost/chameleon/utils/xml/schemas ..\..\..\utils\xml\schemas\chameleon.xsd</xsl:attribute>
			<!-- ca2: DEFAULT FILE CALL  -->
			<xsl:variable name="widgetdoc" select="."/>
			<!-- ~~~~~~~~~~~~~~~~ -->
			<!-- DOC INFO SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~ -->
			<xsl:call-template name="DocInfoBlock"/>			
			<!-- ~~~~~~~~~~~~~~~~~~~~ -->
			<!--IDENTIFICATION SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~~~~ -->		
			<xsl:call-template name="IdentificationBlock"/>		
			<!-- ~~~~~~~~~~~~~~~~~~~~ -->
			<!-- DESCRIPTIONS SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~~~~ -->
			<xsl:call-template name="DescriptionsBlock"/>		
			<!-- ~~~~~~~~~~~~~~~~~~~~~~ -->
			<!--TAG STRUCTURE SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~~~~~~ -->
			<xsl:call-template name="TagStrucuturesBlock"/>	
			<!-- ~~~~~~~~~~~~~~~~~ -->
			<!--EXAMPLES SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~ -->
			<xsl:call-template name="ExamplesBlock"/>		
			<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~ -->
			<!-- ATTRIBUTE GROUPS SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~ -->
			<xsl:call-template name="AttributeGroupsBlock"/>		
			<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~ -->
			<!-- WIDGET ATTRIBUTES SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~ -->
			<xsl:call-template name="WidgetAttributesBlock"/>	
			<!-- ~~~~~~~~~~~~~~~~~~~~~ -->
			<!--FORMELEMENTS SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~~~~~ -->
			<xsl:call-template name="FormelementsBlock"/>	
			<!-- ~~~~~~~~~~~~~~~~~~~~ -->
			<!--JS VARIABLES SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~~~~ -->
			<xsl:call-template name="JSvariablesBlock"/>	
			<!-- ~~~~~~~~~~~~~~~~~~~~ -->
			<!--JS FUNCTIONS SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~~~~ -->			
			<xsl:call-template name="JSfunctionsBlock"/>	
			<!-- ~~~~~~~~~~~~~~~~~~~~ -->
			<!--JS FILES SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~~~~ -->			
			<xsl:call-template name="JSfilesBlock"/>				
			<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
			<!--JSAPI LISTENED EVENTS SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
			<xsl:call-template name="JSapiListenEventsBlock"/>
			<!-- ~~~~~~~~~~~~~~~~~~~~~ -->
			<!--WIDGET EVENTS SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~~~~~ -->
			<xsl:call-template name="WidgetEventsBlock"/>
			<!-- ~~~~~~~~~~~~~~~~~~~~~ -->
			<!--WIDGET ERRORS SECTION  -->
			<!-- ~~~~~~~~~~~~~~~~~~~~~ -->		
			<xsl:call-template name="WidgetErrorsBlock"/>	
<!-- The End -->
		</ca:widgetdoc>
	</xsl:template>
</xsl:stylesheet>
