<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
	xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
	xmlns:ca2="http://localhost/chameleon/utils/xml/schemas"
	xmlns:db="http://localhost/chameleon/utils/xml/schemas"
	xmlns:xs="http://www.w3.org/2001/XMLSchema" 
	exclude-result-prefixes="ca ca2 xs">
	<!-- ~~~~~~~~~~~~~~~~~ -->
	<!--ATTRIBUTE GROUPS SECTION  (used by manager index)-->
	<!-- ~~~~~~~~~~~~~~~~~ -->
	<xsl:template name="AttributeGroupsUpdate">
			<xsl:choose>
					<xsl:when test="$glob_szattgrp != $glob_szattgrpold">
	<xsl:comment>
		~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		Warning 1:A change in attribute groups has been found.
		The Widget code has possibly changed or an error has 
		occured. Please review both the db: and ca: documents 
		for this widget.  
	    
		(ca:attributegroups) = [<xsl:value-of select="$glob_szattgrpold"/>]
		Where
		(db:attributegroups) =  [<xsl:value-of select="$glob_szattgrp"/>]
		
		The below values are what is currently from (ca:attributegroups). 
		Please review and modify if necessary. 	
	</xsl:comment>		
						<xsl:copy-of select="ca2:attributegroups"/>
	<!--					
	<xsl:comment>
		(db:attributegroup) The below values are what is currently being 
		extracted from the widget code.	
		~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	</xsl:comment>	
						<xsl:call-template name="AttributeGroupsBlock"/>
	<xsl:comment>
		~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	</xsl:comment>	
-->
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy-of select="ca2:attributegroups"/>
					</xsl:otherwise>
				</xsl:choose>				
	</xsl:template>
	<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~ -->
	<!-- ATTRIBUTE GROUPS SECTION  (used by default index)-->
	<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~ -->
	<xsl:template name="AttributeGroupsBlock">
		<xsl:for-each select="ca2:attributegroups">
			<ca:attributegroups>
				<xsl:call-template name="DescriptionBlock"/>
				
				<xsl:call-template name="AttributeGrpListBlock"/>
				
			</ca:attributegroups>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="AttributeGrpListBlock">
		<xsl:for-each select="$dbdoc/db:widget/db:attributegroups">
			<ca:attributegroup>
				<xsl:for-each select="db:attributegroup">
				
					<ca:name>
						<xsl:value-of select="."/>
					</ca:name>
				</xsl:for-each>
			</ca:attributegroup>
		</xsl:for-each>	
	</xsl:template>
	
	
	
	
</xsl:stylesheet>
