<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
	xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
	xmlns:ca2="http://localhost/chameleon/utils/xml/schemas"
	xmlns:db="http://localhost/chameleon/utils/xml/schemas"
	xmlns:xs="http://www.w3.org/2001/XMLSchema" 
	exclude-result-prefixes="ca ca2 xs">


	<!-- ~~~~~~~~~~~~~~~~~~~~~~~ -->
	<!-- DOC INFO SECTION UPDATE (used by manager index) -->
	<!-- ~~~~~~~~~~~~~~~~~~~~~~~ -->
	<xsl:template name="DocInfoUpdate">

		<xsl:for-each select="ca2:docinfo">
			<ca:docinfo>
				<!-- Instert by db  -->
				<xsl:for-each select="$dbdoc/db:widget/db:docinfo">	
					<!-- <xsl:for-each select="ca2:docinfo"> -->
						<xsl:call-template name="LangBlock"/>	
						<xsl:call-template name="BuildDateBlock"/>
				</xsl:for-each>
				<!-- Instert by ca2  -->
				<xsl:copy-of select="ca2:docversion"/>
				<xsl:copy-of select="ca2:authors"/>
				<xsl:copy-of select="ca2:editors"/>
			</ca:docinfo>
		</xsl:for-each>
	</xsl:template>	

	<!-- ~~~~~~~~~~~~~~~~ -->
	<!-- DOC INFO SECTION (used by default index)-->
	<!-- ~~~~~~~~~~~~~~~~ -->
	<xsl:template name="DocInfoBlock">
		<xsl:for-each select="ca2:docinfo">
			<ca:docinfo>
				<!-- Instert by db  -->
				<xsl:for-each select="$dbdoc/db:widget/db:docinfo">	
					<!-- <xsl:for-each select="ca2:docinfo"> -->
						<xsl:call-template name="LangBlock"/>	
						<xsl:call-template name="BuildDateBlock"/>
				</xsl:for-each>
				<!-- Instert by ca  -->
				<xsl:call-template name="DocVersionBlock"/>
				<xsl:call-template name="AuthorsBlock"/>
				<xsl:call-template name="EditorsBlock"/>
			</ca:docinfo>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="LangBlock">
		<ca:language>
			<ca:value>
				<xsl:value-of select="db:language"/>
			</ca:value>
		</ca:language>
	</xsl:template>


	<xsl:template name="BuildDateBlock">
		<ca:docbuilddate>
			<ca:value>
				<xsl:value-of select="db:docbuilddate"/>
			</ca:value>
		</ca:docbuilddate>
	</xsl:template>

	<xsl:template name="DocVersionBlock">
		<ca:docversion>
				<ca:value>
					<xsl:value-of select="ca2:docversion/ca2:value"/>
				</ca:value>
		</ca:docversion>
	</xsl:template>

	<xsl:template name="AuthorsBlock">    
		<xsl:for-each select="ca2:authors">
			<ca:authors>	
				<xsl:call-template name="PersonBlock"/>
			</ca:authors>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template name="EditorsBlock">    
		<xsl:for-each select="ca2:editors">
			<ca:editors>	
				<xsl:call-template name="PersonBlock"/>
			</ca:editors>
		</xsl:for-each>
	</xsl:template>
	
	<!-- Person  Sub Section -->					
	<xsl:template name="PersonBlock">    
		<xsl:for-each select="ca2:person">
			<ca:person>
					<ca:name>
						<xsl:value-of select="ca2:name"/>
					</ca:name>
					<ca:company>
						<xsl:value-of select="ca2:company"/>
					</ca:company>
					<ca:contact>
						<xsl:value-of select="ca2:contact"/>
					</ca:contact>
					<ca:comment>
						<xsl:value-of select="ca2:comment"/>
					</ca:comment>
			</ca:person>
		</xsl:for-each>
	</xsl:template>


</xsl:stylesheet>
