<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
	xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
	xmlns:ca2="http://localhost/chameleon/utils/xml/schemas"
	xmlns:db="http://localhost/chameleon/utils/xml/schemas"
	xmlns:xs="http://www.w3.org/2001/XMLSchema" 
	exclude-result-prefixes="ca ca2 xs">


	<!-- ~~~~~~~~~~~~~~~~~ -->
	<!--EXAMPLES SECTION  (used by manager index)-->
	<!-- ~~~~~~~~~~~~~~~~~ -->
	<xsl:template name="ExamplesUpdate">
		<xsl:copy-of select="ca2:examples"/>
	</xsl:template>

	<!-- ~~~~~~~~~~~~~~~~~ -->
	<!--EXAMPLES SECTION  (used by default index)-->
	<!-- ~~~~~~~~~~~~~~~~~ -->

	<xsl:template name="ExamplesBlock">
		<xsl:for-each select="ca2:examples">
			<ca:examples>
				<xsl:call-template name="DescriptionBlock"/>
				
				<xsl:for-each select="ca2:widgetexamples">
					<ca:widgetexamples>
						<xsl:call-template name="ExampleBlock"/>
					</ca:widgetexamples>
				</xsl:for-each>

				<xsl:for-each select="ca2:sharedresourceexamples">
					<ca:sharedresourceexamples>
						<xsl:call-template name="ExampleBlock"/>
					</ca:sharedresourceexamples>
				</xsl:for-each>

				<xsl:call-template name="SampleAppsBlock"/>
				
				<xsl:for-each select="ca2:scriptexamples">
					<ca:scriptexamples>
						<xsl:call-template name="ExampleBlock"/>
					</ca:scriptexamples>
				</xsl:for-each>
				
			</ca:examples>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="ExampleBlock">
		<xsl:for-each select="ca2:example">
			<ca:example>
				<xsl:call-template name="AttTitleBlock"/>
				<xsl:call-template name="DescriptionBlock"/>
				<xsl:for-each select="ca2:code">
					<ca:code>
						<xsl:call-template name="AttTitleBlock"/>
						<xsl:call-template name="DescriptionBlock"/>
						<xsl:for-each select="ca2:codeblock">
							<ca:codeblock>
								<xsl:for-each select="@bold">
									<xsl:attribute name="bold">
										<xsl:value-of select="."/>
									</xsl:attribute>
								</xsl:for-each>
								<xsl:for-each select="ca2:line">
									<ca:line>
										<xsl:value-of select="."/>
									</ca:line>
								</xsl:for-each>
							</ca:codeblock>
						</xsl:for-each>
					</ca:code>
				</xsl:for-each>
			</ca:example>
		</xsl:for-each>
	</xsl:template>
		
	<xsl:template name="SampleAppsBlock">							
		<xsl:for-each select="ca2:sampleapps">
			<ca:sampleapps>
				<xsl:for-each select="ca2:sampleapp">
					<ca:sampleapp>
						<ca:name>
							<xsl:value-of select="ca2:name"/>
						</ca:name>
						<ca:appurl>
							<xsl:value-of select="ca2:appurl"/>
						</ca:appurl>
						<xsl:call-template name="DescriptionBlock"/>
					</ca:sampleapp>
				</xsl:for-each>
			</ca:sampleapps>
		</xsl:for-each>
 	</xsl:template>	

</xsl:stylesheet>
