<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
	xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
	xmlns:ca2="http://localhost/chameleon/utils/xml/schemas"
	xmlns:db="http://localhost/chameleon/utils/xml/schemas"
	xmlns:xs="http://www.w3.org/2001/XMLSchema" 
	exclude-result-prefixes="ca2 xs">


	<!-- ~~~~~~~~~~~~~~~~ -->
	<!-- IDENTIFICATION SECTION (used by manager index) -->
	<!-- ~~~~~~~~~~~~~~~~ -->
	<xsl:template name="IdentificationUpdate">
		<xsl:for-each select="ca2:identification">
			<ca:identification>
				<!-- Instert by db  -->		
				<xsl:for-each select="$dbdoc/db:widget/db:identification/db:name">
						<xsl:call-template name="WidgetNameBlock"/>	
				</xsl:for-each>
				<!-- Instert by ca2  -->
				<xsl:copy-of select="ca2:chameleonpack"/>
				<xsl:copy-of select="ca2:parentgroup"/>
				<xsl:copy-of select="ca2:version"/>
				<xsl:copy-of select="ca2:releasedate"/>
				<!-- Instert by db  -->
				<xsl:for-each select="$dbdoc/db:widget/db:identification">	
						<xsl:call-template name="MaturityLevelBlock"/>	
				</xsl:for-each>
				<!-- Instert by ca2  -->	
				<xsl:copy-of select="ca2:developers"/>		
			</ca:identification>
		</xsl:for-each>
	</xsl:template>

	<!-- ~~~~~~~~~~~~~~~~ -->
	<!-- IDENTIFICATION SECTION (used by default index)  -->
	<!-- ~~~~~~~~~~~~~~~~ -->
	<xsl:template name="IdentificationBlock">
		<xsl:for-each select="ca2:identification">
			<ca:identification>
				<!-- Instert by db  -->		
				<xsl:for-each select="$dbdoc/db:widget/db:identification/db:name">
						<xsl:call-template name="WidgetNameBlock"/>	
				</xsl:for-each>
				<!-- Instert by ca  -->
				<xsl:call-template name="ChamPackBlock"/>
				<xsl:call-template name="ParentGrpBlock"/>
				<xsl:call-template name="VersionBlock"/>
				<xsl:call-template name="ReleaseDateBlock"/>
				<!-- Instert by db  -->
				<xsl:for-each select="$dbdoc/db:widget/db:identification">	
						<xsl:call-template name="MaturityLevelBlock"/>	
				</xsl:for-each>	
				<xsl:call-template name="DevelopersBlock"/>			
			</ca:identification>
		</xsl:for-each>
	</xsl:template>


		
	<xsl:template name="WidgetNameBlock">
		<ca:name>
			<ca:value>
				<xsl:value-of select="."/>
			</ca:value>
		</ca:name>
	</xsl:template>

	<xsl:template name="ChamPackBlock">
		<ca:chameleonpack>
			<ca:value>
				<xsl:value-of select="ca2:chameleonpack"/>
			</ca:value>
		</ca:chameleonpack>
	</xsl:template>

	<xsl:template name="ParentGrpBlock">
		<ca:parentgroup>
			<ca:value>
				<xsl:value-of select="ca2:parentgroup/ca2:value"/>
			</ca:value>
		</ca:parentgroup>
	</xsl:template>

	<xsl:template name="VersionBlock">
		<ca:version>
			<ca:value>
				<xsl:value-of select="ca2:version/ca2:value"/>
			</ca:value>
		</ca:version>
	</xsl:template>

	<xsl:template name="ReleaseDateBlock">
		<ca:releasedate>
			<ca:value>
				<xsl:value-of select="ca2:releasedate/ca2:value"/>
			</ca:value>
		</ca:releasedate>
	</xsl:template>
	
	<xsl:template name="MaturityLevelBlock">
		<ca:maturitylevel>
			<ca:value>
				<xsl:value-of select="db:maturitylevel"/>
			</ca:value>
		</ca:maturitylevel>
	</xsl:template>

	<xsl:template name="DevelopersBlock">    
		<xsl:for-each select="ca2:developers">
			<ca:developers>	
				<xsl:call-template name="PersonBlock"/>
			</ca:developers>
		</xsl:for-each>
	</xsl:template>
	
</xsl:stylesheet>
