<xsl:stylesheet version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
  xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
  xmlns:ca2="http://localhost/chameleon/utils/xml/schemas"
  xmlns:db="http://localhost/chameleon/utils/xml/schemas"
  xmlns:xs="http://www.w3.org/2001/XMLSchema" 
  exclude-result-prefixes="ca2 xs">
  <!-- ~~~~~~~~~~~~~~~~~ -->
  <!--JS FILES SECTION  (used by manager index)-->
  <!-- ~~~~~~~~~~~~~~~~~ -->
  <xsl:template name="JSfilesUpdate"> 
  
  <xsl:variable name="dbnjsfile" select="count($dbdoc/db:widget/db:jsfiles/db:jsfile)"/>
    <xsl:variable name="ca2njsfile" select="count(ca2:jsfiles/ca2:jsfile)"/>

  <xsl:choose>

    <xsl:when test="$dbnjsfile &lt; $ca2njsfile">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
JS Variables Section ERROR 1 : 
THERE ARE LESS  DB:(IN WIDGET CODE) JS Variables THAN THERE ARE CURRENT CA:(WIDGET DOC)!!! 
(db:<xsl:value-of select=" $dbnjsfile"/> &lt; current ca:<xsl:value-of select=" $ca2njsfile"/>)
Someone has either manually edited the ca: file and added an JS Variables or 
there has been a change in the widget code. 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
    </xsl:when>
    <xsl:when test="$dbnjsfile &gt; $ca2njsfile">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
JS Files Section ERROR 2 : 
THERE ARE MORE DB:(IN WIDGET CODE) JS VariablesTHAN THERE ARE CURRENT CA:(WIDGET DOC)!!!
(db:<xsl:value-of select=" $dbnjsfile"/> &gt; current ca:<xsl:value-of select=" $ca2njsfile"/>)
Someone has either manually edited the ca: file and removed JS File or 
there has been a change in the widget code. 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
    </xsl:when>   
    
  </xsl:choose>
  <ca:jsfiles>
      <xsl:copy-of select="ca2:jsfiles/@title"/>
        <xsl:call-template name="DB_JSFileNameSearchEval"/>
      <xsl:call-template name="CA_JSFileNameSearchEval"/>  
  </ca:jsfiles>
  </xsl:template>
  
    <xsl:template name="DB_JSFileNameSearchEval"> 

    <xsl:for-each select="$dbdoc/db:widget/db:jsfiles">
      <xsl:sort select="db:jsfile/db:name"/>
      <xsl:for-each select="db:jsfile">
        <xsl:variable name="dbszjsfile" select="db:name"/>
        <xsl:variable name="dbposjsfile" select="position()"/>
        <xsl:variable name="ca2search" select="contains($glob_ca2jsfiles, $dbszjsfile)"/>
        <xsl:choose>
          <xsl:when test=" string($ca2search) = 'false' ">
          
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
JS Files Section NOTE 1 :{db:jsfile/ca:name[<xsl:value-of select="$dbposjsfile"/>] =(<xsl:value-of select="$dbszjsfile"/>)}
Current JS File could not be found in the current widget document. This is probably a new JS File in the widget code 
</xsl:comment>
            
            <ca:jsfile>
				<ca:name>
					<xsl:value-of select="$dbszjsfile"/>
				</ca:name>
				<ca:description>
				</ca:description>
				<ca:jsvariables>
				</ca:jsvariables>
				<ca:jsfunctions>
				</ca:jsfunctions>
				<!--     
				<xsl:call-template name="JSvariablesBlock"/>
				<xsl:call-template name="JSfunctionsBlock"/>
				-->
			</ca:jsfile>
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>  
          </xsl:when>
        </xsl:choose>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:template>       
  
  <xsl:template name="CA_JSFileNameSearchEval">
    <xsl:for-each select="/ca2:widgetdoc/ca2:jsfiles">
      <xsl:sort select="ca2:jsfile/ca2:name"/>
      <xsl:for-each select="ca2:jsfile">
        <xsl:variable name="ca2szjsfile" select="ca2:name"/>
        
        
        <xsl:variable name="ca2posjsfile" select="position()"/>
        <xsl:variable name="dbsearch" select="contains($glob_dbjsfiles, $ca2szjsfile)"/>
        <xsl:choose>
          <xsl:when test=" string($dbsearch) = 'false' ">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
JS Files Section WARNING 1 : 
ca:jsfile/ca:name[<xsl:value-of select="$ca2posjsfile"/>] =(<xsl:value-of select="$ca2szjsfile"/>)
The Current JS File could not be found in widget code.  
The JS File name could have been manually modified.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
          </xsl:when>
          <xsl:when test=" string($dbsearch) = 'true' ">
            <xsl:for-each select="$dbdoc/db:widget/db:jsfiles"> 
              <xsl:sort select="db:jsfile/db:name"/>
              <xsl:for-each select="db:jsfile">
                
                <xsl:variable name="dbszjsfile" select="db:name"/>
                <xsl:variable name="dbposjsfile" select="position()"/>

                <xsl:if test="$ca2posjsfile = $dbposjsfile and $ca2szjsfile != $dbszjsfile">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
JS Files Section WARNING 2 : 
ca:jsfile/ca:name[node position(<xsl:value-of select="$ca2posjsfile"/>), value= <xsl:value-of select="$ca2szjsfile"/>] 
    Does NOT Equal 
db:jsfile/db:name[node position(<xsl:value-of select="$dbposjsfile"/>), value=<xsl:value-of select="$dbszjsfile"/>] 
This means that there maybe a manual edit done on the widget doc. 
Please make sure all JS File are presented correctly.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
                </xsl:if>
<!-- NO JavaScript variables values to be checked since they are manually added -->
              </xsl:for-each>
            </xsl:for-each>   
          </xsl:when>
        </xsl:choose>
        <xsl:copy-of select="/ca2:widgetdoc/ca2:jsfiles/ca2:jsfile[$ca2posjsfile]" />
      </xsl:for-each>
    </xsl:for-each>
  </xsl:template>
    
  <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~ -->
  <!-- JS FILES SECTION  (used by default index)-->
  <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~ -->
  <xsl:template name="JSfilesBlock">
    <xsl:for-each select="ca2:jsfiles"> 
      <ca:jsfiles>
        <xsl:for-each select="$dbdoc/db:widget/db:jsfiles/db:jsfile">     
			<ca:jsfile>
			  <ca:name>
				<xsl:value-of select="db:name"/>
			  </ca:name>
			  <ca:description>
			  </ca:description>
			  <ca:jsvariables>
			  </ca:jsvariables>
			  <ca:jsfunctions>
			  </ca:jsfunctions>			  
<!-- 
  			  <xsl:call-template name="JSvariablesBlock"/>
			  <xsl:call-template name="JSfunctionsBlock"/>
-->
			</ca:jsfile>
        </xsl:for-each>
      </ca:jsfiles>
    </xsl:for-each>
  </xsl:template>
 
  
	
	<xsl:template name="DefaultJSfilesBlock">
		<xsl:for-each select="$dbdoc/db:widget/db:jsfiles/db:jsfile">  
			<ca:jsfile>
				<ca:name>
					<xsl:value-of select="db:name"/>
				</ca:name>
				<ca:description>
				</ca:description>
				<ca:jsvariables>
				</ca:jsvariables>
				<ca:jsfunctions>
				</ca:jsfunctions>
				<!--     
				<xsl:call-template name="JSvariablesBlock"/>
				<xsl:call-template name="JSfunctionsBlock"/>
				-->
			</ca:jsfile>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>



