<xsl:stylesheet version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
  xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
  xmlns:ca2="http://localhost/chameleon/utils/xml/schemas"
  xmlns:db="http://localhost/chameleon/utils/xml/schemas"
  xmlns:xs="http://www.w3.org/2001/XMLSchema" 
  exclude-result-prefixes="ca2 xs">
	<!-- ~~~~~~~~~~~~~~~~~ -->
	<!-- PARAMETERS SUB SECTION  (used by manager index)-->
	<!-- ~~~~~~~~~~~~~~~~~ -->
	 <xsl:template name="ParametersUpdate"> 
		<xsl:param name="curpositon"/>
<!--		        <xsl:variable name="ca2params" select="normalize-space(/ca2:widgetdoc/ca2:jsfunctions/ca2:jsfunction[$curpositon]/ca2:parameters)"/>

        JSPos [<xsl:value-of select="$curpositon"/>] 	
-->  
			<xsl:for-each select="/ca2:widgetdoc/ca2:jsfunctions/ca2:jsfunction[$curpositon]/ca2:parameters">
				<xsl:sort select="ca2:parameter/ca2:name"/>  
				<xsl:variable name="ca2npar" select="count(ca2:parameter)"/>
				<xsl:variable name="ca2params" select="normalize-space(.)"/>	
<!--				
				ParPos [<xsl:value-of select="$curpositon"/>] 	    
				ca2Paramertstring [<xsl:value-of select="$ca2params"/>] 
-->		
					<xsl:for-each select="ca2:parameter">
						<xsl:variable name="ca2szparam" select="ca2:name"/>
						<xsl:variable name="ca2posparam" select="position()"/>
						
						<xsl:for-each select="$dbdoc/db:widget/db:jsfunctions/db:jsfunction[$curpositon]/db:parameters">
						   <xsl:sort select="db:parameter/db:name"/> 
							<xsl:variable name="dbnpar" select="count(db:parameter)"/>
							<xsl:variable name="dbparams" select="normalize-space(.)"/>
														
							<xsl:call-template name="ParametersErrors">
								<xsl:with-param name="dbnparam" select="$dbnpar"/>
								<xsl:with-param name="ca2nparam" select="$ca2npar"/>
							</xsl:call-template>
							<xsl:call-template name="DB_ParamNameSearchEval">
								<xsl:with-param name="curjsfuncpositon" select="$curpositon"/>
								<xsl:with-param name="ca2parameters" select="$ca2params"/>
								<xsl:with-param name="dbparameters" select="$dbparams"/>
							</xsl:call-template>  
							
							<!-- CA Parameter Name Evaluation -->
							<xsl:variable name="dbsearchparam" select="contains($dbparams, $ca2szparam)"/>
								
							<xsl:choose>
								<xsl:when test=" string($dbsearchparam) = 'false' ">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Parameter Section WARNING 1 : 
ca:parameter/ca:name[<xsl:value-of select="$ca2posparam"/>] =(<xsl:value-of select="$ca2szparam"/>)
The Current Parameter could not be found in widget code. 
The Parameter name could have been manually modified.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
								</xsl:when>     
								<xsl:when test=" string($dbsearchparam) = 'true' ">
									<xsl:for-each select="$dbdoc/db:widget/db:jsfunctions/db:jsfunction[$curpositon]/db:parameters"> 
										<xsl:sort select="db:parameter/db:name"/>  
										<xsl:for-each select="db:parameter">
											<xsl:variable name="dbszparam" select="db:name"/>
											<xsl:variable name="dbposparam" select="position()"/>              
											<xsl:if test="$ca2posparam = $dbposparam and $ca2szparam != $dbszparam">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Parameter Section WARNING 2 : 
ca:parameter/ca:name[node position(<xsl:value-of select="$ca2posparam"/>), value= <xsl:value-of select="$ca2szparam"/>] 
Does NOT Equal 
db:parameter/db:name[node position(<xsl:value-of select="$dbposparam"/>), value=<xsl:value-of select="$dbszparam"/>] 
This means that there maybe a manual edit done on the widget doc. 
Please make sure all Parameter are presented correctly.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
											</xsl:if>
										</xsl:for-each>
									</xsl:for-each>   
								</xsl:when>
							</xsl:choose>
							  
						</xsl:for-each>			
					</xsl:for-each>
        </xsl:for-each>
        
	</xsl:template>

<xsl:template name="CA_ParamNameSearchEval">
		<xsl:param name="curjsfuncpositon"/>
		<xsl:param name="dbparameters"/>

				
	 </xsl:template>


	<xsl:template name="ParametersErrors"> 
		<xsl:param name="dbnparam"/>
		<xsl:param name="ca2nparam"/>
		<xsl:choose>
			<xsl:when test="$dbnparam &lt; $ca2nparam">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Parameter Section ERROR 1 : 
THERE ARE LESS  DB:(IN WIDGET CODE) Parameter THAN THERE ARE CURRENT CA:(WIDGET DOC)!!! 
(db:<xsl:value-of select=" $dbnparam"/> &lt; current ca:<xsl:value-of select=" $ca2nparam"/>)
Someone has either manually edited the ca: file and added an Parameter or 
there has been a change in the widget code. 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
			</xsl:when>
			<xsl:when test="$dbnparam &gt; $ca2nparam">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Parameter Section ERROR 2 : 
THERE ARE MORE DB:(IN WIDGET CODE) Parameter THAN THERE ARE CURRENT CA:(WIDGET DOC)!!!
(db:<xsl:value-of select=" $dbnparam"/> &gt; current ca:<xsl:value-of select=" $ca2nparam"/>)
Someone has either manually edited the ca: file and removed an Parameter or 
there has been a change in the widget code. 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
			</xsl:when>   	
		</xsl:choose>
	</xsl:template>
 
	


	<xsl:template name="DB_ParamNameSearchEval"> 
		<xsl:param name="curjsfuncpositon"/>
		<xsl:param name="ca2parameters"/>
		<xsl:for-each select="db:parameter">
			<xsl:variable name="dbszparam" select="db:name"/>
			<xsl:variable name="dbposparam" select="position()"/>
			<xsl:variable name="ca2searchparam" select="contains($ca2parameters, $dbszparam)"/>          
			<xsl:choose>
				<xsl:when test=" string($ca2searchparam) = 'false' ">
				<xsl:comment>
				~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				Parameter Section NOTE 1 :{db:parameter/db:name[<xsl:value-of select="$dbposparam"/>] =(<xsl:value-of select="$dbszparam"/>)}
				JS Position[<xsl:value-of select="$curjsfuncpositon"/>] 
				Paramertstring [<xsl:value-of select="$ca2parameters"/>] 
				Current Parameter could not be found in the current widget document. This is probably a new Parameter in the widget code 
				</xsl:comment>
					<xsl:call-template name="DefaultParameterBlock"/>
				<xsl:comment>
				~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~</xsl:comment>  
				</xsl:when>
			</xsl:choose>
		</xsl:for-each>           
	</xsl:template>   
 
  <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~ -->
  <!-- PARAMETERS SUB (used by default index)-->
  <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~ -->
  <xsl:template name="ParametersBlock">
    <xsl:for-each select="db:parameters">
		<ca:parameters>
			<xsl:for-each select="db:parameter">
				<xsl:call-template name="DefaultParameterBlock"/>
			</xsl:for-each>
		</ca:parameters>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="DefaultParameterBlock">
		<ca:parameter>
			<ca:name>
				<xsl:value-of select="db:name"/>
			</ca:name>
			<ca:type>
				<ca:value>unknown</ca:value>
			</ca:type>
			<ca:default>
				<ca:value></ca:value>
			</ca:default> 
			<ca:possvalues type="list">
				<ca:minimum>
				</ca:minimum>
				<ca:maximum>
				</ca:maximum>
				<ca:value>
				</ca:value>
			</ca:possvalues>
			<ca:description>
			</ca:description>
		</ca:parameter>
  </xsl:template>
   
</xsl:stylesheet>



