<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
	xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
	xmlns:ca2="http://localhost/chameleon/utils/xml/schemas"
	xmlns:db="http://localhost/chameleon/utils/xml/schemas"
	xmlns:xs="http://www.w3.org/2001/XMLSchema" 
	exclude-result-prefixes="ca ca2 xs">
	<!-- ~~~~~~~~~~~~~~~~~~~~~~ -->
	<!--TAG STRUCTURE SECTION  (used by manager index) -->
	<!-- ~~~~~~~~~~~~~~~~~~~~~~ -->
	<xsl:template name="TagStrucuturesUpdate">
		<xsl:choose>
			<xsl:when test="$glob_szattgrp != $glob_szattgrpold">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Warning 1:A change in attribute groups has been found. Please 
review tag structure section. The Widget	code has possibly changed.
Condition String compare: New "<xsl:value-of select="$glob_szattgrp"/>" and Old "<xsl:value-of select="$glob_szattgrpold"/>"

(ca: tagstructure)  The below tagstructure block is what is currently 
defined within the current widget doc. Please review and modify if 
necessary. 	 
</xsl:comment>
				<xsl:copy-of select="ca2:tagstructures"/>
<!--
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(db:tagstructure) The below tagstructure block is what is currently 
defined by the widget code. Please update manually this section or 
fix the widget code:
</xsl:comment>
				<xsl:call-template name="TagStrucuturesBlock"/>

<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
-->
			</xsl:when>
			
			<xsl:otherwise>
				<xsl:copy-of select="ca2:tagstructures"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- ~~~~~~~~~~~~~~~~~~~~~~ -->
	<!--TAG STRUCTURE SECTION (used by default index) -->
	<!-- ~~~~~~~~~~~~~~~~~~~~~~ -->
	<xsl:template name="TagStrucuturesBlock">
		<xsl:for-each select="ca2:tagstructures">
			<ca:tagstructures>
				<!-- Tag Syntax Block -->
				<xsl:for-each select="ca2:tagstructure">
					<ca:tagstructure>
						<xsl:call-template name="AttTitleBlock"/>
						<xsl:call-template name="DescriptionBlock"/>
						<xsl:for-each select="ca2:code">
							<ca:code>
								<xsl:call-template name="TagSyntaxEval"/>
							</ca:code>
						</xsl:for-each>
					</ca:tagstructure>
				</xsl:for-each>
			</ca:tagstructures>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="TagSyntaxEval">
		<xsl:for-each select="$dbdoc/db:widget">
			<xsl:for-each select="db:attributegroups">
				<xsl:sort select="db:attributegroup"/>
				<xsl:variable name="attgrpstring" select="."/>
				<xsl:variable name="totattgrp" select="count(db:attributegroup)"/>
				<xsl:call-template name="AttTitleBlock"/>
				<xsl:call-template name="DescriptionBlock"/>
				<xsl:call-template name="StartSyntaxBlock"/>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="StartSyntaxBlock">
		<xsl:for-each select="//db:identification">
			<xsl:for-each select="db:name">
				<xsl:variable name="widgetname" select="."/>
				<ca:codeblock bold="true">
					<ca:line>
						<xsl:variable name="widgetstart" select="concat($wigtag, $widgetname)"/>
						<xsl:variable name="widgetstart1" select="concat($widgetstart, $quot)"/>
						<xsl:value-of select="$widgetstart1"/>
					</ca:line>
				</ca:codeblock>
				<ca:codeblock bold="false">
					<ca:line>   ENABLED=&quot;[TRUE|FALSE]&quot;</ca:line>
					<ca:line>   FORMINDEX=&quot;[0 &lt; integer]&quot;</ca:line>
					<xsl:choose>
						<!-- TAG CON'T: -->
						<xsl:when test="$dbdoc/db:widget/db:attributes !='' or $glob_szattgrp != 'base'">
							<ca:line>   VISIBLE=&quot;[TRUE|FALSE]&quot;	</ca:line>
							<ca:line/>
						</xsl:when>
						<!-- END TAG: At Base Attributes -->
						<xsl:when test="$dbdoc/db:widget/db:attributes='' and $glob_szattgrp = 'base' ">
							<!-- end widget tag -->
							<ca:line>   VISIBLE=&quot;[TRUE|FALSE]&quot;<xsl:value-of select="$tagend"/>
							</ca:line>
							<ca:line/>
						</xsl:when>
					</xsl:choose>
				</ca:codeblock>
				<!-- Close Block for Base -->
				<xsl:choose>
					<!-- TAG CON't: Build Widget Specific Attributes -->
					<xsl:when test="$dbdoc/db:widget/db:attributes/db:attribute[last() &gt; 0]">
						<ca:codeblock bold="false">
							<ca:line>
								<xsl:variable name="commentResult" select="concat($frontspace, $comment1)"/>
								<xsl:variable name="commentResult1" select="concat($commentResult, $widgetname)"/>
								<xsl:variable name="commentResult2" select="concat($commentResult1, $comment2)"/>
								<xsl:value-of select="$commentResult2"/>
							</ca:line>
							<ca:line/>
							<!-- TAG CON't: Add widget specific widget tags-->
							<xsl:call-template name="DefineCodeBlock"/>
							<!--TAG CON't:  Add Attribute Group to widget tag -->
							<xsl:call-template name="AddAttGrpSyntaxBlock"/>
						</ca:codeblock>
					</xsl:when>
					<xsl:otherwise>
						<!-- TAG CON't: Add Attribute Group to widget tag -->
						<xsl:call-template name="AddAttGrpSyntaxBlock"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="DefineCodeBlock">
		<!-- TAG CON't: Define Required Attributes during Frist Loop -->
		<ca:codeblock bold="true">
			<xsl:for-each select="$dbdoc/db:widget">
				<xsl:for-each select="db:attributes">
					<xsl:for-each select="db:attribute">
						<xsl:sort select="db:class"/>
						<xsl:variable name="attribute" select="."/>
						<xsl:variable name="totattnum" select="last()"/>
						<xsl:variable name="curattnum" select="position()"/>
						<xsl:for-each select="db:class">
							<xsl:variable name="class" select="."/>
							<xsl:if test="$class='Required'">
								<xsl:call-template name="SingleLineBlock">
									<xsl:with-param name="att" select="$attribute"/>
									<xsl:with-param name="atotal" select="$totattnum"/>
									<xsl:with-param name="acurr" select="$curattnum"/>
								</xsl:call-template>
							</xsl:if>
						</xsl:for-each>
					</xsl:for-each>
				</xsl:for-each>
			</xsl:for-each>
		</ca:codeblock>
		<!-- TAG CON't: Define Not Required Attributes during Second Loop -->
		<ca:codeblock bold="false">
			<xsl:for-each select="$dbdoc/db:widget">
				<xsl:for-each select="db:attributes">
					<xsl:for-each select="db:attribute">
						<xsl:sort select="db:class"/>
						<xsl:variable name="attribute" select="."/>
						<xsl:variable name="totattnum" select="last()"/>
						<xsl:variable name="curattnum" select="position()"/>
						<xsl:for-each select="db:class">
							<xsl:variable name="class" select="."/>
							<xsl:if test="$class!='Required'">
								<xsl:call-template name="SingleLineBlock">
									<xsl:with-param name="att" select="$attribute"/>
									<xsl:with-param name="atotal" select="$totattnum"/>
									<xsl:with-param name="acurr" select="$curattnum"/>
								</xsl:call-template>
							</xsl:if>
						</xsl:for-each>
					</xsl:for-each>
				</xsl:for-each>
			</xsl:for-each>
		</ca:codeblock>
	</xsl:template>
	<xsl:template name="SingleLineBlock">
		<xsl:param name="att"/>
		<xsl:param name="atotal"/>
		<xsl:param name="acurr"/>
		<xsl:for-each select="$att/db:type">
			<xsl:variable name="type" select="."/>
			<xsl:for-each select="$att/db:name">
				<xsl:variable name="name" select="."/>
				<ca:line>
					<xsl:variable name="concatResult" select="concat($frontspace, $name)"/>
					<xsl:variable name="concatResult1" select="concat($concatResult, $syntax1)"/>
					<xsl:variable name="concatResult2" select="concat($concatResult1, $type)"/>
					<xsl:variable name="concatResult3" select="concat($concatResult2, $syntax2)"/>
					<xsl:choose>
						<!-- TAG ENDS: AT Widget Specific Attributes -->
						<xsl:when test="$atotal = $acurr and $glob_szattgrp='base'">
							<xsl:variable name="concatResult4" select="concat($concatResult3, $tagend)"/>
							<xsl:value-of select="$concatResult4"/>
						</xsl:when>
						<!-- TAG CON'T: -->
						<xsl:otherwise>
							<xsl:value-of select="$concatResult3"/>
						</xsl:otherwise>
					</xsl:choose>
				</ca:line>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="AddAttGrpSyntaxBlock">
		<xsl:choose>
			<xsl:when test="$glob_szattgrp = 'basebutton' ">
				<xsl:call-template name="ButtonAttGrpSyntaxBlock"/>
			</xsl:when>
			<xsl:when test="$glob_szattgrp = 'basebuttonlabel' ">
				<xsl:call-template name="LabelAttGrpSyntaxBlock"/>
				<xsl:call-template name="ButtonAttGrpSyntaxBlock"/>
			</xsl:when>
			<xsl:when test="$glob_szattgrp = 'basebuttonnavtool' ">
				<xsl:call-template name="NavAttGrpSyntaxBlock"/>
				<xsl:call-template name="ButtonAttGrpSyntaxBlock"/>
			</xsl:when>
			<xsl:when test="$glob_szattgrp = 'basebuttonpopup' ">
				<xsl:call-template name="PopupAttGrpSyntaxBlock"/>
				<xsl:call-template name="ButtonAttGrpSyntaxBlock"/>
			</xsl:when>
			<xsl:when test="$glob_szattgrp = 'basebuttonlabelnavtool' ">
				<xsl:call-template name="LabelAttGrpSyntaxBlock"/>
				<xsl:call-template name="NavAttGrpSyntaxBlock"/>
				<xsl:call-template name="ButtonAttGrpSyntaxBlock"/>
			</xsl:when>
			<xsl:when test="$glob_szattgrp = 'basebuttonlabelpopup' ">
				<xsl:call-template name="PopupAttGrpSyntaxBlock"/>
				<xsl:call-template name="LabelAttGrpSyntaxBlock"/>
				<xsl:call-template name="ButtonAttGrpSyntaxBlock"/>
			</xsl:when>
			<xsl:when test="$glob_szattgrp = 'basebuttonnavtoolpopup' ">
				<xsl:call-template name="PopupAttGrpSyntaxBlock"/>
				<xsl:call-template name="NavAttGrpSyntaxBlock"/>
				<xsl:call-template name="ButtonAttGrpSyntaxBlock"/>
			</xsl:when>
			<xsl:when test="$glob_szattgrp = 'basebuttonlabelnavtoolpopup' ">
				<xsl:call-template name="PopupAttGrpSyntaxBlock"/>
				<xsl:call-template name="LabelAttGrpSyntaxBlock"/>
				<xsl:call-template name="NavAttGrpSyntaxBlock"/>
				<xsl:call-template name="ButtonAttGrpSyntaxBlock"/>
			</xsl:when>
			<xsl:when test="$glob_szattgrp = 'baselabel' ">
				<xsl:call-template name="LabelAttGrpSyntaxBlock"/>
			</xsl:when>
			<xsl:when test="$glob_szattgrp = 'baselabelpopup' ">
				<xsl:call-template name="PopupAttGrpSyntaxBlock"/>
				<xsl:call-template name="LabelAttGrpSyntaxBlock"/>
			</xsl:when>
			<xsl:when test="$glob_szattgrp = 'basenavtool' ">
				<xsl:call-template name="NavAttGrpSyntaxBlock"/>
			</xsl:when>
			<xsl:otherwise>
				ERROR: NO TAG SYNTAX MATCH WAS MADE WITH THE FOLLOWING ATTRIBUTEGROUPS VALUE: (<xsl:value-of select="$glob_szattgrp"/>)
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="LabelAttGrpSyntaxBlock">
		<ca:codeblock bold="false">
			<ca:line/>
			<ca:line>   &lt;!-- Label Attribute Group--&gt;</ca:line>
			<ca:line/>
			<ca:line>   LABEL="[string]"</ca:line>
			<ca:line>   LABELCLASS="[string]"</ca:line>
			<ca:line>   LABELHALIGN="[LEFT|CENTER|RIGHT]"</ca:line>
			<ca:line>   LABELPOSITION="[0 &lt; integer &lt; 8]"</ca:line>
			<ca:line>   LABELSTYLE="[path]"</ca:line>
			<!--TAG END: Condition -->
			<ca:line>   LABELVALIGN="[TOP|MIDDLE|BOTTOM]"<xsl:if test="$glob_szattgrp = 'baselabel' or $glob_szattgrp = 'baselabelpopup' ">
					<xsl:value-of select="$tagend"/>
				</xsl:if>
			</ca:line>
		</ca:codeblock>
	</xsl:template>
	<xsl:template name="PopupAttGrpSyntaxBlock">
		<ca:codeblock bold="false">
			<ca:line/>
			<ca:line>   &lt;!-- Popup Attribute Group--&gt;</ca:line>
			<ca:line/>
		</ca:codeblock>
		<ca:codeblock bold="true">
			<ca:line>   POPUPHEIGHT="[0 &lt; integer]"</ca:line>
			<ca:line>   POPUPWIDTH="[0 &lt; integer]"</ca:line>
		</ca:codeblock>
		<ca:codeblock bold="false">
			<ca:line>   MENUBAR="[TRUE|FALSE]"</ca:line>
			<ca:line>   POPUPSTYLERESOURCE="[string]"</ca:line>
			<ca:line>   RESIZABLE="[TRUE|FALSE]"</ca:line>
			<ca:line>   SCROLLBARS="[TRUE|FALSE]"</ca:line>
			<ca:line>   STATUS="[TRUE|FALSE]"</ca:line>
			<ca:line>   TOOLBAR="[TRUE|FALSE]"</ca:line>
		</ca:codeblock>
	</xsl:template>
	<xsl:template name="NavAttGrpSyntaxBlock">
		<ca:codeblock bold="false">
			<ca:line/>
			<ca:line>   &lt;!-- Navigation Attributes --&gt;</ca:line>
			<ca:line/>
			<ca:line>   CURSORTYPE="[string]"</ca:line>
			<ca:line>   DEFAULT="[TRUE|FALSE]"</ca:line>
			<ca:line>   MAPID="[string]"</ca:line>
			<ca:line>   WIDGETSTYLE="[string]"<xsl:if test="$glob_szattgrp = 'basenavtool'">
					<xsl:value-of select="$tagend"/>
				</xsl:if>
			</ca:line>
		</ca:codeblock>
	</xsl:template>
	<xsl:template name="ButtonAttGrpSyntaxBlock">
		<ca:codeblock bold="false">
			<ca:line/>
			<ca:line>   &lt;!-- Button Attribute Group--&gt;</ca:line>
			<ca:line/>
			<ca:line>   BACKGROUNDIMAGE=&quot;[path]&quot;</ca:line>
			<ca:line>   DEFAULT=&quot;[TRUE|FALSE]&quot;</ca:line>
			<ca:line>   IMAGE=&quot;[path]&quot;</ca:line>
			<ca:line>   IMAGEHEIGHT=&quot;[integer]&quot;</ca:line>
			<ca:line>   IMAGETIP=&quot;[string]&quot;</ca:line>
			<ca:line>   IMAGEWIDTH=&quot;[integer]&quot;</ca:line>
			<ca:line>   LABELALIGN=&quot;[LEFT|CENTER|RIGHT]&quot;</ca:line>
			<ca:line>   LABELANTIALIAS=&quot;[TRUE|FALSE]&quot;</ca:line>
			<ca:line>   LABELCOLOR=&quot;[#RRGGBB]&quot;</ca:line>
			<ca:line>   LABELFONT=&quot;[string]&quot;</ca:line>
			<ca:line>   LABELFONTSIZE=&quot;[0 &lt; integer]&quot;</ca:line>
			<ca:line>   ONCLICK=&quot;[string]&quot;</ca:line>
			<ca:line>   STYLERESOURCE=&quot;[string]&quot;</ca:line>
			<ca:line>   TEXTBUTTONBORDER=&quot;[path]&quot;</ca:line>
			<ca:line>   TEXTBUTTONBORDER_BOTTOM_IMAGE=&quot;[path]&quot;</ca:line>
			<ca:line>   TEXTBUTTONBORDER_BOTTOMLEFT_IMAGE=&quot;[path]&quot;</ca:line>
			<ca:line>   TEXTBUTTONBORDER_BOTTOMRIGHT_IMAGE=&quot;[path]&quot;</ca:line>
			<ca:line>   TEXTBUTTONBORDER_LEFT_IMAGE=&quot;[path]&quot;</ca:line>
			<ca:line>   TEXTBUTTONBORDER_RIGHT_IMAGE=&quot;[path]&quot;</ca:line>
			<ca:line>   TEXTBUTTONBORDER_TOP_IMAGE=&quot;[path]&quot;</ca:line>
			<ca:line>   TEXTBUTTONBORDER_TOPLEFT_IMAGE=&quot;[path]&quot;</ca:line>
			<ca:line>   TEXTBUTTONBORDER_TOPRIGHT_IMAGE=&quot;[path]&quot;</ca:line>
			<ca:line>   TEXTBUTTONCOLOR=&quot;[#RRGGBB]&quot;</ca:line>
			<ca:line>   TEXTBUTTONNUDGE=&quot;[integer]&quot;</ca:line>
			<ca:line>   TEXTBUTTONPADDING=&quot;[0 &lt; integer]&quot;</ca:line>
			<ca:line>   TOOLSET=&quot;[string]&quot;</ca:line>
			<ca:line>   USETEXTBUTTONCACHE=&quot;[TRUE|FALSE]&quot;&gt;</ca:line>
			<ca:line/>
			<ca:line>   &lt;!-- Button Subtag Group example--&gt;</ca:line>
			<ca:line>   &lt;!-- this can include any of the above parameters --&gt;</ca:line>
			<ca:line/>
			<ca:line>   &lt;IMAGE STATE=&quot;[NORMAL|SELECTED|HOVER|DISABLED]&quot;</ca:line>
			<ca:line>      IMAGE=&quot;[path]&quot; LABEL=&quot;[string]&quot;<xsl:value-of select="$tagend"/>
			</ca:line>
		</ca:codeblock>
		<ca:codeblock bold="true">
			<ca:line>&lt;/CWC&gt;</ca:line>
		</ca:codeblock>
	</xsl:template>
</xsl:stylesheet>
