<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
	xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
	xmlns:ca2="http://localhost/chameleon/utils/xml/schemas"
	xmlns:db="http://localhost/chameleon/utils/xml/schemas"
	xmlns:xs="http://www.w3.org/2001/XMLSchema" 
	exclude-result-prefixes="ca2 xs">
  <!-- ~~~~~~~~~~~~~~~~~ -->
  <!-- WIDGET ATTRIBUTESSECTION  (used by manager index)-->
  <!-- ~~~~~~~~~~~~~~~~~ -->
  <xsl:template name="WidgetAttributesUpdate"> 
	
	<xsl:variable name="dbnatt" select="count($dbdoc/db:widget/db:attributes/db:attribute)"/>
   	<xsl:variable name="ca2natt" select="count(ca2:widgettag/ca2:attribute)"/>
<!--
	<xsl:comment>
     ( new db:<xsl:value-of select=" $dbnatt"/> and ca2: <xsl:value-of select=" $ca2natt"/>)
     </xsl:comment>
-->
	<xsl:choose>
<!--
		<xsl:when test="$dbnatt=$ca2natt">
			<xsl:call-template name="DB_AttNameSearchEval"/>
			<xsl:call-template name="CA_AttNameSearchEval"/>
		</xsl:when>
-->
		<xsl:when test="$dbnatt &lt; $ca2natt">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Attribtue Section ERROR 1 : 
THERE ARE LESS  DB:(IN WIDGET CODE) ATTRIBUTE THAN THERE ARE CURRENT CA:(WIDGET DOC)!!! 
(db:<xsl:value-of select=" $dbnatt"/> &lt; current ca:<xsl:value-of select=" $ca2natt"/>)
Someone has either manually edited the ca: file and added an attribute or 
there has been a change in the widget code. 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
		</xsl:when>
		<xsl:when test="$dbnatt &gt; $ca2natt">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Attribtue Section ERROR 2 : 
THERE ARE MORE DB:(IN WIDGET CODE) ATTRIBUTE THAN THERE ARE CURRENT CA:(WIDGET DOC)!!!
(db:<xsl:value-of select=" $dbnatt"/> &gt; current ca:<xsl:value-of select=" $ca2natt"/>)
Someone has either manually edited the ca: file and removed an attribute or 
there has been a change in the widget code. 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
		</xsl:when>		
		
	</xsl:choose>
	<ca:widgetag>
			<xsl:copy-of select="ca2:widgettag/@title"/>
     		
     		<xsl:call-template name="DB_AttNameSearchEval"/>
			<xsl:call-template name="CA_AttNameSearchEval"/>	

			<xsl:copy-of select="ca2:widgettag/ca2:subtag"/>
	</ca:widgetag>
  </xsl:template>
  
  	<xsl:template name="DB_AttNameSearchEval"> 

		<xsl:for-each select="$dbdoc/db:widget/db:attributes">	
			<xsl:sort select="db:attribute/db:name"/>		
			<xsl:for-each select="db:attribute">
				<xsl:variable name="dbszatt" select="db:name"/>
				<xsl:variable name="dbposatt" select="position()"/>
				<xsl:variable name="ca2search" select="contains($glob_ca2attributes, $dbszatt)"/>
				<xsl:choose>
					<xsl:when test=" string($ca2search) = 'false' ">
					
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Attribtue Section NOTE 1 :{db:attribute/ca:name[<xsl:value-of select="$dbposatt"/>] =(<xsl:value-of select="$dbszatt"/>)}
Current Attribute could not be found in the current widget document. This is probably a new attribute in the widget code 
</xsl:comment>
						
						<xsl:call-template name="DefaultAttBlock"/>
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>	
					</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>				
	
	<xsl:template name="CA_AttNameSearchEval">
		<xsl:for-each select="/ca2:widgetdoc/ca2:widgettag">
			<xsl:sort select="ca2:attribute/ca2:name"/>	
			<xsl:for-each select="ca2:attribute">

				<xsl:variable name="vca2szatt" select="ca2:name"/>
				<xsl:variable name="vca2sztype" select="ca2:type/ca2:value"/>
				<xsl:variable name="vca2szclass" select="ca2:class/ca2:value"/>
				<xsl:variable name="vca2szdefault" select="string(ca2:default/ca2:value)"/>
				<xsl:variable name="vca2szpossval" select="string(ca2:possvalues)"/>
				<xsl:variable name="vca2szposstyp" select="ca2:possvalues/@type"/>
				
				<xsl:variable name="ca2posatt" select="position()"/>
				<xsl:variable name="dbsearch" select="contains($glob_dbattributes, $vca2szatt)"/>
				<xsl:choose>
					<xsl:when test=" string($dbsearch) = 'false' ">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Attribtue Section WARNING 1 : 
ca:attribute/ca:name[<xsl:value-of select="$ca2posatt"/>] =(<xsl:value-of select="$ca2szatt"/>)
The Current Attribute could not be found in widget code.	
The attribute name could have been manually modified.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
					</xsl:when>
					<xsl:when test=" string($dbsearch) = 'true' ">
						<xsl:for-each select="$dbdoc/db:widget/db:attributes">	
							<xsl:sort select="db:attribute/db:name"/>	
							<xsl:for-each select="db:attribute">
								
								<xsl:variable name="vdbszatt" select="db:name"/>
								<xsl:variable name="vdbsztype" select="db:type"/>
								<xsl:variable name="vdbszclass" select="db:class"/>
								<xsl:variable name="vdbszdefault" select="string(db:default)"/>
								<xsl:variable name="vdbszpossval" select="string(db:possvalues)"/>
								<xsl:variable name="vdbszposstyp" select="ca2:possvalues/@type"/>

								<xsl:variable name="dbposatt" select="position()"/>
								<xsl:if test="$ca2posatt = $dbposatt and $vca2szatt != $vdbszatt">
<xsl:comment>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Attribtue Section WARNING 2 : 
ca:attribute/ca:name[node position(<xsl:value-of select="$ca2posatt"/>), value= <xsl:value-of select="$vca2szatt"/>] 
		Does NOT Equal 
db:attribute/db:name[node position(<xsl:value-of select="$dbposatt"/>), value=<xsl:value-of select="$vdbszatt"/>] 
This means that there maybe a manual edit done on the widget doc. 
Please make sure all attributes are presented correctly.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
</xsl:comment>
								</xsl:if>
								<xsl:call-template name="AttCheckEval">
									<!-- db: widget code attribute values -->
									<xsl:with-param name="dbszatt" select="$vdbszatt"/>
									<xsl:with-param name="dbsztype" select="$vdbsztype"/>
									<xsl:with-param name="dbszclass" select="$vdbszclass"/>
									<xsl:with-param name="dbszdefault" select="$vdbszdefault"/>
									<xsl:with-param name="dbszpossval" select="$vdbszpossval"/>
									<xsl:with-param name="dbszposstyp" select="$vdbszposstyp"/>

									<!-- ca: widget doc attribute values -->
									<xsl:with-param name="ca2szatt" select="$vca2szatt"/>
									<xsl:with-param name="ca2sztype" select="$vca2sztype"/>
									<xsl:with-param name="ca2szclass" select="$vca2szclass"/>
									<xsl:with-param name="ca2szdefault" select="$vca2szdefault"/>
									<xsl:with-param name="ca2szpossval" select="$vca2szpossval"/>
									<xsl:with-param name="ca2szposstyp" select="$vca2szposstyp"/>
								</xsl:call-template>
							</xsl:for-each>
						</xsl:for-each>		
					</xsl:when>
				</xsl:choose>
				<xsl:copy-of select="/ca2:widgetdoc/ca2:widgettag/ca2:attribute[$ca2posatt]" />
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="AttCheckEval"> 
		<!-- db: widget code attribute values -->
		<xsl:param name="dbszatt" />
		<xsl:param name="dbsztype" />
		<xsl:param name="dbszclass" />
		<xsl:param name="dbszdefault" />
		<xsl:param name="dbszpossval" />
		<xsl:param name="dbszposstyp" />
			
		<!-- ca: widget doc attribute values -->
		<xsl:param name="ca2szatt" />
		<xsl:param name="ca2sztype" />
		<xsl:param name="ca2szclass"/>
		<xsl:param name="ca2szdefault" />
		<xsl:param name="ca2szpossval" />
		<xsl:param name="ca2szposstyp" />
<!--		db: widget code attribute values 
		!!=<xsl:value-of select="$dbszatt" /> !-
		<xsl:value-of select="$dbsztype" />!-
		<xsl:value-of select="$dbszclass" />!-
		<xsl:value-of select="$dbszdefault" />!-
		<xsl:value-of select="$dbszpossval" />!-
		<xsl:value-of select="$dbszposstyp" />=!!	
-->		
		<!-- XXXXXXXXXXXXXXXXXXXXX CHECK XXXXXXXX -->		
		<!-- check type -->	
		<xsl:if test="$ca2szatt = $dbszatt and $dbsztype != $ca2sztype">
<xsl:comment>
Attribtue Section NOTE 2 : 
Attribute:[<xsl:value-of select="$ca2szatt"/>] = db:type (<xsl:value-of select="$dbsztype"/>) != ca:type/ca:value (<xsl:value-of select="$ca2sztype"/>) 
</xsl:comment>
		</xsl:if>
		
		<!-- check class -->
		<xsl:if test="$ca2szatt = $dbszatt and $dbszclass != $ca2szclass">
<xsl:comment>
Attribtue Section NOTE 3 : 
Attribute:[<xsl:value-of select="$ca2szatt"/>] = db:class (<xsl:value-of select="$dbszclass"/>) != ca:class/ca:value (<xsl:value-of select="$ca2szclass"/>) 
</xsl:comment>
		</xsl:if>
		
		<!-- check default -->
		<xsl:if test="$ca2szatt = $dbszatt and $dbszdefault != $ca2szdefault">
<xsl:comment>
Attribtue Section NOTE 4 : 
Attribute:[<xsl:value-of select="$ca2szatt"/>] = db:default (<xsl:value-of select="$dbszdefault"/>) != ca:default/ca:value (<xsl:value-of select="$ca2szdefault"/>) 
</xsl:comment>
		</xsl:if>	
									
		<!-- check possvalues -->
		<xsl:if test="$ca2szatt = $dbszatt and $dbszpossval != $ca2szpossval">
<xsl:comment>
Attribtue Section NOTE 5 :  
Attribute:[<xsl:value-of select="$ca2szatt"/>] = db:possvalues (<xsl:value-of select="$dbszpossval"/>) != ca:possvalues (<xsl:value-of select="$ca2szpossval"/>) 
</xsl:comment>
		</xsl:if>	
		
		<!-- check possvalues @type -->
		<xsl:if test="$ca2szatt = $dbszatt and $dbszposstyp != $ca2szposstyp">
<xsl:comment>
Attribtue Section WARNING 8 : 
Attribute:[<xsl:value-of select="$ca2szatt"/>] = db:possvalues/@type (<xsl:value-of select="$dbszposstyp"/>) != ca:possvalues/@type (<xsl:value-of select="$ca2szposstyp"/>) 
</xsl:comment>
		</xsl:if>	
		<!-- XXXXXXXXXXXXXXXXXXXXX CHECK END XXXXXXXX -->
</xsl:template>
 

  
  <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~ -->
  <!--  WIDGET ATTRIBUTES SECTION  (used by default index)-->
  <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~ -->
	<xsl:template name="WidgetAttributesBlock">
		<xsl:for-each select="ca2:widgettag">	
			<ca:widgettag>
				<xsl:for-each select="$dbdoc/db:widget/db:attributes/db:attribute">			
					<xsl:call-template name="DefaultAttBlock"/>
				</xsl:for-each>
				<xsl:call-template name="SubTagBlock"/>
			</ca:widgettag>
		</xsl:for-each>
	</xsl:template>



  <xsl:template name="DefaultAttBlock"> 
		<ca:attribute>
			<ca:name>
				<xsl:value-of select="db:name"/>
			</ca:name>
			<ca:type>
				<ca:value>
					<xsl:value-of select="db:type"/>
				</ca:value>
			</ca:type>
			<ca:class>
				<ca:value>
					<xsl:value-of select="db:class"/>
				</ca:value>
			</ca:class>
			<ca:default>
				<ca:value>
					<xsl:value-of select="db:default"/>
				</ca:value>
			</ca:default>	
			<xsl:call-template name="PossValuesBlock"/>
			<ca:description></ca:description>
		</ca:attribute>	  
</xsl:template>  
	
	<xsl:template name="PossValuesBlock">
		<xsl:for-each select="db:possvalues">
			<ca:possvalues>
				<xsl:variable name="posstype" select="@type"/>
				<xsl:attribute name="type">
					<xsl:value-of select="$posstype"/>
				</xsl:attribute>
				<xsl:choose>
					<xsl:when test="$posstype=&quot;range&quot;">
						<ca:minimum>
							<xsl:value-of select="db:minimum"/>
						</ca:minimum>
						<ca:maximum>
							<xsl:value-of select="db:maximum"/>
						</ca:maximum>			
					</xsl:when>
					<xsl:when test="$posstype=&quot;list&quot;">
						<xsl:for-each select="db:value">
							<ca:value>
								<xsl:value-of select="."/>
							</ca:value>
						</xsl:for-each>					
					</xsl:when>
				</xsl:choose>
			</ca:possvalues>
		</xsl:for-each>	
	</xsl:template>

		<xsl:template name="SubTagBlock">		
				<xsl:for-each select="ca2:subtag">
					<ca:subtag>
						<ca:name>
						</ca:name>
						<ca:type>
							<ca:value>
								<xsl:value-of select="ca2:value"/>
							</ca:value>
						</ca:type>
						<ca:class>
							<ca:value>
							</ca:value>
						</ca:class>
						<ca:description>
						</ca:description>
						<ca:attribute>
								<ca:name>
								</ca:name>
								<ca:type>
									<ca:value>
									</ca:value>
								</ca:type>
								<ca:class>
									<ca:value>
									</ca:value>
								</ca:class>
								<ca:default>
										<ca:value>
										</ca:value>
								</ca:default>
								<ca:possvalues type="">
										<ca:minimum>
										</ca:minimum>
										<ca:maximum>
										</ca:maximum>
										<ca:value>
										</ca:value>
								</ca:possvalues>
								<ca:description>
								</ca:description>
						</ca:attribute>
					</ca:subtag>	
				</xsl:for-each>
	   </xsl:template>						

</xsl:stylesheet>

