<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
  xmlns:xs="http://www.w3.org/2001/XMLSchema" 
  xmlns:fn="http://www.w3.org/2004/07/xpath-functions" 
  xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <xsl:output version="1.0" encoding="utf-8" omit-xml-declaration="no" indent="no" media-type="text/html"/>


  <!-- Main Title For Description Section -->
  <xsl:template name="AttributeGroupTitle">
    <div class="MainHeading">         
      <a>
        <xsl:attribute name="name"><xsl:text disable-output-escaping="yes">#_tagsyntax</xsl:text></xsl:attribute>
        <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:attributegroups/@title" />
      </a>
    </div>  
  </xsl:template>
  <!-- Attribute Group List Section -->
  <xsl:template name="AttributeGroupList">
    <xsl:for-each select="ca:attributegroups">
      <div class="Section">  
        <xsl:for-each select="ca:description">
          <div class="SectionConten">       
            <xsl:apply-templates />
          </div>    
        </xsl:for-each>
      </div>                
        <xsl:for-each select="ca:attributegroup">
          <xsl:for-each select="ca:name">
            <div class="AttributeGroupList">            
              <ul style="margin-bottom:0; margin-top:0; ">
                <li>
                  <a>
                    <xsl:attribute name="href">
<!--                      <xsl:text disable-output-escaping="yes">../../docs/html/widgets/</xsl:text> -->
                      <xsl:value-of select="."/>
                      <xsl:text disable-output-escaping="yes">_attribute_group.en-ca.doc.html</xsl:text>
                    </xsl:attribute>
                    <xsl:apply-templates/>
                  </a>
                </li>
              </ul>
            </div>              
          </xsl:for-each>
        </xsl:for-each>     
    </xsl:for-each>
  </xsl:template>
</xsl:stylesheet> 