<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
  xmlns:xs="http://www.w3.org/2001/XMLSchema" 
  xmlns:fn="http://www.w3.org/2004/07/xpath-functions" 
  xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  
  <!--DOCUMENT  FLAVOURS  -->
  <xsl:include href="attributegroupdoc_all.xslt"/>
  <xsl:include href="widgetdoc_all.xslt"/>
  <!-- SECTIONS OF A DOCTUMENT -->
  <xsl:include href="identification_sec.xslt"/>
  <xsl:include href="descriptions_sec.xslt"/>
  <xsl:include href="tagsyntax_sec.xslt"/>  
  <xsl:include href="examples_sec.xslt"/> 
  <xsl:include href="attributegroups_sec.xslt"/>    
  <xsl:include href="attributes_sec.xslt"/> 
  <xsl:include href="formelements_sec.xslt"/> 
  <xsl:include href="jsvariables_sec.xslt"/>  
  <xsl:include href="jsfunctions_sec.xslt"/>  
  <xsl:include href="jsfiles_sec.xslt"/>    
  <xsl:include href="listenedjsapievents_sec.xslt"/>    
  <xsl:include href="widgetevents_sec.xslt"/>     
  <xsl:include href="errors_sec.xslt"/>     
  <xsl:output version="1.0" encoding="utf-8" omit-xml-declaration="no" indent="no" media-type="text/html"/>
  <!--   
  <xsl:param name="alang" select="ca:attributegroupdoc/ca:docinfo/ca:language/ca:value"></xsl:param>  
  <xsl:variable name="wlang"  select="ca:widgetdoc/ca:docinfo/ca:language/ca:value" > </xsl:variable>

  
  <xsl:variable name="wl" >
    <xsl:apply-templates select="$wlang"/>_testing
  </xsl:variable>
-->
  <xsl:template match="/">
<!--
<xsl:apply-templates select="//ca:docinfo/ca:language/ca:value" /> <br />    
<xsl:apply-templates select="//ca:docinfo/ca:language/ca:value" />   

    <xsl:apply-templates select="$wl"/>

 <br /> <xsl:apply-templates select="$alang"/>
   -->
  <html>
    <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"/>
    <head>
      <title>Chameleon Widget Document</title>
      <link href="autodocs.css" rel="stylesheet" type="text/css"/>
    </head>
    <body>  
      <div class="Chapter">
      <xsl:choose>
        <xsl:when test="ca:widgetdoc/ca:identification/ca:name/ca:value != &quot;&quot;">
            <!-- CALL TO ALL WIDGET DOC CONTENT -->
          <xsl:call-template name="WIGETDOC_ALL"/>  
        </xsl:when>
        <xsl:when test="ca:attributegroupdoc/ca:identification/ca:name/ca:value != &quot;&quot;">
            <!-- CALL TO ALL ATTRIBUTE GROUP DOC CONTENT -->
          <xsl:call-template name="ATTRIBUTEGROUPDOC_ALL"/>
        </xsl:when>
        <xsl:otherwise>
          Help Viewer Tanslation ERROR: Current XML doc is not properly defined and does not work with the current condition. Make sure schema is valid.
        </xsl:otherwise>
      </xsl:choose> 
      </div>  
    </body>
  </html> 
  </xsl:template>
    
</xsl:stylesheet>


