<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
  xmlns:xs="http://www.w3.org/2001/XMLSchema" 
  xmlns:fn="http://www.w3.org/2004/07/xpath-functions" 
  xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <xsl:output version="1.0" encoding="utf-8" omit-xml-declaration="no" indent="no" media-type="text/html"/>
  
   <!--EXAMPLE MAIN SECTION -->
  <xsl:template name="ExamplesMainSection"> 
     <xsl:call-template name="ExamplesTitle"/>
    <xsl:for-each select="ca:examples">
    <!--
       <xsl:choose>
        <xsl:when test="ca:widgetexamples/ca:example/@title != &quot;&quot; and ca:sharedresourceexamples/ca:example/@title != &quot;&quot; and ca:scriptexamples/ca:example/@title != &quot;&quot; and ca:sampleapps/ca:sampleapp/ca:name != &quot;&quot;">
  -->       
          <!-- Widget Examples -->         
          <xsl:call-template name="WidgetExamples"/>    
          <!-- Shared Resource Examples -->         
          <xsl:call-template name="SharedResourceExamples"/>    
          <!-- Script Examples -->         
          <xsl:call-template name="ScriptExamples"/>    
            <!-- Sample Applications -->         
          <xsl:call-template name="SampleApplications"/>  
<!--    
        </xsl:when>
        <xsl:otherwise>
          <div class="Section">
--> 
        <!-- Example Title -->
<!--
            <div class="SectionHeading">
              Not Available.
            </div>
          </div>
        </xsl:otherwise>        
      </xsl:choose>
-->
    </xsl:for-each> 
  </xsl:template>

  <!-- Main Title For Section -->
  <xsl:template name="ExamplesTitle">
      <div class="MainHeading">
        <a>
          <xsl:attribute name="name"><xsl:text disable-output-escaping="yes">#_examples</xsl:text></xsl:attribute>
            <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:examples/@title" />
        </a>
      </div>      
  </xsl:template>
  <!-- Widget Example Section -->
  <xsl:template name="WidgetExamples">
    <xsl:if test="ca:widgetexamples/ca:example/@title != &quot;&quot;">
        <div class="Section">
        <div class="SectionHeading">          
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:examples/ca:widgetexamples/@title"/>
        </div>          
        <xsl:for-each select="ca:widgetexamples">
          <xsl:call-template name="Example"/>
        </xsl:for-each>
      </div>
    </xsl:if>
  </xsl:template>
  <!-- Shared Resource Example Section -->
  <xsl:template name="SharedResourceExamples">
    <xsl:if test="ca:sharedresourceexamples/ca:example/@title != &quot;&quot;"> 
      <xsl:for-each select="ca:sharedresourceexamples">
        <div class="Section">
          <div class="SectionHeading">          
            <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:examples/ca:sharedresourceexamples/@title"/>    
          </div>  
          <xsl:call-template name="Example"/>
        </div>
      </xsl:for-each>
    </xsl:if>
  </xsl:template> 
  <!-- Shared Resource Example Section -->
  <xsl:template name="ScriptExamples">
    <xsl:if test="ca:scriptexamples/ca:example/@title != &quot;&quot;">   
      <div class="Section">   
        <div class="SectionHeading"> 
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:examples/ca:scriptexamples/@title"/>
        </div>            
        <xsl:for-each select="ca:scriptexamples">
          <xsl:call-template name="Example"/>
        </xsl:for-each>
      </div>
    </xsl:if>
  </xsl:template>   
  <!--Example Section Block-->
  <xsl:template name="Example">
    <xsl:for-each select="ca:example">  
      <div class="SubSection">            
          <xsl:for-each select="@title">
          <div class="ExampleHeading">                  
            <xsl:value-of select="." />
          </div>        
        </xsl:for-each>
              
        <xsl:for-each select="ca:description">
          <div class="SubSectionContent2">    
            <xsl:apply-templates />
          </div>      
        </xsl:for-each>
        <xsl:call-template name="CodeSection"/>
      </div>  
    </xsl:for-each>
  </xsl:template>
  <!-- Widget Example Section -->
  <xsl:template name="SampleApplications">
    <xsl:if test="ca:sampleapps/ca:sampleapp/ca:name != &quot;&quot;">    
      <div class="Section">
        <div class="SectionHeading">    
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:examples/ca:sampleapps/@title"/>
        </div>
        <xsl:for-each select="ca:sampleapps"> 
          <xsl:for-each select="ca:sampleapp"> 
            <div class="SubSection"> 
              <xsl:for-each select="ca:name"> 
                <div class="SubSectionHeading">                                   
                  <a>
                  <xsl:attribute name="href"><xsl:value-of select="../ca:appurl" /></xsl:attribute>
                  <xsl:apply-templates />
                  </a>
                </div>
              </xsl:for-each> 
              <xsl:for-each select="ca:description">
                <div class="SubSectionContent">
                  <xsl:apply-templates/>
                </div>
              </xsl:for-each>
            </div>
          </xsl:for-each>     
        </xsl:for-each>     
      </div>
    </xsl:if>
  </xsl:template>
</xsl:stylesheet> 