<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
  xmlns:xs="http://www.w3.org/2001/XMLSchema" 
  xmlns:fn="http://www.w3.org/2004/07/xpath-functions" 
  xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <xsl:output version="1.0" encoding="utf-8" omit-xml-declaration="no" indent="no" media-type="text/html"/>
  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx --> 
  <!-- Form Element  Section -->
  <xsl:template name="FormelementsSection">
    <xsl:call-template name="FormelementsTitle"/>
    <xsl:choose>
		<xsl:when test="ca:formelements/ca:formelement/ca:name != &quot;&quot;">
			<xsl:call-template name="FormelementsList"/>
		</xsl:when>
		<xsl:otherwise>
			<div class="Section">
				<div class="FormelementName">
					None Found.
				</div>
			</div>
		</xsl:otherwise>
	</xsl:choose>
  </xsl:template> 
  
  <!-- Main Title For Description Section -->
  <xsl:template name="FormelementsTitle">
    <div class="MainHeading">         
      <a>
        <xsl:attribute name="name"><xsl:text disable-output-escaping="yes">#_formelements</xsl:text></xsl:attribute>
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:formelements/@title" />
      </a>
    </div>  
  </xsl:template>
  <!-- Form Element List -->
  <xsl:template name="FormelementsList">
    <xsl:for-each select="ca:formelements"> 
      <div class="Section">
        <xsl:for-each select="ca:formelement">
          <xsl:sort  select="ca:name "/>  
          <!-- Formelement Name -->
          <xsl:for-each select="ca:name">
            <div class="FormelementName">
              <xsl:apply-templates/>
            </div>
          </xsl:for-each>
          <!-- Formelement Definition -->
          <div class="SubSection">
            <xsl:call-template name="FormelementType"/> 
            <xsl:call-template name="FormelementDefault"/>
            <xsl:call-template name="FormelementPossValues"/> 
            <xsl:for-each select="ca:description">
              <div class="SectionContent2">
                <xsl:apply-templates/>
              </div>
            </xsl:for-each>
          </div>
        </xsl:for-each>       
      </div>
    </xsl:for-each>       
  </xsl:template>
  <!-- Formelement Value Type -->
  <xsl:template name="FormelementType">
    <div class="SectionContent2">
      <span class="DefinitionTitle">
        <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:formelements/ca:formelement/ca:type/@title" />: 
      </span>
      <xsl:for-each select="ca:type">
        <xsl:call-template name="ValueDescription"/>  
      </xsl:for-each>
    </div>  
  </xsl:template> 
  <!-- Formelement Default Value -->
  <xsl:template name="FormelementDefault">
      <xsl:for-each select="ca:default">      
        <xsl:if test="ca:value!=&quot;&quot;">
          <div class="SectionContent2">       
            <span class="DefinitionTitle">   
            <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:formelements/ca:formelement/ca:default/@title" />: 
            </span>
            <xsl:call-template name="ValueDescription"/>  
          </div>
        </xsl:if>
      </xsl:for-each> 
  </xsl:template> 
  <!-- Possible Values for Widget Feature -->
  <xsl:template name="FormelementPossValues">
    <xsl:if test="ca:possvalues/@type != &quot;&quot;">  
      <div class="SectionContent2">   
        <span class="DefinitionTitle">      
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:formelements/ca:formelement/ca:possvalues/@title" />: 
        </span> 
        <xsl:call-template name="PossValueCondition"/>  
      </div>
    </xsl:if> 
  </xsl:template>   
</xsl:stylesheet> 