<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
  xmlns:xs="http://www.w3.org/2001/XMLSchema" 
  xmlns:fn="http://www.w3.org/2004/07/xpath-functions" 
  xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">

  <xsl:output version="1.0" encoding="utf-8" omit-xml-declaration="no" indent="no" media-type="text/html"/>

  <xsl:template name="DocTitle">
       <xsl:for-each select="ca:name">  
        <xsl:for-each select="ca:value">  
          <div class="WidgetName">             
                  <xsl:value-of select="." />
          </div>  
        </xsl:for-each>
      </xsl:for-each>
  </xsl:template> 
    
  <xsl:template name="IdentificationTitle">
    <div class="MainHeading">       
      <a>
        <xsl:attribute name="name"><xsl:text disable-output-escaping="yes">#_identification</xsl:text></xsl:attribute>
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:identification/@title" />
      </a>
    </div>    
  </xsl:template>

  <xsl:template name="IdentificationTable">     
    <div class="Section">
      <table border="1" width="50%">
        <tbody>
          <tr>
            <td class="SectionHeading">         
              <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:identification/ca:name/@title"/>
            </td>
            <td class="SectionHeading">
              <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:identification/ca:parentgroup/@title"/>
            </td>
            <td class="SectionHeading">
              <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:identification/ca:maturitylevel/@title"/>
            </td>
          </tr>
          <tr>
            <td class="SubSectionHeading2">
              <xsl:for-each select="ca:name">
                <xsl:for-each select="ca:value">
                  <xsl:apply-templates />
                </xsl:for-each>
              </xsl:for-each>
            </td>
            <td class="SubSectionHeading2">
              <xsl:for-each select="ca:parentgroup">
                <xsl:for-each select="ca:value">
                  <xsl:apply-templates />
                </xsl:for-each>
              </xsl:for-each>
            </td>
            <td class="SubSectionHeading2">
              <xsl:for-each select="ca:maturitylevel">
                <xsl:for-each select="ca:value">
                  <xsl:apply-templates />
                </xsl:for-each>
              </xsl:for-each>
            </td> 
          </tr>
        </tbody>
      </table>
    </div>    
  </xsl:template>
</xsl:stylesheet> 