<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
  xmlns:xs="http://www.w3.org/2001/XMLSchema" 
  xmlns:fn="http://www.w3.org/2004/07/xpath-functions" 
  xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <xsl:output version="1.0" encoding="utf-8" omit-xml-declaration="no" indent="no" media-type="text/html"/>
  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx --> 
  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx -->     
  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx --> 
  <!-- JS file Section -->
	<xsl:template name="JSfilesSection">
		<xsl:call-template name="JSfilesTitle"/>
		<xsl:choose>
			<xsl:when test="ca:jsfiles/ca:jsfile/ca:name != &quot;&quot;">
				 <xsl:call-template name="JSfilesList"/>     
			</xsl:when>
			<xsl:otherwise>
				<div class="Section">
					<div class="JSfileName">
						None Found.
					</div>
				</div>
			</xsl:otherwise>
		</xsl:choose>      
	</xsl:template>      
  <!-- Main Title For Description Section -->
  <xsl:template name="JSfilesTitle">
    <div class="MainHeading">         
      <a>
        <xsl:attribute name="name"><xsl:text disable-output-escaping="yes">#_jsfile</xsl:text></xsl:attribute>
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/@title" />
      </a>
    </div>  
  </xsl:template>
  <!-- JS Function List -->
  <xsl:template name="JSfilesList">
    <xsl:for-each select="ca:jsfiles">  
      <div class="Section">
        <xsl:for-each select="ca:jsfile">
          <xsl:sort  select="ca:name "/>
          <!-- JS file Name -->
          <xsl:for-each select="ca:name">
            <div class="JSfileName">
              <xsl:apply-templates/>
            </div>  
          </xsl:for-each>
          <!-- JS file Description -->
          <xsl:for-each select="ca:description">
            <div class="SectionContent2">
              <xsl:apply-templates/>
            </div>
          </xsl:for-each> 
                    <!-- JS Functions and Variables Section -->
          <xsl:call-template name="JSfilevariablesSection"/>     
          <xsl:call-template name="JSfilefunctionsSection"/>            
        </xsl:for-each>       
      </div>
    </xsl:for-each>       
  </xsl:template>
  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx -->   
  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx --> 
  <!-- JS file: JS Variables Section -->
  <xsl:template name="JSfilevariablesSection">
    <xsl:if test="ca:jsvariables/ca:jsvariable/ca:name != &quot;&quot;">  
      <!-- Parameter Section Title -->
      <xsl:call-template name="JSfilevariablesTitle"/>     
      <xsl:call-template name="JSfilevariablesList"/>   
    </xsl:if>
  </xsl:template> 
  <!-- JS File: JS Variables Title -->
  <xsl:template name="JSfilevariablesTitle">
    <div class="SectionHeading">
      <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsvariables/@title" />: 
    </div>  
  </xsl:template> 
  <!-- JS File: JS Variables List -->
  <xsl:template name="JSfilevariablesList">
    <xsl:for-each select="ca:jsvariables">  
      <div class="SubSection">     
        <xsl:for-each select="ca:jsvariable">
        <xsl:sort  select="ca:name "/>   
        <!-- JS Variables Name -->
        <xsl:for-each select="ca:name">
          <div class="JSvariableName">
          <xsl:apply-templates/>
          </div>
        </xsl:for-each>
        <!-- JS Variables Definition -->
        <div class="SubSection">
          <xsl:call-template name="JSfilevariableType"/>  
          <xsl:call-template name="JSfilevariableScope"/>             
          <xsl:call-template name="JSfilevariableDefault"/>
          <xsl:call-template name="JSfilevariablePossValues"/>  
          <xsl:for-each select="ca:description">
          <div class="SectionContent2">
            <xsl:apply-templates/>
          </div>
          </xsl:for-each>
        </div>
        </xsl:for-each>       
      </div>
    </xsl:for-each>       
  </xsl:template>
  <!-- JS File: JS Variables Value Type -->
  <xsl:template name="JSfilevariableType">
    <div class="SectionContent2">
      <span class="DefinitionTitle">
      <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsvariables/ca:jsvariable/ca:type/@title" />: 
      </span>
      <xsl:for-each select="ca:type">
      <xsl:call-template name="ValueDescription"/>  
      </xsl:for-each>
    </div>  
    </xsl:template> 
    <xsl:template name="JSfilevariableScope">
    <div class="SectionContent2">
      <span class="DefinitionTitle">
      <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsvariables/ca:jsvariable/ca:scope/@title" />: 
      </span>
      <xsl:for-each select="ca:scope">
      <xsl:call-template name="ValueDescription"/>  
      </xsl:for-each>
    </div>  
  </xsl:template>   
  <!-- JS File: JS VariablesDefault Value -->
  <xsl:template name="JSfilevariableDefault">
    <xsl:for-each select="ca:default">      
    <xsl:if test="ca:value!=&quot;&quot;">
      <div class="SectionContent2">       
      <span class="DefinitionTitle">   
      <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsvariables/ca:jsvariable/ca:default/@title" />: 
      </span>
      <xsl:call-template name="ValueDescription"/>  
      </div>
    </xsl:if>
    </xsl:for-each> 
  </xsl:template> 
  <!-- JS File: Possible Values for JS Variables-->
  <xsl:template name="JSfilevariablePossValues">
    <xsl:if test="ca:possvalues/@type != &quot;&quot;">  
      <div class="SectionContent2">   
      <span class="DefinitionTitle">      
        <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsvariables/ca:jsvariable/ca:possvalues/@title" />: 
      </span> 
      <xsl:call-template name="PossValueCondition"/>  
      </div>
    </xsl:if> 
  </xsl:template>   

  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx --> 
  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx --> 
  <!-- JS Function Section -->
  <xsl:template name="JSfilefunctionsSection">
    <xsl:if test="ca:jsfunctions/ca:jsfunction/ca:name != &quot;&quot;">  
      <!-- Parameter Section Title -->
      <xsl:call-template name="JSfilefunctionsTitle"/>
      <xsl:call-template name="JSfilefunctionsList"/>
    </xsl:if>
  </xsl:template> 
  <!-- Main Title For Description Section -->
  <xsl:template name="JSfilefunctionsTitle">
    <div class="SectionHeading">
      <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsfunctions/@title" />:
    </div>  
  </xsl:template>
  <!-- JS Function List -->
  <xsl:template name="JSfilefunctionsList">   
    <xsl:for-each select="ca:jsfunctions">  
      <div class="Section">
        <xsl:for-each select="ca:jsfunction">
          <xsl:sort  select="ca:name "/>
          <!-- JS Function Name -->
          <xsl:for-each select="ca:name">
            <div class="JSfunctionName">
              <xsl:apply-templates/>
            </div>
          </xsl:for-each>
          <!-- JS Function  Definition -->
          <div class="SubSection">
            <xsl:call-template name="JSfilefunctionScope"/>
            <xsl:for-each select="ca:description">
              <div class="SectionContent2">
                <xsl:apply-templates/>
              </div>
            </xsl:for-each>                         
            <xsl:call-template name="JSfileFeatureParameters"/>
            <xsl:call-template name="JSfileFunctionReturnValues"/>  
            <xsl:call-template name="JSfileTriggeredEvents"/> 
          </div>
        </xsl:for-each>       
      </div>
    </xsl:for-each>       
  </xsl:template>
  <!--JS Function Scope -->
  <xsl:template name="JSfilefunctionScope">
    <div class="SectionContent2">
      <span class="DefinitionTitle">
        <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsfunctions/ca:jsfunction/ca:scope/@title" />: 
      </span>
      <xsl:for-each select="ca:scope">
        <xsl:call-template name="ValueDescription"/>  
      </xsl:for-each>
    </div>  
  </xsl:template> 
  
  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx -->
  <!--Parameters Section -->
  <xsl:template name="JSfileFeatureParameters">
    <xsl:if test="ca:parameters/ca:parameter/ca:name != &quot;&quot;">  
      <xsl:for-each select="ca:parameters">
        <!-- Parameter Section Title -->
        <xsl:call-template name="JSfileParametersTitle"/>
        <xsl:call-template name="JSfileParametersList"/>
      </xsl:for-each>
    </xsl:if>
  </xsl:template> 
  
  <!-- Parameter Section Title -->
  <xsl:template name="JSfileParametersTitle">
    <div class="SectionHeading">
      <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsfunctions/ca:jsfunction/ca:parameters/@title" />: 
    </div>
  </xsl:template>

  <xsl:template name="JSfileParametersList">
    <xsl:for-each select="ca:parameter">  
      <xsl:sort  select="ca:name "/>
      <!-- Formelement Definition -->
      <div class="SubSection">
      <!-- Parameter Name -->
        <xsl:for-each select="ca:name">
          <div class="ParameterName">
            <xsl:apply-templates/>
          </div>
        </xsl:for-each> 
        <div class="SubSection">    
          <xsl:call-template name="JSfileParameterType"/> 
          <xsl:call-template name="JSfileParameterRequired"/> 
          <xsl:call-template name="JSfileParameterDefault"/>
          <xsl:call-template name="JSfileParameterPossValues"/> 
          <xsl:for-each select="ca:description">
            <div class="SectionContent2">
              <xsl:apply-templates/>
            </div>
          </xsl:for-each>
        </div>
      </div>          
    </xsl:for-each>
  </xsl:template>
  
  <!-- Parameter Value Type -->
  <xsl:template name="JSfileParameterType">
    <div class="SectionContent2">
      <span class="DefinitionTitle">
        <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsfunctions/ca:jsfunction/ca:parameters/ca:parameter/ca:type/@title" />: 
      </span>
      <xsl:for-each select="ca:type">
        <xsl:call-template name="ValueDescription"/>  
      </xsl:for-each>
    </div>  
  </xsl:template> 
  <!-- Parameter Value Required -->
  <xsl:template name="JSfileParameterRequired">
    <div class="SectionContent2">
      <span class="DefinitionTitle">
        <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsfunctions/ca:jsfunction/ca:parameters/ca:parameter/ca:required/@title" />: 
      </span>
      <xsl:for-each select="ca:required">
        <xsl:call-template name="ValueDescription"/>  
      </xsl:for-each>
    </div>  
  </xsl:template>   
  <!-- Parameter Default Value -->
  <xsl:template name="JSfileParameterDefault">
      <xsl:for-each select="ca:default">      
        <xsl:if test="ca:value!=&quot;&quot;">
          <div class="SectionContent2">       
            <span class="DefinitionTitle">   
            <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsfunctions/ca:jsfunction/ca:parameters/ca:parameter/ca:default/@title" />: 
            </span>
            <xsl:call-template name="ValueDescription"/>  
          </div>
        </xsl:if>
      </xsl:for-each> 
  </xsl:template> 
  <!-- Possible Values for Parameter -->
  <xsl:template name="JSfileParameterPossValues">
    <xsl:if test="ca:possvalues/@type != &quot;&quot;">  
      <div class="SectionContent2">   
        <span class="DefinitionTitle">      
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsfunctions/ca:jsfunction/ca:parameters/ca:parameter/ca:possvalues/@title" />: 
        </span> 
        <xsl:call-template name="PossValueCondition"/>  
      </div>
    </xsl:if> 
  </xsl:template> 
  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx -->
  <!--Function Return Values Section -->
  <xsl:template name="JSfileFunctionReturnValues">
    <xsl:if test="ca:returnvalues/ca:returnvalue/ca:type != &quot;&quot;">
      <xsl:for-each select="ca:returnvalues">
          <!-- Parameter Section Title -->
          <xsl:call-template name="JSfileReturnValuesTitle"/>
          <xsl:call-template name="JSfileReturnValuesList"/>
      </xsl:for-each>
    </xsl:if>
  </xsl:template> 
  <!-- Function ReturnValues Title-->
  <xsl:template name="JSfileReturnValuesTitle">
    <div class="SectionHeading">
        <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsfunctions/ca:jsfunction/ca:returnvalues/@title" />: 
    </div>
  </xsl:template>
   <!-- Return Value List [1] -->
  <xsl:template name="JSfileReturnValuesList">
    <xsl:for-each select="ca:returnvalue">
      <xsl:sort  select="ca:name "/>
      <!-- Formelement Definition -->
      <div class="SubSection">
          <xsl:call-template name="JSfileReturnValueType"/> 
          <xsl:call-template name="JSfileReturnValueDefault"/>
          <xsl:call-template name="JSfileReturnPossValues"/>  
          <xsl:for-each select="ca:description">
            <div class="SectionContent2">
              <xsl:apply-templates/>
            </div>
          </xsl:for-each>
      </div>      
    </xsl:for-each>
  </xsl:template>   
  <!-- Return  Value Type -->
  <xsl:template name="JSfileReturnValueType">
    <div class="SectionContent2">
      <span class="DefinitionTitle">
        <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsfunctions/ca:jsfunction/ca:returnvalues/ca:returnvalue/ca:type/@title" />: 
      </span>
      <xsl:for-each select="ca:type">
        <xsl:call-template name="ValueDescription"/>  
      </xsl:for-each>
    </div>  
  </xsl:template>   
  <!-- Parameter Default Value -->
  <xsl:template name="JSfileReturnValueDefault">
      <xsl:for-each select="ca:default">      
        <xsl:if test="ca:value!=&quot;&quot;">
          <div class="SectionContent2">       
            <span class="DefinitionTitle">   
            <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsfunctions/ca:jsfunction/ca:returnvalues/ca:returnvalue/ca:default/@title" />: 
            </span>
            <xsl:call-template name="ValueDescription"/>  
          </div>
        </xsl:if>
      </xsl:for-each> 
  </xsl:template> 
  <!-- Possible Values for Parameter -->
  <xsl:template name="JSfileReturnPossValues">
    <xsl:if test="ca:possvalues/@type != &quot;&quot;">  
      <div class="SectionContent2">   
        <span class="DefinitionTitle">      
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsfunctions/ca:jsfunction/ca:returnvalues/ca:returnvalue/ca:possvalues/@title" />: 
        </span> 
        <xsl:call-template name="PossValueCondition"/>  
      </div>
    </xsl:if> 
  </xsl:template> 
  
  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx -->
  <!-- Api Triggered Events  Section -->  
  <xsl:template name="JSfileTriggeredEvents">
    <xsl:if test="ca:triggeredjsapievents/ca:triggeredjsapievent/ca:name != &quot;&quot;">
      <xsl:for-each select="ca:triggeredjsapievents">
          <!-- Parameter Section Title -->
          <xsl:call-template name="JSfileTriggeredEventsTitle"/>
          <xsl:call-template name="JSfileTriggeredEventsList"/>
      </xsl:for-each>
    </xsl:if>
  </xsl:template> 
  <!-- Api Triggered Events Title-->
  <xsl:template name="JSfileTriggeredEventsTitle">
    <div class="SectionHeading">
        <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsfiles/ca:jsfile/ca:jsfunctions/ca:jsfunction/ca:triggeredjsapievents/@title" />: 
    </div>  
  </xsl:template>
  <!-- Api Triggered Events Definitions --> 
  <xsl:template name="JSfileTriggeredEventsList">
    <xsl:for-each select="ca:triggeredjsapievent">  
      <xsl:sort  select="ca:name "/>
      <div class="SubSection">
        <xsl:for-each select="ca:name">
          <div class="TriggeredEventName">
            <xsl:apply-templates/>
          </div>
        </xsl:for-each> 
        <div class="SubSection">    
          <xsl:for-each select="ca:description">
            <div class="SectionContent2">
              <xsl:apply-templates/>
            </div>
          </xsl:for-each>
        </div>
      </div>          
    </xsl:for-each>
  </xsl:template>


  
</xsl:stylesheet> 