<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
  xmlns:xs="http://www.w3.org/2001/XMLSchema" 
  xmlns:fn="http://www.w3.org/2004/07/xpath-functions" 
  xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <xsl:output version="1.0" encoding="utf-8" omit-xml-declaration="no" indent="no" media-type="text/html"/>


  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx --> 
  <!-- JS Variables Section --> 
	<xsl:template name="JSvariablesSection">
		<xsl:call-template name="JSvariablesTitle"/>
		<xsl:choose>
			<xsl:when test="ca:jsvariables/ca:jsvariable/ca:name != &quot;&quot;">
				 <xsl:call-template name="JSvariablesList"/>     
			</xsl:when>
			<xsl:otherwise>
				<div class="Section">
					<div class="JSvariableName">
						None Found.
					</div>
				</div>
			</xsl:otherwise>
		</xsl:choose>      
	</xsl:template>  
	
  <!-- Main Title For JS Variables Section -->
  <xsl:template name="JSvariablesTitle">
    <div class="MainHeading">         
      <a>
        <xsl:attribute name="name"><xsl:text disable-output-escaping="yes">#_jsvariables</xsl:text></xsl:attribute>
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsvariables/@title" />
      </a>
    </div>  
  </xsl:template>
  <!-- JS Variables List -->
  <xsl:template name="JSvariablesList">
    <xsl:for-each select="ca:jsvariables">  
      <div class="Section">
        <xsl:for-each select="ca:jsvariable">
          <xsl:sort  select="ca:name "/>
          <!-- JS Variables Name -->
          <xsl:for-each select="ca:name">
            <div class="JSvariableName">
              <xsl:apply-templates/>
            </div>
          </xsl:for-each>
          <!-- JS Variables Definition -->
          <div class="SubSection">
            <xsl:call-template name="JSvariableType"/>  
            <xsl:call-template name="JSvariableScope"/>             
            <xsl:call-template name="JSvariableDefault"/>
            <xsl:call-template name="JSvariablePossValues"/>  
            <xsl:for-each select="ca:description">
              <div class="SectionContent2">
                <xsl:apply-templates/>
              </div>
            </xsl:for-each>
          </div>
        </xsl:for-each>       
      </div>
    </xsl:for-each>       
  </xsl:template>
  <!-- JS Variables Value Type -->
  <xsl:template name="JSvariableType">
    <div class="SectionContent2">
      <span class="DefinitionTitle">
        <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsvariables/ca:jsvariable/ca:type/@title" />: 
      </span>
      <xsl:for-each select="ca:type">
        <xsl:call-template name="ValueDescription"/>  
      </xsl:for-each>
    </div>  
  </xsl:template> 
  <xsl:template name="JSvariableScope">
    <div class="SectionContent2">
      <span class="DefinitionTitle">
        <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsvariables/ca:jsvariable/ca:scope/@title" />: 
      </span>
      <xsl:for-each select="ca:scope">
        <xsl:call-template name="ValueDescription"/>  
      </xsl:for-each>
    </div>  
  </xsl:template>   
  <!--JS VariablesDefault Value -->
  <xsl:template name="JSvariableDefault">
      <xsl:for-each select="ca:default">      
        <xsl:if test="ca:value!=&quot;&quot;">
          <div class="SectionContent2">       
            <span class="DefinitionTitle">   
            <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsvariables/ca:jsvariable/ca:default/@title" />: 
            </span>
            <xsl:call-template name="ValueDescription"/>  
          </div>
        </xsl:if>
      </xsl:for-each> 
  </xsl:template> 
  <!-- Possible Values for JS Variables-->
  <xsl:template name="JSvariablePossValues">
    <xsl:if test="ca:possvalues/@type != &quot;&quot;">  
      <div class="SectionContent2">   
        <span class="DefinitionTitle">      
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:jsvariables/ca:jsvariable/ca:possvalues/@title" />: 
        </span> 
        <xsl:call-template name="PossValueCondition"/>  
      </div>
    </xsl:if> 
  </xsl:template>   
</xsl:stylesheet> 