<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
  xmlns:xs="http://www.w3.org/2001/XMLSchema" 
  xmlns:fn="http://www.w3.org/2004/07/xpath-functions" 
  xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <xsl:output version="1.0" encoding="utf-8" omit-xml-declaration="no" indent="no" media-type="text/html"/>
  <!-- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx --> 
  <!-- Listened Events Title Section -->
  <xsl:template name="ListenedEventsSection">
    <xsl:call-template name="ListenedEventsTitle"/>
    <xsl:choose>
		<xsl:when test="ca:listenedjsapievents/ca:listenedjsapievent/ca:name != &quot;&quot;">
			<xsl:call-template name="ListenedEventsList"/>
		</xsl:when>
		<xsl:otherwise>
			<div class="Section">
				<div class="ListenedEventName">
					None Recorded.
				</div>
			</div>
		</xsl:otherwise>
	</xsl:choose>
  </xsl:template>     
  
  
  <!-- Main Title For JSAPI Listented Events Section -->
  <xsl:template name="ListenedEventsTitle">
    <div class="MainHeading">         
      <a>
        <xsl:attribute name="name"><xsl:text disable-output-escaping="yes">#_listenedevents</xsl:text></xsl:attribute>
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:listenedjsapievents/@title" />
      </a>
    </div>  
  </xsl:template>
  <!-- JSAPI Listented Events List -->
  <xsl:template name="ListenedEventsList">
    <xsl:for-each select="ca:listenedjsapievents">  
      <div class="Section">
        <xsl:for-each select="ca:listenedjsapievent"> 
          <xsl:sort  select="ca:name "/>
          <!-- JSAPI Listented Events Name -->
          <xsl:for-each select="ca:name">
            <div class="ListenedEventName">
              <xsl:apply-templates/>
            </div>
          </xsl:for-each>
          <!-- JSAPI Listented Events Definition -->
          <div class="SubSection">
            <xsl:for-each select="ca:description">
              <div class="SectionContent2">
                <xsl:apply-templates/>
              </div>
            </xsl:for-each>
            <xsl:call-template name="CalledFunctionsSection"/>
          </div>
        </xsl:for-each>       
      </div>
    </xsl:for-each>       
  </xsl:template>
  
  <!-- Listened Events Title Section -->
  <xsl:template name="CalledFunctionsSection">
    <xsl:if test="ca:calledfunctions/ca:calledfunction/ca:name != &quot;&quot;">  
      <!-- Parameter Section Title -->
      <xsl:call-template name="CalledFunctionsTitle"/>
      <xsl:call-template name="CalledFunctionsList"/>
    </xsl:if>
  </xsl:template>
  <!-- CalledFunctions  Title --> 
  <xsl:template name="CalledFunctionsTitle">
    <div class="SectionHeading">
      <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:listenedjsapievents//ca:listenedjsapievent/ca:calledfunctions/@title" />: 
    </div>
  </xsl:template>
  <!-- CalledFunctions  List -->
  <xsl:template name="CalledFunctionsList">
    <xsl:for-each select="ca:calledfunctions">  
      <div class="Section">
        <xsl:for-each select="ca:calledfunction"> 
          <xsl:sort  select="ca:name "/>
          <!-- JSAPI Listented Events Name -->
          <xsl:for-each select="ca:name">
            <div class="CalledFunctionName">
              <xsl:apply-templates/>
            </div>
          </xsl:for-each>
          <!-- JSAPI Listented Events Definition -->
          <div class="SubSection">
            <xsl:for-each select="ca:description">
              <div class="SectionContent2">
                <xsl:apply-templates/>
              </div>
            </xsl:for-each>
          </div>
        </xsl:for-each>       
      </div>
    </xsl:for-each>       
  </xsl:template>   
</xsl:stylesheet> 