<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
  xmlns:xs="http://www.w3.org/2001/XMLSchema" 
  xmlns:fn="http://www.w3.org/2004/07/xpath-functions" 
  xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <xsl:output version="1.0" encoding="utf-8" omit-xml-declaration="no" indent="no" media-type="text/html"/>


  <!-- Main Title For Description Section -->
  <xsl:template name="TagSyntaxTitle">
    <div class="MainHeading">         
      <a>
        <xsl:attribute name="name"><xsl:text disable-output-escaping="yes">#_tagsyntax</xsl:text></xsl:attribute>
          <xsl:value-of select="document('../templates/widget-default.en-ca.doc.xml')//ca:tagstructures/@title" />
      </a>
    </div>  
  </xsl:template>
  <!-- Tag Syntax Content -->         
  <xsl:template name="TagSection">    
    <xsl:for-each select="ca:tagstructure"> 
      <div class="Section">              
        <div class="SectionHeading">           
            <xsl:for-each select="@title">
              <xsl:value-of select="." />
            </xsl:for-each>
        </div>
        <div class="SubSection">           
          <xsl:for-each select="ca:description">
            <div class="SubSectionContent2">                    
              <xsl:apply-templates />
            </div>            
          </xsl:for-each>
          <xsl:call-template name="CodeSection"/> 
        </div>
      </div>                 
    </xsl:for-each>
  </xsl:template>
    <!-- Code Section -->
  <xsl:template name="CodeSection"> 
    <xsl:for-each select="ca:code">
      <xsl:for-each select="@title">
         <div class="SubSectionHeading">           
          <xsl:value-of select="." />
        </div>    
      </xsl:for-each>
      <xsl:for-each select="ca:description">
        <div class="SubSectionContent">           
          <xsl:apply-templates />
        </div>      
      </xsl:for-each>
		<pre class="CodePreview">   
			<xsl:for-each select="ca:codeblock">
				<xsl:for-each select="ca:line">
					<!-- if Line NOT Important -->
					<xsl:if test="../@bold =&quot;false&quot;">
						<xsl:apply-templates /><br />
					</xsl:if>
					<!-- if Line Important (Highlight) -->
					<xsl:if test="../@bold =&quot;true&quot;">
						<span class="CodeRequired"><xsl:apply-templates /></span><br />
					</xsl:if>
				</xsl:for-each>                     
			</xsl:for-each>         
		</pre>    
    </xsl:for-each>    
  </xsl:template>
</xsl:stylesheet> 