<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:ca="http://localhost/chameleon/utils/xml/schemas" 
  xmlns:xs="http://www.w3.org/2001/XMLSchema" 
  xmlns:fn="http://www.w3.org/2004/07/xpath-functions" 
  xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <xsl:output version="1.0" encoding="utf-8" omit-xml-declaration="no" indent="no" media-type="text/html"/>

  <xsl:template name="WIGETDOC_ALL">
    <xsl:for-each select="ca:widgetdoc">    
      <!-- ~~~~~~~~~~~~~~~~~~~~ -->
      <!--  Identification Section -->
      <xsl:for-each select="ca:identification">    
        <!-- Doc Header -->
        <xsl:call-template name="DocTitle"/>  
        <!-- Identification Section -->     
        <xsl:call-template name="IdentificationTitle"/> 
        <xsl:call-template name="IdentificationTable"/>     
      </xsl:for-each> 
      <!-- ~~~~~~~~~~~~~~~~~~~~ -->
      <!-- Description Section -->
      <xsl:for-each select="ca:descriptions">
        <xsl:call-template name="DescriptionsTitle"/>
        <!-- General Description -->
        <xsl:call-template name="GeneralDescription"/>
        <!--  Shared Resource Section -->    
        <xsl:call-template name="SharedResources"/>
        <!-- Embedded Help Section -->        
        <xsl:call-template name="UserHelp"/>
        <!--  Technical Requirements Section -->                  
        <xsl:call-template name="TechRequirements"/>
        <!--  Interface Functionality Section -->        
        <xsl:call-template name="Dependancy"/> 
        <!--  Interface Functionality Section -->        
        <xsl:call-template name="GUINotes"/>
      </xsl:for-each> 
      <!-- ~~~~~~~~~~~~~~~~~~~~ -->
      <!-- Tag Syntax Section -->
      <xsl:for-each select="ca:tagstructures">
        <xsl:call-template name="TagSyntaxTitle"/>
        <!-- Tag Syntax Content -->         
        <xsl:call-template name="TagSection"/>    
      </xsl:for-each>   
      <!-- ~~~~~~~~~~~~~~~~~~~~ -->
      <!-- Examples Section -->
      <xsl:call-template name="ExamplesMainSection"/>                 
      <!-- ~~~~~~~~~~~~~~~~~~~~ -->
      <!-- Attribute Groups Section -->
      <xsl:call-template name="AttributeGroupTitle"/>       
      <xsl:call-template name="AttributeGroupList"/>    
      <!-- ~~~~~~~~~~~~~~~~~~~~ -->
      <!-- Attribute Section -->    
      <xsl:call-template name="WidgetTagSection"/>  
      <!-- Formelements Section --> 
      <xsl:call-template name="FormelementsSection"/>
      <!-- JS Variables Section -->
      <xsl:call-template name="JSvariablesSection"/>
      <!-- JS Functions Section --> 
      <xsl:call-template name="JSfunctionsSection"/>              
      <!-- JS Files Section --> 
      <xsl:call-template name="JSfilesSection"/>      
      <!-- JS Api Listend Events Section -->  
      <xsl:call-template name="ListenedEventsSection"/>       
      <!-- Widget Events Section -->  
      <xsl:call-template name="WidgetEventsSection"/>                       
      <!-- Errors Section -->
      <xsl:call-template name="ErrorsSection"/>                 
    </xsl:for-each> 
  </xsl:template>
    
</xsl:stylesheet>


