<?php
/**
 * Very simple class that give acces to form variables
 * 
 */
class HttpFormVars
{
  var $maszVars = array();

  /**
     @param aszVars Array of variables
     
  */
  function HttpFormVars(&$aszVars)
  {
      if (is_array($aszVars))
      {
          $aszVars = array_merge( $aszVars, array_change_key_case( $aszVars, CASE_UPPER ) );
          $this->maszVars =& $aszVars;
      }
  }

  /**
     Check if variable exist in array
     
     @param szVarName Variable name to check if exist
     @param bCaseSens Make the test case sensitive (default false)

     @return TRUE if found
  */
  function isVarSet($szVarName, $bCaseSens=false)
  {
      if (is_array($this->maszVars))
      {
          $nVarCnt = count($this->maszVars);
          $aszVarKeys = array_keys($this->maszVars);

          for ($i=0;$i<$nVarCnt;$i++)
          {
              if (!$bCaseSens && 
                  strcasecmp($aszVarKeys[$i], $szVarName) == 0)
              {
                  return true;
              }
              elseif (strcmp($aszVarKeys[$i], $szVarName) == 0)
              {
                  return true;
              }
          }
      }

      return false;
  }

  /**
     Check if variable exist in array and return it
     
     @param szVarName Variable name to get value
     @param bCaseSens Make the test case sensitive (default false)

     @return Value if found. FALSE if not found.
  */
  function getVar($szVarName, $bCaseSens=true)
  {
      if (is_array($this->maszVars))
      {
          foreach($this->maszVars as $szKey => $szValue)
          {
              if (!$bCaseSens && 
                  strcasecmp($szKey, $szVarName) == 0)
              {
                  return $szValue;
              }
              elseif (strcmp($szKey, $szVarName) == 0)
              {
                  return $szValue;
              }
          }
      }

      return false;
  }

  /**
     Set variable value
     
     @param szVarName Variable name to set
     @param szValueToAssign Value to assign
     @param bCaseSens Make the test case sensitive (default false)

     @return TRUE if is set properly.
  */
  function setVar($szVarName, $szValueToAssign, $bCaseSens=true)
  {
      if (is_array($this->maszVars))
      {
          foreach($this->maszVars as $szKey => $szValue)
          {
              if (!$bCaseSens && 
                  strcasecmp($szKey, $szVarName) == 0)
              {
                  $this->maszVars[$szKey] = $szValueToAssign;

                  return true;
              }
              elseif (strcmp($szKey, $szVarName) == 0)
              {
                  $this->maszVars[$szKey] = $szValueToAssign;

                  return true;
              }
          }
      }
      return false;
  }

  /**
     Add variable value
     
     @param szVarName Variable name to add
     @param szValueToAssign Value to assign (default "")

     @return TRUE if is set properly.
  */
  function addVar($szVarName, $szValueToAssign="")
  {
      if (is_array($this->maszVars))
      {
          foreach($this->maszVars as $szKey => $szValue)
          {
              if (!$bCaseSens && 
                  strcasecmp($szKey, $szVarName) == 0)
              {
                return false;
              }
              elseif (strcmp($szKey, $szVarName) == 0)
              {
                  return false;
              }
          }
      }

      $this->maszVars[$szVarName] = $szValueToAssign;

      return true;
  }
}
?>