<?php
// Report ALL errors
error_reporting( E_ALL );

include_once("HttpFormVars.php");

if(!defined("CHAMELEON_PATH"))
    define( "CHAMELEON_PATH", dirname(__FILE__)."/." );
    
// define the path to the conguration settings
if(!defined("CHAMELEON_CONFIG_PATH"))
    define( "CHAMELEON_CONFIG_PATH", dirname(__FILE__)."/../config/" );

// define the path to the components folder
//%DMPEAR_COMMON%
//%DMPEAR_WEBCOMMON%
if(!defined("COMMON"))
    define( "COMMON",  dirname(__FILE__)."/common/" );


// include the logging functions
include_once( COMMON."logger/logfile.php" );
include_once( COMMON."logger/error_manager.php" );
include_once( COMMON."logger/logger.php" );

// include the xml parsing class
include_once( COMMON."appcontext/appcontext.php" );

// include wrapper file(s)
include_once( COMMON."wrapper/map_session.php" );

// include the mlt file
include_once( COMMON."mlt/mlt.php" );

// Session management
include_once( COMMON."session/session.php");
installSessionDirectoryHandler();
$GLOBALS['bSessionOK'] = initializeSession("sid");

// convert the global session reference if necessary
if ( PHP_OS == "WINNT" || PHP_OS == "WIN32" )
{
    if ( version_compare( phpversion(), "4.2.1" ) < 0 )
        $_SESSION = &$HTTP_SESSION_VARS;
}


if (!isset($GLOBALS['gszAppWebPath']))
{
    if (version_compare( phpversion(), "4.3.0" ) < 0)
    {
        $GLOBALS['gszAppWebPath'] = $_SERVER['REQUEST_URI'];
    }
    else
    {
        $GLOBALS['gszAppWebPath'] = dirname( $_SERVER['SCRIPT_NAME'] )."/";
    }    
}

if (!isset($_SESSION['gszAppWebPath']))
{
    $_SESSION['gszAppWebPath'] = $GLOBALS['gszAppWebPath'];
}

if (!isset($GLOBALS['gszAppPath']))
{
    if (version_compare( phpversion(), "4.3.0" ) < 0)
    {
        $GLOBALS['gszAppPath'] = dirname($_SERVER['PATH_TRANSLATED']);
    }
    else
    {
        $GLOBALS['gszAppPath'] = dirname( $_SERVER['SCRIPT_FILENAME'] )."/";
    } 
}
if (!isset($_SESSION['gszAppPath']))
{
    $_SESSION['gszAppPath'] = $GLOBALS['gszAppPath'];
}

class Chameleon
{
    var $moHttpFormVars;
    var $HTTP_FORM_VARS1;

    var $moContext;
    var $mszCurrentLanguage;
    var $maszTemplates = array();
    
    var $mszTemplateName = "";
    var $mszTemplate = "";

    var $mszMapFile;

    var $moMapSession = "";
    var $moMLT;
    var $moCommonMLT;
    var $moUI;

    var $moErrorManager;
    var $moLogFile;

    var $mszCurrentState = "";

    var $mszCoreWebPath;

    var $mszInvalidSessionTmpl = "";

    var $mbSessionOK = true;

    function Chameleon()
    {
        if (sizeof($_POST) > 0)
            $this->HTTP_FORM_VARS1 =& $_POST;
        else if (sizeof($_GET) > 0)
            $this->HTTP_FORM_VARS1 =& $_GET;
        else
            $this->HTTP_FORM_VARS1 = array("");

        if (isset($GLOBALS['bSessionOK']) && !$GLOBALS['bSessionOK'])
          $this->mbSessionOK = false;

        // Load form variables into a class
        $this->moHttpFormVars = new HttpFormVars($this->HTTP_FORM_VARS1);

        if (isset($_SESSION['gszCurrentState']))
            $this->mszCurrentState = $_SESSION['gszCurrentState'];
        else
        if ($this->moHttpFormVars->isVarSet('currentState', false) &&
            $this->moHttpFormVars->getVar('currentState', false) != "")
        {
            $this->mszCurrentState = $this->moHttpFormVars->getVar('currentState', false);
        }
        
        if( isset($this->HTTP_FORM_VARS1["LANGUAGE"]))
        {
            $this->mszCurrentLanguage = $this->HTTP_FORM_VARS1["LANGUAGE"];
        }
        elseif(isset($_SESSION['gszCurrentLanguage']))
        {
            $this->mszCurrentLanguage = $_SESSION['gszCurrentLanguage'];
        }
    }
    
    function CWCAddRegionalTemplate( $szLang, $szTemplateName )
    {
        $this->maszTemplates[$szLang] = $szTemplateName;
    }

    function CWCExecute($aszWidgetsDir=array())
    {
        // set a global reference
        $GLOBALS['oChameleonApp'] =& $this;

        include("UIManager.php");

        $nCount = 0;

        $bRet = false;
        while($bRet == false)
        {
            // First thing, check if session is invalid and if a tmeplate is
            // specified
            if (!$this->mbSessionOK)
            {
                if ($this->mszInvalidSessionTmpl == "")
                {
                    $this->CWCLoadTemplate($this->mszTemplateName);
                    if (strpos($this->mszTemplate, "SessionExpired") === false)
                    {
                        echo "Your session has expired from our server, please come back to the entry page of the application to initiate a new session";
                        exit;
                    }
                }
                else
                    $this->CWCLoadTemplate($this->mszInvalidSessionTmpl);
            }
            else
                $this->CWCLoadTemplate($this->mszTemplateName);

            $this->moUI = new UIManager($this->mszTemplate,
                                        $this->moMapSession,
                                        $aszWidgetsDir);

            if ($this->moUI->ProcessURL($this->HTTP_FORM_VARS1))
            {
                $nCount = 0;
                $this->moUI->DrawPublish();

                $_SESSION['gszCurrentState']=$this->moMapSession->saveState();

                $bRet = true;
            }
            else
            {
                if ($this->mszTemplateName == $this->mszLastTemplateName)
                    $bRet = true;
                else
                    $nCount ++;

                // This should never happen.
                if ($nCount > 10)
                {
                    echo "Infinit loop. Exiting."; 
                   
                    echo "<!-- ".$this->mszTemplateName."\n\n";
                    print_r($this->HTTP_FORM_VARS1);
                    echo " -->";

                    exit;
                }
            }
        }
    }

    function CWCInitialize($szTemplateName, $szMapFile="")
    {
        $this->CWCSetTemplate($szTemplateName);
        $this->mszMapFile  = $szMapFile;
        
        // define a new AppContext object
        $this->moContext = new AppContext( CHAMELEON_CONFIG_PATH."cwc2.xml" );
        
        if(!defined("WEBCOMMON"))
            define( "WEBCOMMON", $this->moContext->getContextValue("web_server_path")."/common/" );

        $this->mszInvalidSessionTmpl =
          $this->moContext->getContextValue("invalid_session_template", "");

        // Get default language from configuration file
        if ($this->mszCurrentLanguage == "")
        {
            $this->mszCurrentLanguage = $this->moContext->getContextValue("default_language","");
        }
        $_SESSION['gszCurrentLanguage'] = $this->mszCurrentLanguage;
        
        // create a new MLT object
        $this->moMLT = new MLTdBase( $this->mszCurrentLanguage );

        // create a new common MLT object
        $this->moCommonMLT = new MLTdBase( $this->mszCurrentLanguage );

        // load the resourcre file into memory
        $this->moMLT->loadResource( "../data/language/CWC2.dbf", $this->mszCurrentLanguage );

        // load common resources
        $this->moCommonMLT->loadResource( "../data/language/common.dbf", $this->mszCurrentLanguage );

        // Init session variables if not already set
        if (!$this->moHttpFormVars->isVarSet('SID') ||
            !$this->mbSessionOK ||
            (isset($_SESSION['gszMapName']) && $_SESSION['gszMapName'] != $szMapFile))
        {
            $this->mszCurrentState = "";
            $this->CWCInitializeSession();
        }

        if (!extension_loaded("MapScript"))
            dl($_SESSION['gszMapscriptModule']);

        $this->CWCInitializeMap();
    }

    function CWCSetTemplate($szTemplateName)
    {
        $this->mszLastTemplateName = $this->mszTemplateName;
        if (isset($this->maszTemplates[$this->mszCurrentLanguage]))
        {
            $this->mszTemplateName = $this->maszTemplates[$this->mszCurrentLanguage];
        }
        else
        {
            $this->mszTemplateName = $szTemplateName;
        }
    }

    function CWCLoadTemplate($szTemplateName)
    {
        if (function_exists('file_get_contents'))
        {
            $this->mszTemplate = file_get_contents($szTemplateName);
        }
        else
        {
            $this->mszTemplate = implode("\n", file($szTemplateName));
        }
    }

    function CWCInitializeMap()
    {
        //session map init
        // create a new map session object if not created
        if ($this->moMapSession == "")
        {
            $this->moMapSession = new MapSession_R;
        }

        // set the global log file and error manager
        $this->moMapSession->setLogFile( $this->moLogFile );
        $this->moMapSession->setErrorManager( $this->moErrorManager );

        /* ===========================================================
         * Re-instate the previous map state
         * =========================================================== */
        if ($this->mszCurrentState == "" )
        {
            // load mapfile if necessary
            if ($this->mszMapFile != "")
            {
                // Init error stack
                ms_ResetErrorList();

                $bStatus = MS_FAILURE;
                if (strtoupper(substr($this->mszMapFile, -3)) == "MAP")
                {
                    $bStatus = $this->moMapSession->readMapFile($this->mszMapFile,
                                                                dirname($this->mszMapFile));

                    if ($bStatus)
                        $bStatus = MS_SUCCESS;
                    else
                        $bStatus = MS_FAILURE;

                }

                if ($bStatus == MS_FAILURE)
                {
                    if (isset($this->moErrorManager))
                        $this->moErrorManager->setError(ERR_WARNING,
                                                   trim($this->moMLT->get("4", "ERROR: Invalid map file file.")));
                    else
                        echo "ERROR: Invalid map file file (".$this->mszMapFile.").";

                    // Get mapserver error stack
                    $oError = ms_GetErrorObj();
                    while($oError && $oError->code > 0)
                    {
                        if (isset($this->moErrorManager))
                            $this->moErrorManager->setError(ERR_WARNING, $oError->message);

                        echo "<!-- ".$oError->message." -->";

                        $oError = $oError->next();
                    }
                }
                else
                {
                    // Reset form Vars when new context is loaded
                    $this->resetFormVars();
                }
            }
        }
        else
        {
            $this->moMapSession->restoreState($this->mszCurrentState,
                                              $this->mszMapFile,
                                              dirname($this->mszMapFile));
        }
    }

    function CWCInitializeSession()
    {
        $_SESSION['gszCoreWebPath'] =
                       $this->moContext->getContextValue("web_server_path");
        $_SESSION['gszCorePath'] = dirname(__FILE__)."/";

        $_SESSION['gszTmpPath']    = getSessionSavePath();
        $_SESSION['gszTmpMapPath'] = getSessionSavePath();
        $_SESSION['gszDefaultLanguage'] = $this->mszCurrentLanguage;

        $_SESSION['gnMapSessionMode'] = ((method_exists($this->moMapSession, "MapSession_RW")) ? "1":"0");

        //  tmp web path
        $gszTmpWebPath = str_replace("\\", "/",
                                     $this->moContext->getContextValue("tmp_web_path"));
        if (substr($gszTmpWebPath, -1) != "/")
            $gszTmpWebPath .= "/";
        $_SESSION["gszTmpWebPath"] = $gszTmpWebPath;

        //  tmp image path
        $gszTmpImgPath = str_replace("\\", "/",
                                     $this->moContext->getContextValue("tmp_img_path"));
        if (substr($gszTmpImgPath, -1) != "/")
            $gszTmpImgPath .= "/";
        $_SESSION["gszTmpImgPath"] = $gszTmpImgPath;

        //button cache path
        $gszButtonCachePath = $this->moContext->getContextValue("button_cache_path");
        if (substr($gszButtonCachePath, -1) != "/")
            $gszButtonCachePath .= "/";
        $_SESSION["gszButtonCachePath"] = $gszButtonCachePath;

        //button cache url
        $gszButtonCacheWebPath = $this->moContext->getContextValue("button_cache_web_path");
        if (substr($gszButtonCacheWebPath, -1) != "/")
            $gszButtonCacheWebPath .= "/";
        $_SESSION["gszButtonCacheWebPath"] = $gszButtonCacheWebPath;

        // Get image output type
        $_SESSION["gszImgType"] = $this->moContext->getContextValue("image_type");

        // get the font list file
        $_SESSION["gszFontListFile"] = str_replace("\\", "/",
                                                   realpath($this->moContext->getContextValue("fontlist_file")));
        
        // set a default map title font.
        $_SESSION["gszMapTitleFontName"] = "fritqat";

        // set a default legend font.
        $_SESSION["gszLegendFontName"] = "fritqat";
        
        // get the symbol file
        $_SESSION["gszSymbolFile"] = str_replace("\\", "/",
                                                 realpath($this->moContext->getContextValue("symbol_file")));

        // path for the log file
        $gszLogPath = str_replace("\\", "/", realpath($this->moContext->getContextValue("log_path")));
        if (substr($gszLogPath, -1) != "/")
          $gszLogPath .= "/";

        // get the log level
        $gszLogLevel = $this->moContext->getContextValue("log_level");

        $gnTimeout = intval($this->moContext->getContextValue( "execution_timeout" ));
        if ( $gnTimeout < 30 )
          $gnTimeout = 30;

        set_time_limit( $gnTimeout );

        // create new logfile object (customize parameters)
        $aszLog = explode(".", basename($_SERVER["PHP_SELF"]));
        $gLogFile = new LogFile( $gszLogPath.$aszLog[0]."_cwc2.log", LOG_TO_FILE, true );

        // determine the max log level ( set in mapbrowser.xml )
        switch( $gszLogLevel )
          {
            case "LOG_ALL";
            $gnLogLevel = LOG_ALL;
            break;
          case "LOG_VERBOSE":
            $gnLogLevel = LOG_VERBOSE;
            break;
          case "LOG_QUIET":
            $gnLogLevel = LOG_QUIET;
            break;
          default:
            $gnLogLevel = LOG_OFF;
          } // switch

        // set the max log level
        $gLogFile->setMaxLogLevel( $gnLogLevel );

        // add log file parameters to the session for use elsewhere
        $_SESSION["gnLogLevel"]= $gnLogLevel;
        $_SESSION["gszLogPath"]= $gszLogPath;

        if (!isset($_SESSION["gErrorManager"] ) )
        {
            // create new error manager object
            $_SESSION["gErrorManager"]= new ErrorManager();
        }

        // create a logger object
        $oLog = new Logger( "General" );

        // set the global log file and error manager
        $oLog->setLogFile( $gLogFile );
        $oLog->setErrorManager( $_SESSION["gErrorManager"] );

        $gnTextButtonDefaultFontSize =
                  $this->moContext->getContextValue("textbutton_default_font_size", 11);
        $gbTextButtonDefaultFontAntialiasing =
                  $this->moContext->getContextValue("textbutton_default_font_antialiasing", true);

        $gszGDVersion = $this->moContext->getContextValue("gd_version");
        $gszFreeTypeVersion = $this->moContext->getContextValue("freetype_version");

        $_SESSION['gszMapscriptModule'] =
                  $this->moContext->getContextValue("mapscript_module");

        $_SESSION['gszCurrentState'] = ((!isset($_SESSION['gszCurrentState'])) ? "" : $_SESSION['gszCurrentState']);
        $_SESSION['gszTmpWebPath'] = $gszTmpWebPath;
        $_SESSION['gszMapName'] = $this->mszMapFile;
        $_SESSION['gszMapPath'] = dirname($this->mszMapFile);
        $_SESSION['gnTimeout'] = $gnTimeout;
        $_SESSION['gszCurrentLanguage'] = $this->mszCurrentLanguage;
        $_SESSION["gnTextButtonDefaultFontSize"] = $gnTextButtonDefaultFontSize;
        $_SESSION["gbTextButtonDefaultFontAntialiasing"] = $gbTextButtonDefaultFontAntialiasing;
        $_SESSION['gszGDVersion'] = $gszGDVersion;
        $_SESSION['gszFreeTypeVersion'] = $gszFreeTypeVersion;

        // build list of languages to load
        $_SESSION['aszLang'] = array_keys( $this->maszTemplates );
    }


    function resetFormVars()
    {
        // Reset some form variables when loading a new context or map file
        if(isset($GLOBALS["HTTP_FORM_VARS1"]["MAP_EXTENTS_MINX"]))
        {
            unset($GLOBALS["HTTP_FORM_VARS1"]["MAP_EXTENTS_MINX"]);
            unset($GLOBALS["HTTP_FORM_VARS1"]["MAP_EXTENTS_MINY"]);
            unset($GLOBALS["HTTP_FORM_VARS1"]["MAP_EXTENTS_MAXX"]);
            unset($GLOBALS["HTTP_FORM_VARS1"]["MAP_EXTENTS_MAXY"]);
        }

        if(isset($GLOBALS["HTTP_FORM_VARS1"]["Extent_MAXX"]))
        {
            unset($GLOBALS["HTTP_FORM_VARS1"]["Extent_MAXX"]);
            unset($GLOBALS["HTTP_FORM_VARS1"]["Extent_MAXY"]);
            unset($GLOBALS["HTTP_FORM_VARS1"]["Extent_MINX"]);
            unset($GLOBALS["HTTP_FORM_VARS1"]["Extent_MINY"]);
        }

        if(isset($GLOBALS["HTTP_FORM_VARS1"]["CursorPos_X"]))
        {
            unset($GLOBALS["HTTP_FORM_VARS1"]["CursorPos_X"]);
            unset($GLOBALS["HTTP_FORM_VARS1"]["CursorPos_Y"]);
        }

        if(isset($GLOBALS["HTTP_FORM_VARS1"]["MAP_WIDTH"]))
        {
            unset($GLOBALS["HTTP_FORM_VARS1"]["MAP_WIDTH"]);
            unset($GLOBALS["HTTP_FORM_VARS1"]["MAP_HEIGHT"]);
        }

        if(isset($GLOBALS["HTTP_FORM_VARS1"]["NAV_INPUT_COORDINATES"]))
            unset($GLOBALS["HTTP_FORM_VARS1"]["NAV_INPUT_COORDINATES"]);

        if(isset($GLOBALS["HTTP_FORM_VARS1"]["NAV_CMD"]))
            unset($GLOBALS["HTTP_FORM_VARS1"]["NAV_CMD"]);

        if(isset($GLOBALS["HTTP_FORM_VARS1"]["SCALE"]))
            unset($GLOBALS["HTTP_FORM_VARS1"]["SCALE"]);
    }

    function &getWidgetByName($szName)
    {
        $nWidgets = count($this->moUI->maoWidgets);

        foreach(array_keys($this->moUI->maoWidgets) as $szKey)
        {
            $oWidget =& $this->moUI->maoWidgets[$szKey];

            if ($oWidget->GetValue("TYPE") == $szName)
                return $oWidget;
        }

        return false;
    }
}

function &GetChameleonApplication()
{
    if(isset($GLOBALS['oChameleonApp']))
        return $GLOBALS['oChameleonApp'];

    return false;
}
?>