/* ==================================================================== */
/*  FindStation( station_id )                                           */
/*  gets a handles on a CWC_JS_SharedResource based on station_id       */
/* ==================================================================== */
function FindStation( station_id )
{
    var result = null;
    var i, child;
    var sr = goJSSR.GetValue( "MapTipsQueryResults" );
    //var sr = CWC_JSSR_GetValue( "MapTipsQueryResults" );
    //alert(sr.maoChildren.length);
    for (i=0; i<sr.maoChildren.length; i++)
    {
        child = sr.maoChildren[i];
        if (child.GetValue( "station_id" ) == station_id )
        {
            result = child;
            break;
        }
    }

    return result;
}


/* ==================================================================== */
/*  MapTipInit( station_id, szLayer )                                   */
/*  Initializes the Chameleon MapTips functionality                     */
/* ==================================================================== */
function MapTipInit( station_id, szLayer, layerMode )
{

    var child = FindStation( station_id );

    if (child != null)
    {
        var station_id   = child.GetValue( "station_id" );
        var station_name = child.GetValue( "station_name" );
        var station_x    = child.GetValue( "pix_x" );
        var station_y    = child.GetValue( "pix_y" );
        var station_geox = child.GetValue( "geo_x" );
        var station_geoy = child.GetValue( "geo_y" );
        
        // here we would build the content of the maptip for display
        // style of DIV controlled by CSS in including page template
        var szText = station_name + '<br>' + station_id;
        var content = MapTipContent( szLayer, szText );
        
        if(!layerMode)
            var layerMode = 'dynamic';
            
        if(layerMode == 'dynamic')
        {
            MapTipPosition(szLayer, station_x, station_y);
        }
    }
    else
    {
        alert('child is null - exiting');
    }
}


/* ==================================================================== */
/*  MapTipClear(szLayer, szText)                                        */
/*  Clears the contents of the MapTip DIV (szText can be default text)  */
/* ==================================================================== */
function MapTipClear(szLayer, szText)
{
    if(!szText)
        var szText = '';
        
    MapTipContent( szLayer, szText );
}


/* ==================================================================== */
/*  MapTipPosition(szLayer,x,y)                                         */
/*  Positions the layer based on the users current cursor position      */
/* ==================================================================== */
function MapTipPosition(szLayer,ix,iy)
{

    // this uses the name of the chameleon mapimage
    // couldn't use the overlay transparent gif -- was returning 0 0
    var oImg = CWCDHTML_GetImage('mapimage')
    var imgX = CWCDHTML_FindObjectPosX(oImg);
    var imgY = CWCDHTML_FindObjectPosY(oImg);
    
    // +5 pixel offset
    var layerPosX = imgX + parseInt(ix) + 5;
    var layerPosY = imgY + parseInt(iy) + 5;
    
    CWCDHTML_SetLayerPos(szLayer, layerPosX, layerPosY);
    CWCDHTML_SetLayerVis(szLayer, true);
    
}


/* ==================================================================== */
/*  MapTipContent( szLayer, szText )                                    */
/*  Writes the content to the MapTip DIV                                */
/* ==================================================================== */
function MapTipContent( szLayer, szText )
{

    if(!szLayer)
    {
        alert('no layer specified .. exiting');
        return false;
    }

    // should work for all browsers
    if (document.layers)
    {
        var oLayer;
        if(parentID)
        {
            oLayer = eval('document.' + parentID + '.document.' + szLayer + '.document');
        }
        else
        {
            oLayer = document.layers[szLayer].document;
        }

        oLayer.open();
        oLayer.write(szText);
        oLayer.close();
    }
    else if (parseInt(navigator.appVersion)>=5&&navigator.appName=="Netscape")
    {
        document.getElementById(szLayer).innerHTML = szText;
    }
    else if (document.all)
    {
        document.all[szLayer].innerHTML = szText;
    }
    
    return true;

}