<%-- 
 * CWC Link with JSP
 *
 * @project     CWC2
 * @revision    $Id: cwc_link_jsp.jsp,v 1.1 2003/08/06 16:28:24 assefa Exp $
 * @purpose     Linking cwc with J2EE (using jsp)
 * @author      DM Solutions Group (assefa@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2003, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.

--%>

<%-- 
The purpose of this file is to be able to call an instance of
 a cwc2 application (php) from a jsp page.
The resulting response to the CWC instance is then parsed into three 
blocks of HTML/Javascript codes. These blocks will be placed inside the HTML at appropriate places. 
--%>

<%@ page language="java" contentType="text/html" %>
<%@ page import="java.util.*" %>
<%@ page import="java.net.*" %>
<%@ page import="java.io.*" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core" %>


<%-- parseCWCTemplate

Utility class to call a CWC instance and parse the result in to three 
separate blocks. These blocks can then be feched and placed anywhere in 
the HTML.
--%>

<%!

public class parseCWCTemplate
{
    private StringBuffer sTopBlock = null;
    private StringBuffer sBodyBlock = null;
    private StringBuffer sLowerBlock = null;

    /**
     * Return the top block.
    */
    public String getTopBlock()
    {
        if (sTopBlock != null)
          return sTopBlock.toString();
        
        return "";
    }

    
    /**
     * Return the body block.
    */
    public String getBodyBlock()
    {
        if (sBodyBlock != null)
          return sBodyBlock.toString();
        
        return "";
    }

    /**
     * Return the lower block.
    */
    public String getLowerBlock()
    {
        if (sLowerBlock != null)
          return sLowerBlock.toString();
        
        return "";
    }

    
    /**
     * Read contents of remote web page and return as string
     */
    public String setCWCUrl(String s) 
    {
        try 
        {
            BufferedReader in; 
            sTopBlock = new StringBuffer();
            sBodyBlock =  new StringBuffer();
            sLowerBlock = new StringBuffer();
            boolean bTopBlock = false;
            boolean bBodyBlock = false;
            boolean bLowerBlock = false;
            //StringBuffer out = new StringBuffer();

            URL u = new URL(s);
        
            InputStream oStream = u.openStream();
            in = new BufferedReader(new InputStreamReader(oStream));
        
            String sLine = in.readLine();
        
            while(sLine != null)
            {
                if (sLine.startsWith("<!-- BLOCK"))
                {
                    if (sLine.startsWith("<!-- BLOCK_TOP_START"))
                      bTopBlock = true;
                    else if (sLine.startsWith("<!-- BLOCK_TOP_END"))
                    {
                        sTopBlock.append(sLine + "\n");
                        bTopBlock = false;
                    }
                    else if (sLine.startsWith("<!-- BLOCK_BODY_START"))
                      bBodyBlock = true;
                    else if (sLine.startsWith("<!-- BLOCK_BODY_END"))
                    {
                        sBodyBlock.append(sLine + "\n");
                        bBodyBlock = false;
                    }
                    else if (sLine.startsWith("<!-- BLOCK_LOWER_START"))
                      bLowerBlock = true;
                    else if (sLine.startsWith("<!-- BLOCK_LOWER_END"))
                    {
                         sLowerBlock.append(sLine + "\n");
                        bLowerBlock = false;
                    }
                }
            
                if (bTopBlock == true)
                  sTopBlock.append(sLine + "\n");
                else if (bBodyBlock == true)
                  sBodyBlock.append(sLine + "\n");
                else if (bLowerBlock == true)
                  sLowerBlock.append(sLine + "\n");
            
                //out.append(sLine + "\n");

                sLine = in.readLine();

            
            }

            oStream.close();
            //return out.toString();
            //return sTopBlock.toString();
        }
        catch(MalformedURLException me)
        {
            return "Malformed URL: " + me.getMessage();
        }    
        catch(IOException ioe) 
        {
            return "IO Error: " + ioe.getMessage();
        } 
        catch(Exception e) 
        {
            return "Unknown Error: " + e.getMessage();
        }

        return "success";
    }
}
%>

<%
Enumeration aParamNames = request.getParameterNames();
String sQueryString = new String("");
String sParamValue[];
//String sParamName;

/* Build the query string that will be conacatenated to the URL*/
while (aParamNames.hasMoreElements()) 
{
    String sParamName = String.valueOf(aParamNames.nextElement());
    sParamValue = request.getParameterValues(sParamName);
    if (sParamValue != null)
    {
        if (sQueryString == "")
        {
            sQueryString = sParamName + "=";
            sQueryString = sQueryString + String.valueOf(sParamValue[0]);
        }
        else
        {
            sQueryString = sQueryString + "&" + sParamName + "=";
            sQueryString = sQueryString +  String.valueOf(sParamValue[0]);
        }
    }
}
//Create a parser class
parseCWCTemplate oParser = new parseCWCTemplate();

//set the URL to the CWC2 instance
String sURL = new String("http://localhost/msapps/cwc/htdocs/cwc2.php?TEMPLATE=test.html&CONTEXT=gmap_context.xml&");
if (sQueryString != "")
     sURL = sURL + sQueryString;
  
oParser.setCWCUrl(sURL);

//extact the blocks
String sTop = oParser.getTopBlock();
String sBody = oParser.getBodyBlock();
String sLower = oParser.getLowerBlock();

%>

<HTML>
<HEAD>
<TITLE>CWC2/JSP Demo</TITLE>
<%= sTop %> <br>
<link href="http://localhost/msapps/cwc/htdocs/cwc2.css" rel="stylesheet" type="text/css">
</HEAD>
<%= sBody %> <br>
<%= sLower %> <br>

</html>


