<?php
/* ************************************************
     Post installation process for chameleon
   ***********************************************/
// Include help functions
if (!defined("INSTALL_INCLUDED"))
{
    if (isset($GLOBALS['argv'][1]))
    {
        if (!@include_once(str_replace("\\","/",$GLOBALS['argv'][1]."/installer/client/install.php")))
        {
            echo "\n\nPlease specify path to applications repository. EG: php -q post-installation.php /DMPear/\n\n";
            exit;
        }
    }
    else
    {
        echo "\n\nPlease specify path to applications repository. EG: php -q post-installation.php /DMPear/\n\n";
        exit;
    }
}

// Step 1.
//
// Update registry. We put category inside the registry.
setApplicationName("chameleon", "chameleon");


// Step 2.
//
// Create httpd.d if don't exist. Copy the file in the correct
// directory and replace all %DMPEAR% instance to the current
// applications repository.
setHttpdConfFile("chameleon", "chameleon/httpd_chameleon.conf");

// Step 3.
//
// Copy conf dist file to current conf file (if no exist)
$szAppRep = getApplicationRepositoryDir();
$aszReplaceFrom = array("%CHAMELEON_WEB_PATH%", 
                        "%LOG_PATH%", 
                        "%BUTTON_CACHE_PATH%", 
                        "%BUTTON_CACHE_WEB_PATH%", 
                        "%TMP_PATH%", 
                        "%TMP_WEB_PATH%");
$aszReplaceTo   = array("/chameleon/", 
                        str_replace("\\", "/", $szAppRep.DS."chameleon".DS."log".DS),
                        str_replace("\\", "/", $szAppRep.DS."chameleon".DS."htdocs".DS."tmp".DS."buttons".DS),
                        "/chameleon/tmp/buttons/",
                        str_replace("\\", "/", $szAppRep.DS."chameleon".DS."htdocs".DS."tmp".DS),
                        "/chameleon/tmp/");

copyFileAndReplace($aszReplaceFrom, $aszReplaceTo, 
                   "chameleon/config/cwc2.xml-dist", 
                   "chameleon/config/cwc2.xml");

// Step 4.
//
// Make sure COMMON is set to something ok.
// for chameleon.php
$aszReplaceFrom = array("//%DMPEAR_WEBCOMMON%", "//%DMPEAR_COMMON%");
$aszReplaceTo   = array("define(\"WEBCOMMON\", \"/common/\");", 
                        "define(\"COMMON\", \"".str_replace("\\", "/", $szAppRep)."/php_utils/\");");

copyFileAndReplace($aszReplaceFrom, $aszReplaceTo, "/chameleon/htdocs/chameleon.php");

// for UpdateMap.php
copyFileAndReplace($aszReplaceFrom, $aszReplaceTo, "/chameleon/htdocs/UpdateMap.php");

// for widgets/session.inc.php
copyFileAndReplace($aszReplaceFrom, $aszReplaceTo, "/chameleon/htdocs/widgets/session.inc.php");

// Step 5.
//
// Create tmp and buttons directory
if (!file_exists($gszApplicationsRepository.DS."chameleon".DS."htdocs".DS."tmp"))
    mkdir($gszApplicationsRepository.DS."chameleon".DS."htdocs".DS."tmp");
if (!file_exists($gszApplicationsRepository.DS."chameleon".DS."htdocs".DS."tmp".DS."buttons"))
    mkdir($gszApplicationsRepository.DS."chameleon".DS."htdocs".DS."tmp".DS."buttons");
if (!file_exists($gszApplicationsRepository.DS."chameleon".DS."log"))
    mkdir($gszApplicationsRepository.DS."chameleon".DS."log");
?>