<?php
/**
 * @project     GeoDan
 * @revision    $Id: ExpressionBuilder.php,v 1.8 2004/01/09 20:40:28 wbronsema Exp $
 * @purpose     This contains the supporting php code.
 * @author      William A. Bronsema, C.E.T. (dev@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2003, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 **/
 
//set the language resource file
$szLanguageResource = "../../data/language/ExpressionBuilder.dbf";
$szCommonLanguageResource = "../../data/language/common.dbf";

// set the flag to setup the mapsession
if ( !defined("LOAD_MAPSESSION") )
    define("LOAD_MAPSESSION", 1);

// include the session handling file (currently only required for MLT)
include_once("./session.inc.php");
include_once("CWC2ButtonCache.php");

// get the form vars
$_FORM = array_merge( $_GET, $_POST );

/* ============================================================================
 * Define the default properties for the "LIKE" operator
 * ========================================================================= */
define( "LIKE_WILDCARD", urldecode( $_FORM["wildcard"] ) );
define( "LIKE_SINGLECHAR", urldecode( $_FORM["singlechar"] ) );
define( "LIKE_ESCAPECHAR", urldecode( $_FORM["escape"] ) );

/* ============================================================================
 * Determine the layer specific info
 * ========================================================================= */
// init vars
$nCount = 0;
$nSelectedLayer = "";
$szSelectedLayerName = "";
$szSelectedLayerConnType = "";
$aszAttributes = array();
$szErrorNotice = "";
$szWFSConnection = "";
$nLayerCount = $oMapSession->oMap->numlayers;

/* ============================================================================
 * Get selected WFS layer
 * ========================================================================= */
// check if selected layer list has been passes through URL
$aszLayers = array();
if ( isset( $_FORM["selectedlayers"] ) && 
                              strlen( trim( $_FORM["selectedlayers"] ) ) > 0 )
{
    // put layers into array
    $aszLayers = explode( ',', $_FORM["selectedlayers"] );
    $nTmpCount = count( $aszLayers );
    for( $i=0; $i<$nTmpCount; $i++ )
        $aszLayers[$i] = trim( $aszLayers[$i] );
}

// check for layers from the url
if ( count( $aszLayers ) > 0 )
{
}
else
{
    // get list from metadata
    for ( $i=0; $i<$nLayerCount; $i++ )
    {
        // get layer
        $oLayer = $oMapSession->oMap->getLayer( $i );
        
        // check metadata
        if ( $oLayer->getmetadata("selected") == 1 )
        {
            // add to the list of layers
            array_push( $aszLayers, $oLayer->name );
        }
    }
}

// check for an empty first one
if ( $aszLayers[0] == '' )
    array_shift( $aszLayers );

// update the active layer count
$nCount = count( $aszLayers );    
    
// only process the first WMS or WFS layer
for ( $i=0; $i<$nCount; $i++ )
{
    // get layer by name
    $oLayer = $oMapSession->oMap->getLayerbyName( $aszLayers[$i] );

    // only process WMS and WFS layers
    if ( $oLayer->connectiontype == MS_WFS || 
         $oLayer->connectiontype == MS_WMS )
    {
        // record layer index
        $nSelectedLayer = $oLayer->index;
        
        // store the layer name to use
        $szSelectedLayerName = $oLayer->name;
        
        // store the connection type
        $szSelectedLayerConnType = $oLayer->connectiontype;
        
        // process according to layer type
        switch( $oLayer->connectiontype )
        {
            case MS_WFS:
                // record the connection string
                $szWFSConnection = $oLayer->connection;
                break;
            case MS_WMS:
                // get WFS the connection string
                $szWFSConnection = getWFSConnection( $oLayer->connection );

                // check for false (meaning no associated WFS)
                if ( $szWFSConnection === false )
                {
                    // give error
                    $szErrorNotice = $oMLT->get("30", 'An invalid WMS layer was '.
                        'selected.  A WMS layer must have a WFS associated with '.
                        'it in order to be filtered.' );
                    
                    // reset
                    $szWFSConnection = '';
                    $nSelectedLayer = '';
                    $szSelectedLayerName = '';
                }
                break;                        
        }
            
        // save expressions if necessary
        if ( isset( $_FORM['txtSaveExpressions'] ) && 
                                        $_FORM['txtSaveExpressions'] == 1 )
        {   
            // store these as current layer's metadata expression
            $oLayer = $oMapSession->oMap->getLayer( $nSelectedLayer );
            $oLayer->setMetadata( 'cham_x_build_expressions', 
                                                  $_FORM['txtExpressions'] );
        }

        // get expressions from metadata
        $_FORM['txtExpressions'] = 
                        $oLayer->getMetadata( 'cham_x_build_expressions' );
                        
        // one layer has been processed so exit loop
        break;
    }

// for loop
}
















/*
// loop through layers and get the first selected one
for ( $i=0; $i<$nLayerCount; $i++ )
{
    // get layer
    $oLayer = $oMapSession->oMap->getLayer( $i );
    
    // check for override from url
    $bSelected = in_array( trim( $oLayer->name ), $aszLayers );
    
    // check metadata if necessary
    if ( !$bSelected )
        $bSelected = $oLayer->getmetadata("selected") == 1;
    else
    {
        // count number from URL
        $nSelectedFromURL++;
    }
  
    // process details
    if ( $bSelected )
    {
        // record the info for first selected layer only
        if ( strlen( $nSelectedLayer ) <= 0 )
        {
            // only process WMS and WFS layers
            if ( $oLayer->connectiontype == MS_WFS || 
                 $oLayer->connectiontype == MS_WMS )
            {
                // record layer index
                $nSelectedLayer = $i;
                
                // store the layer name to use
                $szSelectedLayerName = $oLayer->name;
                
                // store the connection type
                $szSelectedLayerConnType = $oLayer->connectiontype;
                
                // process according to layer type
                switch( $oLayer->connectiontype )
                {
                    case MS_WFS:
                        // record the connection string
                        $szWFSConnection = $oLayer->connection;
                        break;
                    case MS_WMS:
                        // get WFS the connection string
                        $szWFSConnection = getWFSConnection( $oLayer->connection );

                        // check for false (meaning no associated WFS)
                        if ( $szWFSConnection === false )
                        {
                            // give error
                            $szErrorNotice = $oMLT->get("30", 'An invalid WMS layer was '.
                                'selected.  A WMS layer must have a WFS associated with '.
                                'it in order to be filtered.' );
                            
                            // reset
                            $szWFSConnection = '';
                            $nSelectedLayer = '';
                            $szSelectedLayerName = '';
                        }
                        break;                        
                }
                    
                // save expressions if necessary
                if ( isset( $_FORM['txtSaveExpressions'] ) && 
                                                $_FORM['txtSaveExpressions'] == 1 )
                {   
                    // store these as current layer's metadata expression
                    $oLayer = $oMapSession->oMap->getLayer( $nSelectedLayer );
                    $oLayer->setMetadata( 'cham_x_build_expressions', 
                                                          $_FORM['txtExpressions'] );
                }
    
                // get expressions from metadata
                $_FORM['txtExpressions'] = 
                                $oLayer->getMetadata( 'cham_x_build_expressions' );
            }
        }
        
        // increment the counter
        $nCount++;
    }
}
*/

/* ============================================================================
 * Create javascript necessary to load saved expressions
 * ========================================================================= */
if ( isset( $_FORM['txtExpressions'] ) && strlen( $_FORM['txtExpressions'] ) > 0 )
{
    $szJavascriptExpressions = 
                         buildJavascriptExpressions( $_FORM['txtExpressions'] );
}
 
/* ============================================================================
 * Process attribute info
 * ========================================================================= */
if ( strlen( trim( $szWFSConnection ) ) > 0 )
{   
    // check the the WFS online resource contains the necessary params
    $szWFSConnection = fixWFSURL( $szWFSConnection, $szSelectedLayerName );

    // get the attribute types
    $aszAttributes = getAttributeTypes( $szWFSConnection.
                            'request=describefeaturetype', $szSelectedLayerName );

    // build list of attrtibutes
    $szAttributeOptions = '';
    $szLayerType = '';
    foreach( $aszAttributes as $key=>$value )
    {
        // skip layer type
        if ( $key == 'LayerType' )
        {
            $szLayerType = $value;
            continue;
        }
        
        // assemble string
        $szTmpAttribute = $key." (".$value.")";
            
        // create new option list item
        $szAttributeOptions .= "<option value=\"".$key."\">".
            $szTmpAttribute."</option>\n";
    }
}
else
{
    // set error message
    $szErrorNotice = $oMLT->get("20", "Invalid layer or none selected.  ".
        "Please ensure that the selected layer is a WFS or WMS layer." );
}

/* ============================================================================
 * Build style select
 * ========================================================================= */
if ( isset($_FORM['styles']  ) && strlen( $_FORM['styles'] ) > 0 )
{
    // get title
    $szTmpTitle = $oMLT->get("28", "Select SLD");
    
    // loop and build list of drop down options
    $aszStyles = explode( '|', $_FORM['styles'] );
    $nSLDCount = count( $aszStyles );
    $szStyleOptions = '';
    for ( $i=0; $i<$nSLDCount; $i++ )
    {
        // separate the name from the sld file
        $aszSplit = explode( '@', $aszStyles[$i] );
        $szStyleOptions .= '<option value="'.$aszStyles[$i].'">'.$aszSplit[0].
                                                                    '</option>';
    }
    
    // set 
    $szStyleForm = <<<EOT
  <tr>
    <td colspan="2" class="layoutTable">
      <table class="titleArea" width="100%" border="0" cellpadding="4" cellspacing="0">
        <tr>
          <td><span class="title">{$szTmpTitle}</span></td>
        </tr>
      </table>
      <table class="contentArea" width="100%" border="0" cellpadding="4" cellspacing="0">
        <tr>
          <td><select name="selSLD" class="inputList">
                {$szStyleOptions}
              </select></td>
        </tr>
      </table>    
    </td>
  </tr>
EOT;
    
/* ============================================================================
 * Build layer type HTML
 * ========================================================================= */
    if ( !isset( $szLayerType ) || strlen( $szLayerType ) <= 0 )
    {
        $szLayerTypeHTML = '<td valign="middle" rowspan="2"><p class="helpArea">'.
            $oMLT->get('33', 'Unable to determine layer data type.  Please specify the underlying data type for this layer.').
            '</p></td>'.
            '</tr>'.
            '<tr>'.
            '<td valign="top"><span class="label">'.
            $oMLT->get("31", "Type").
            ': </span><select name="selLayerType" class="inputList">'.
            '<option value="MS_LAYER_POINT">Point</option>'.
            '<option value="MS_LAYER_LINE">Line</option>'.
            '<option value="MS_LAYER_POLYGON">Polygon</option></select></td>';
    }
    else
    {
        if ( !isset( $szLayerType ) ) $szLayerType = '';
        $szLayerTypeHTML = '<input type="hidden" name="selLayerType" value="'.
                                                                $szLayerType.'">';
    }   
}
/**
 * getAttributeTypes()
 *
 * Postcondition:  This function processes the given XML file returns an array
 *                 of attribute names and types.
 *
 * @param $szXmlUrl string - URL to the XML document to parse.
 * @return mixed - Array of results or a string of the server error results.
 * @desc Reads XML datasource and returns array of att->type pairs.
 */
function getAttributeTypes( $szXmlUrl, $szLayerName ) 
{
    // int vars
    $data = "";
    $axReturn = "";
    
    // read the xml datasource
    $aszFile = file( $szXmlUrl );

    // combine results
    if ( is_array( $aszFile ) )
    {
        foreach( $aszFile as $line )
            $data .= $line;
    }

    // check to see if an error was generated
    if ( !is_array( $aszFile ) || 
         strpos( strtoupper( $data ), '<SERVICEEXCEPTIONREPORT' ) !== false )
        return array();
    
    // parse
    $parser = xml_parser_create();
    xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
    xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
    xml_parse_into_struct($parser,$data,$values,$tags);
    xml_parser_free($parser);

    // loop through the structures and process the SEQUENCE
    foreach ($tags as $key=>$val) 
    {
        // process ROWSET
        if (strtoupper( $key ) == "SEQUENCE") 
        {
            $ranges = $val;
            // each contiguous pair of array entries are the 
            // lower and upper range for each SEQUENCE definition
            $nCount = count($ranges);          
            for ($i=0; $i < $nCount; $i+=2) 
            {
                $offset = $ranges[$i] + 1;
                $len = $ranges[$i + 1] - $offset;
                $axReturn = parseElements( array_slice($values, $offset, $len) );
            }
        } 
        else 
        {
            // otherwise skip
            continue;
        }
    }
    
    // return
    return $axReturn;
    
// end getAttributeTypes() function    
}

/**
 * parseElements()
 *
 * Postcondition:  This function parses the given array returns an array of 
 *                 attribute->type pairs.
 *
 * @param axValues Array - Mixed array of XML tags to process.
 * @return array - Array of att->type pairs if successful or empty array if not.
 * @desc Parses array and returns array of att->type pairs.
 */
function parseElements( $axValues ) 
{   
    // init vars
    $aszReturn = array();
    
    // loop through each item of the array
    $nCount = count( $axValues );
    for ( $i=0; $i < $nCount; $i++ )
    {
        // only process "name" and "type" values
        if ( strtoupper( $axValues[$i]["tag"] ) == "ELEMENT" )
        {
            // add to array
            if ( isset(  $axValues[$i]["attributes"]["name"] ) && 
                 $axValues[$i]["attributes"]["type"] )
            {
               $aszReturn[$axValues[$i]["attributes"]["name"]] = 
                                            $axValues[$i]["attributes"]["type"];
            }
            
            // check for the layer type
            $szLayerType = '';
            if ( isset( $axValues[$i]["attributes"]["ref"] ) )
                $szLayerType = strtoupper( $axValues[$i]["attributes"]["ref"] );
            elseif ( isset( $axValues[$i]["attributes"]["type"] ) && 
                     strtoupper( substr( $axValues[$i]["attributes"]["type"], 0, 4 ) ) == 'GML:' )
                $szLayerType = strtoupper( $axValues[$i]["attributes"]["type"] );
            
            // check for the type
            if (  strlen( $szLayerType ) > 0 )
            {
                // check if poly
                if ( strpos( $szLayerType, 'POLYGON' ) !== false )
                    $aszReturn['LayerType'] = 'MS_LAYER_POLYGON';
                elseif ( strpos( $szLayerType, 'BOX' ) !== false )
                    $aszReturn['LayerType'] = 'MS_LAYER_POLYGON';                    
                elseif ( strpos( $szLayerType, 'LINE' ) !== false )
                    $aszReturn['LayerType'] = 'MS_LAYER_LINE';
                elseif ( strpos( $szLayerType, 'POINT' ) !== false )
                    $aszReturn['LayerType'] = 'MS_LAYER_POINT';                   
            }
        }
    }
    
    // return array
    return $aszReturn;
    
// end parseElements() function
}

function buildJavascriptExpressions( $szExpressionsString )
{
    
    // explode individual expressions
    $aszExpressions = explode( '|@|', $szExpressionsString );
    
    // init vars
    $szJavascriptExpressions = "";
    
    // process each expression
    foreach( $aszExpressions as $szExpression )
    {
        // skip if empty
        if ( strlen( trim( $szExpression ) ) <= 0 )
            continue;
        
        // break apart
        $aszExpComponents = explode( '|', $szExpression );
          
        // create javascript to add expressions
        $szJavascriptExpressions .= 'addExpression( "'.
                                        $aszExpComponents[0].'", "'.
                                        $aszExpComponents[1].'", "'.
                                        $aszExpComponents[2].'", "'.
                                        $aszExpComponents[4].'", "'.
                                        $aszExpComponents[5].'", "'.
                                        $aszExpComponents[2].'", "'.
                                        $aszExpComponents[3].'", "'.
                                        $aszExpComponents[4].'", "'.
                                        $aszExpComponents[5].'" );';
    }
    
    // return 
    return $szJavascriptExpressions;
}

/**
 * getWFSConnection()
 *
 * Postscript:  This function reads the given WMS connection and returns the WFS 
 *              online resource.
 *
 * @param $szWMSConnection string - WMS connection string.
 * @return string - WFS online resource if successful, false if failed.
 * @desc Parses given connection string and returns WFS online resource.
 */
function getWFSConnection( $szWMSConnection )
{
    // get the url to perform a describelayer on
    $szUpperCase = strtoupper( $szWMSConnection );

    // check last char for ? or &
    if ( substr( $szWMSConnection, -1 ) != "?" &&
         substr( $szWMSConnection, -1 ) != "&" )
    {
        // check for ?
        if ( strpos( $szWMSConnection, "?" ) === false )
        {
            $szWMSConnection .= "?";
        }
        else
            $szWMSConnection .= "&";
    }

    // check for and add VERSION
    if ( strpos( $szUpperCase, "VERSION=" ) === false )
        $szWMSConnection .= "VERSION=1.1.0&";

    // check for and add SERVICE
    if ( strpos( $szUpperCase, "SERVICE=" ) === false )
        $szWMSConnection .= "SERVICE=WMS&";

    // add LAYERS
    if ( strpos( $szUpperCase, "LAYERS=" ) ===  false )
        $szWMSConnection .= "LAYERS=".$szSelectedLayerName."&";

    // add REQUEST
    $szWMSConnection .= "REQUEST=DESCRIBELAYER";

    // perform a describe layer
    return getWFSResource( $szWMSConnection );
    
// end getWFSConnection function
}

/**
 * getWFSResource()
 *
 * Postscript:  This function reads the given url and returns the WFS online
 *              resource.
 *
 * @param $szURL string - URL to the GML source.
 * @return string - WFS online resource if successful, false if failed.
 * @desc Parses given url and returns WFS online resource.
 */
function getWFSResource( $szURL )
{
    // init vars
    $data = "";
    $szReturn = "";
    
    // read the xml datasource
    $aszFile = file( $szURL );

    // check to see if an error was generated
    if ( !is_array( $aszFile ) ||
         strtoupper( substr( $aszFile[0], 0, 23 ) ) == "<SERVICEEXCEPTIONREPORT" )
    {
        return false;
    }

    // process url
    foreach( $aszFile as $line )
    {
        // check each line until "<LayerDescription" is found
        if ( strpos( strtoupper( $line ) ,
                                "<LAYERDESCRIPTION" ) !== false )
        {
            // loop through and extract the wfs param
            $nCount = strlen( $line );
            $bOpen = false;
            for ( $i=0; $i<$nCount; $i++ )
            {
                // check for the closing "
                if ( $bOpen )
                {
                    // look for the closing "
                    if ( substr( $line, $i, 1 ) != "\"" )
                        $szReturn .= substr( $line, $i, 1 );
                    else
                        break;
                }
                else
                {
                    // check for first occurance of " wfs="
                    if ( substr( strtoupper( $line ), $i, 5 )
                                                == " WFS=" )
                    {
                        // flag as open and advance
                        $bOpen = true;
                        $i += 5;
                    }
                }
            }
        }
    }

    // return true
    return $szReturn;

// end getWFSResource function
}

/**
 * fixWFSURL()
 *
 * Postscript:  This function adds any missing WFS parameters to a WFS connection.
 *
 * @param $szConnection string - Connection string.
 * @param $szLayerName string -  Layer name to add.
 * @return string - The updated url.
 * @desc Checks given WFS connection and adds the necessary parameters.
 */
function fixWFSURL( $szConnection, $szLayerName )
{
    // convert the url to uppercase
    $szUpperCase = strtoupper( $szConnection );
    
    // check last char for ? or &
    if ( substr( $szConnection, -1 ) != "?" &&
         substr( $szConnection, -1 ) != "&" )
    {
        // check for ?
        if ( strpos( $szConnection, "?" ) === false )
        {
            $szConnection .= "?";
        }
        else
            $szConnection .= "&";
    }    
    
    // check for and add VERSION
    if ( strpos( $szUpperCase, "VERSION=" ) === false )
        $szConnection .= "VERSION=1.0.0&";

    // check for and add SERVICE
    if ( strpos( $szUpperCase, "SERVICE=" ) === false )
        $szConnection .= "SERVICE=WFS&";

    // add TYPENAME
    if ( strpos( $szUpperCase, "TYPENAME=" ) ===  false )
        $szConnection .= "TYPENAME=".$szLayerName."&";
    
    // return
    return $szConnection;

// end fixWFSURL function
}
?>