<?php
/**
 * ExtractContext Widget class
 *
 * @project     CWC2
 * @revision    $Id: ExtractContext.widget.php,v 1.3 2004/02/02 14:18:16 sfournier Exp $
 * @purpose     ExtractContext widget class
 * @author      DM Solutions Group (spencer@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */


include_once("Link.widget.php");
include_once( COMMON."wrapper/map_navigator.php" );
include_once("Popup.php");
/**
 * ExtractContext
 *
 * Extract widget class
 */
class ExtractContext extends Link
{
    var $moPopup;          // Popup object

    /**
     * ExtractContextWidget
     *
     * Constctor method for the ExtractContext widget.
     */
    function ExtractContext()
    {
        $this->mszLanguageResource = "../data/language/ExtractContext.dbf";

        // invoke constructor of parent
        parent::Link();

        $this->Link($this);
        // set the description for this widget
        $this->szWidgetDescription = <<<EOT
The ExtractContext widget passes the current context to a web-based extraction
service.
EOT;

        $this->maAttributes["EXTRACTURL"] = new StringAttribute( "EXTRACTURL", true );
    }

    function InitDefaults()
    {
        $this->moPopup = new CWCPopup($this);
        parent::InitDefaults();
    }

    /**
     * GetJavascriptFunctions
     *
     * Build and return the array of functions needed in the
     * widget.
     */
    function GetJavascriptFunctions()
    {
        $aReturn = array();

        if (is_object($this->moPopup))
        	$szPopup = $this->moPopup->DrawPublish();
        else
        	$szPopup = "";

        $this->moPopup->mszLink = "widgets/ExtractContext.phtml";
        $this->moPopup->mszParam = "&EXTRACTURL=".urlencode($this->maParams["EXTRACTURL"]);

        $szJsFunctionName = "clickExtractContext";
        $szFunction = "function $szJsFunctionName()\n" .
         "{\n".
          $szPopup."\n".
        "return;\n" .
        "}\n";
        $aReturn[$szJsFunctionName] = $szFunction;

        return $aReturn;
    }

    /**
     * DrawPublish
     *
     * Return the HTML code to display the link to the legend popup
     */
    function DrawPublish()
    {
        if (!$this->mbVisible)
            return "<!-- ExtractContext widget hidden -->";

        $this->maParams["HREF"] = "clickExtractContext()";
        $this->maParams["POPUP"] = "true";

        $szReturn = parent::DrawPublish();

        return $szReturn;
    }
}

if ((function_exists( "RegisterWidget" )))
    RegisterWidget( "ExtractContext", "ExtractContext" );
?>
