<?php
/**
 * WebService   Abstract class definition of Web search service
 *
 * @project     PHPGeoCoder
 * @revision    $Id:
 * @purpose     Abstract class definition of Web search service.
 * @author      Sacha Fournier (sfournier@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

include_once("service.php");

class WebSearchService extends SearchService
{
    var $szBaseURL;
    var $szParameters;

    var $szRawResult;

    function WebSearchService($szSearchServiceName = "", 
                              $oGeoCoder = "", 
                              $szBaseURL = "")
    {
        parent::SearchService($szSearchServiceName, $oGeoCoder);

        $this->log(LOG_VERBOSE, "WebSearchService($szSearchServiceName, $oGeoCoder, $szBaseURL)");

        $this->szBaseURL = $szBaseURL;
        $this->szParameters = "";
    }

    function search()
    {
        $this->log(LOG_VERBOSE, "search (".$this->szBaseURL."?".$this->szParameters.")");

        parent::search();

        $bRes = true;
        $this->szRawResult = "";

        // Init connection with server
        $aszLines = @file($this->szBaseURL."?".$this->szParameters);

        // Check if web server returned something else than 200
        if ($aszLines == "")
        {
            $this->error(ERR_CRITICAL, "Can't communicate with ".$this->szBaseURL);
            $bRes = false;
        }
        else
            $this->szRawResult = implode("", $aszLines);

        return $bRes;
    }
}
?>
