<?php
/**
 * This script generate a gif file representing
 * the font ($szFontToDisplay) from font file.
 * Font file is set by registered variable
 * $FontFileRef
 *
 * @project     MapEdit
 * @revision    $Id: sect_font.php,v 1.5 2004/03/01 16:52:29 sfournier Exp $
 * @purpose     Generate a font preview image
 * @author      Paul Spencer (spencer@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
$szStudioConfigFile = '../config/studio.xml';
$parser = xml_parser_create();
xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE,   1);
xml_parse_into_struct($parser, file_get_contents( $szStudioConfigFile), $aVals, $aIndicies);
xml_parser_free($parser);

$gszChameleonPath = '';
foreach( $aIndicies as $key => $indexes )
{
    if ($key =='param-name')
    {
        foreach( $indexes as $index )
        {
            if ($aVals[$index]['value'] == 'chameleon_path')
            {
                //value is in next index
                if (isset($aVals[$index + 1]['value']))
                    $gszChameleonPath = $aVals[$index + 1]['value'];
                break;
            }
        }
    }
}

if ($gszChameleonPath == '')
{
    $gszChameleonPath = '../../chameleon';
}
include_once( "common.php" );

include_once( COMMON."/logger/error_manager.php" );

include_once( COMMON."/session/session.php" );
installSessionDirectoryHandler();
initializeSession();

/* -------------------------------------------------------------------- */
/*      Load required modules                                           */
/* -------------------------------------------------------------------- */
if (PHP_OS == "WINNT" || PHP_OS == "WIN32")
{
    if (!extension_loaded("gd"))
    {
        dl("php_gd2.dll");
    }
}
else
{
    if (!extension_loaded("gd"))
        dl("php_gd2.so");
}

$nX = isset($_GET['width']) ? $_GET['width'] : 80;
$nY = isset($_GET['height']) ? $_GET['height'] : 26;
$nFontSize = 10;
$szFontToDisplay = $_GET["szFontName"];
// If no font specify, display a empty gif.
if ($szFontToDisplay == "NONE" || $szFontToDisplay == "" ||
    !isset($_SESSION["gszFontListFile"]))
    $bDrawX = true;
else
    $bDrawX = false;

// Create the image
$nImgId = ImageCreate($nX, $nY);

//allocate drawing colors
$nXColor = ImageColorAllocate( $nImgId, 255, 0, 0);
$nRed = (isset($_GET["nRed"])) ? $_GET["nRed"] : 0;
$nGreen = (isset($_GET["nGreen"])) ? $_GET["nGreen"] : 0;
$nBlue = (isset($_GET["nBlue"])) ? $_GET["nBlue"] : 0;

$nFillColor = ImageColorAllocate ($nImgId, $nRed, $nGreen, $nBlue);
$nShadowColor = ImageColorAllocate( $nImgId, 153, 153, 153 );
$nHiliteColor = ImageColorAllocate( $nImgId, 255, 255, 255 );
$nFaceColor = ImageColorAllocate( $nImgId, 217, 217, 217 );
$nTriangleColor = ImageColorAllocate($nImgId, 0,0,0);
$nWhite = ImageColorAllocate($nImgId, 255, 255, 255 );

$nBorderColor = ImageColorAllocate($nImgId, 0,0,0);

//fill up the rectange with the face color and draw everything
//else on top
ImageFilledRectangle($nImgId, 0, 0, $nX - 1, $nY - 1, $nFaceColor);
ImageFilledRectangle($nImgId, 0, 0, $nX - 1, $nY - 1, $nWhite );

if ($bDrawX)
{
    //no, draw a red X
    $nCX = intval(( $nX - 1 ) / 2);
    $nCY = intval(( $nY - 1 ) / 2);
    ImageFilledRectangle( $nImgId, 3, 3, $nX - 4, $nY - 4, $nWhite );
    ImageLine( $nImgId, $nCX-3, $nCY-3, $nCX+3, $nCY+3, $nXColor );
    ImageLine( $nImgId, $nCX-2, $nCY-3, $nCX+4, $nCY+3, $nXColor );
    ImageLine( $nImgId, $nCX+3, $nCY-3, $nCX-3, $nCY+3, $nXColor );
    ImageLine( $nImgId, $nCX+4, $nCY-3, $nCX-2, $nCY+3, $nXColor );
}
else
{
    // Open the whole file
    $szFontFile = $_SESSION['gszFontListFile'];

    if (substr($szFontFile, 0, 1) != "/" && substr($szFontFile, 1, 1) != ":")
    {
        $szFontFile = $_SESSION['gszMapPath'] . "/". $szFontFile;
    }
    $aszTmpFontList = file($szFontFile );
    $aszFontList = array();

    $szFontList = "";

    // Parse each line of the font file
    foreach ($aszTmpFontList as $szFont)
    {
        // Extract the font name
        $szFontName = trim($szFont, " ");
        $szFontName = preg_replace("/\s+/", "|", $szFontName);
        $aszFontName = explode("|", $szFontName);
        $szFontName = $aszFontName[0];
        if ($szFontName ==  $szFontToDisplay)
        {
            // Extrack the font file name
            $szFontToDisplay = $aszFontName[1];
            // Get bounding box of text
            $ttfBBox =  imagettfbbox ($nFontSize, 0,
                                      dirname($szFontFile )."/".
                                      $szFontToDisplay,
                                      $szFontName);
            $nFontHeight = abs($ttfBBox[7] - $ttfBBox[3]);
            $nFontWidth = abs($ttfBBox[6] - $ttfBBox[2]);
            $nLabelX = max(5, ($nX - $nFontWidth) / 2);
            $nLabelY = max(5, ($nY + $nFontHeight - 4) / 2);
            // Test will be black
            $text_color = ImageColorAllocate ($nImgId, 0, 0, 0);

            // Draw text. Use font name for sample text
            ImageTTFText($nImgId, $nFontSize, 0, $nLabelX, $nLabelY, $text_color,
                         dirname($szFontFile )."/".$szFontToDisplay,
                         $szFontName);

        }
   }
}

//draw the inside black border
ImageLine( $nImgId, 1, 1, $nX-2, 1, $nBorderColor);
ImageLine( $nImgId, 1, 1, 1, $nY-2, $nBorderColor);
ImageLine( $nImgId, $nX-2, 1, $nX-2, $nY-2, $nBorderColor);
ImageLine( $nImgId, 1, $nY-2, $nX-2, $nY-2, $nBorderColor);
//draw the outside shadow and hilite (appears inset)
ImageLine( $nImgId, 0, 0, $nX-1, 0, $nShadowColor);
ImageLine( $nImgId, 0, 0, 0, $nY-1, $nShadowColor);
ImageLine( $nImgId, $nX-1, 1, $nX-1, $nY-1, $nHiliteColor);
ImageLine( $nImgId, 1, $nY-1, $nX-1, $nY-1, $nHiliteColor);
//draw the corner button (appears beveled)
ImageLine( $nImgId, $nX-8, $nY-1, $nX-1, $nY-1, $nBorderColor);
ImageLine( $nImgId, $nX-1, $nY-8, $nX-1, $nY-1, $nBorderColor);
ImageLine( $nImgId, $nX-2, $nY-8, $nX-8, $nY-2, $nBorderColor);
ImageLine( $nImgId, $nX-2, $nY-7, $nX-7, $nY-2, $nHiliteColor);
ImageLine( $nImgId, $nX-2, $nY-6, $nX-2, $nY-2, $nShadowColor);
ImageLine( $nImgId, $nX-6, $nY-2, $nX-2, $nY-2, $nShadowColor);
ImageLine( $nImgId, $nX-3, $nY-5, $nX-5, $nY-3, $nFaceColor);
ImageLine( $nImgId, $nX-3, $nY-4, $nX-4, $nY-3, $nFaceColor);
ImageLine( $nImgId, $nX-3, $nY-3, $nX-3, $nY-3, $nFaceColor);


//draw the small face colored box for the drop down triangle
//ImageFilledRectangle($nImgId, $nX-8, $nY-6, $nX-1, $nY-1, $nFaceColor);

//ImageLine( $nImgId, 0, 0, $nX-1, 0, $nHiliteColor);
//ImageLine( $nImgId, 0, 0, 0, $nY-1, $nHiliteColor);
//ImageLine( $nImgId, $nX-1, $nY-1, $nX-1, 0, $nShadowColor);
//ImageLine( $nImgId, $nX-1, $nY-1, 0, $nY-1, $nShadowColor);
//ImageLine( $nImgId, 2, 2, 2, $nY - 3, $nShadowColor );
//ImageLine( $nImgId, 2, 2, $nX - 3, 2, $nShadowColor );
//ImageLine( $nImgId, $nX-3, 2, $nX-3, $nY-7, $nHiliteColor );
//ImageLine( $nImgId, 2, $nY-3, $nX-9, $nY-3, $nHiliteColor );
//ImageLine( $nImgId, $nX-9, $nY-7, $nX-3, $nY-7, $nHiliteColor );
//ImageLine( $nImgId, $nX-9, $nY-7, $nX-9, $nY-3, $nHiliteColor );

//$anPoints = array();
//$anPoints[0] = $nX - 7;
//$anPoints[1] = $nY - 5;
//$anPoints[2] = $nX - 3;
//$anPoints[3] = $nY - 5;
//$anPoints[4] = $nX - 5;
//$anPoints[5] = $nY - 3;
//ImageFilledPolygon( $nImgId, $anPoints, 3, $nTriangleColor);

if (!isset($_SESSION["gszImageType"]))
{
    header("Content-type: image/png");
    ImagePng($nImgId);
}
else
{
    header("Content-type: image/".$_SESSION["gszImageType"]);
    eval("Image".$_SESSION["gszImageType"]."(\$nImgId);");
}

ImageDestroy( $nImgId );
?>

