<?php
/**
 * MapLab XML configuration Tool
 *
 * @project     MapLab
 * @revision    $Id: edit_xml.php,v 1.1.1.1 2004/02/03 20:08:24 pspencer Exp $
 * @purpose     This is the XML configuration page.
 * @author      Sacha Fournier (sfournier@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

/*****************************************************************************
 * $Log: edit_xml.php,v $
 * Revision 1.1.1.1  2004/02/03 20:08:24  pspencer
 * rip Studio out of MapLab and make its own cvs
 *
 * Revision 1.1  2003/10/08 21:14:44  zjames
 * initial checkin
 *
 *
 *****************************************************************************/

error_reporting( E_ALL );

// define the common directory    
if (!defined( "COMMON" ) )
    define("COMMON", "../htdocs/common/");

// include appcontext definition
include_once(COMMON."appcontext/appcontext.php");

include_once("./edit_xml_default.php");

/* ============================================================================
 * Build an array with the HTTP GET or POST parameters.
 * ========================================================================= */
// check for POST vars
$http_form_vars =  (count($_POST) > 0) ? 
                   $_POST : ((count($_GET) > 0) ? $_GET : array());

if (!isset($http_form_vars["bSave"]))
    $http_form_vars["bSave"] = false;

/* ============================================================================
 * Check for valid config file
 * ========================================================================= */
// initialize vars
$gszStatus = "";
$gbErrors = false;
 
// check for the configuration file
if ( $http_form_vars["szConfigFile"] == "" || 
     !is_file( $http_form_vars["szConfigFile"] ) )
{
    // log message
    echo "No configuration file specified.";
    exit;
}    
else
{
    //TODO: add regex expression to make sure that this value is a valid file
    //name, ends with XML and doesn't have any extra path information than it
    //should.  Should probably limit it to one of four file names also.
    // check if the file is read-only
    if ( !is_writable( $http_form_vars["szConfigFile"] ) )
        $gbWritable = false;
    else
        $gbWritable = true;    

    // create the new appcontext object
    $oAppContext = new AppContext( $http_form_vars["szConfigFile"] );

/* ============================================================================
 * Process save command
 * ========================================================================= */    
    if ( $http_form_vars["bSave"] == 1 && $gbWritable )
    {
        // set flag
        $bChanged = false;
        //array of changed keys
        $aszChangedKeys = array();
        
        // loop through each query variable and set
        foreach ($http_form_vars as $szKey => $szValue)
        {
            $bRet = false;
            // Check if it is a include variable
            if ( substr($szKey,0, 14) == "SUBAPPCONTEXT_" )
            {
                // get name
                $szSubContextName = substr($szKey, 14);
                
                // loop through each
                foreach(array_keys($oAppContext->aoContext) as $szContextKey)
                {
                    if ($oAppContext->aoContext[$szContextKey]->szContextName == $szSubContextName)
                    {
                        if ( trim ( $oAppContext->aoContext[$szContextKey]->szContextFile ) != trim( $szValue ) )
                        {
                            $oAppContext->aoContext[$szContextKey]->szContextFile = $szValue;
                            $bRet = true;
                            //array_push($aszChangedKeys, $szValue);
                        }
                    }
            
                    // update the name to display
                    $szKey = $szSubContextName;
                    break;
                }
            
                //continue;
            } 
            else
            {      
                // set if changed
                $szCurrentValue = $oAppContext->getContextValue( $szKey );
                if (trim($szCurrentValue) != trim($szValue))
                {
                    $bRet = $oAppContext->setContextValue($szKey, $szValue);
                }
                
            }
            
            // check for failure
            if ($bRet !== false)
            {
               $bChanged = true;
               array_push($aszChangedKeys, $szKey);
            }
            
        }
        
        // check for any changes
        if ($bChanged)
        {
            // save the file
            $gszStatus .= "Committing changes....";
            $bRes = $oAppContext->saveAppContext( 
                                            $http_form_vars["szConfigFile"] );
            // check success
            if ($bRes == true)
            {
                // flag success
                $gszStatus .= "OK\n";
            }
            else
            {
                // log error
                $gszStatus .= "Failed\n";
                $gbErrors = true;            
            }
        }
    }
    if (isset($http_form_vars["szTargetConfigFile"]) && 
        $http_form_vars["szTargetConfigFile"] != "" && 
        is_file("../config/".$http_form_vars["szTargetConfigFile"].".xml"))
        header("Location:./edit_xml.phtml?szConfigFile=../config/".$http_form_vars['szTargetConfigFile'].".xml");
}   
?>


