<?php
/* ************************************************
     Post installation process for studio
   ***********************************************/
// Include help functions
if (!defined("INSTALL_INCLUDED"))
{
    if (isset($GLOBALS['argv'][1]))
    {
        if (!@include_once(str_replace("\\", "/", $GLOBALS['argv'][1]."/installer/client/install.php")))
        {
            echo "\n\nPlease specify path to applications repository. EG: php -q post-installation.php /DMPear/\n\n";
            exit;
        }
    }
    else
    {
        echo "\n\nPlease specify path to applications repository. EG: php -q post-installation.php /DMPear/\n\n";
        exit;
    }
}

// Step 1.
//
// Update registry. We put category inside the registry.
setApplicationName("studio", "studio");


// Step 2.
//
// Create httpd.d if don't exist. Copy the file in the correct
// directory and replace all %DMPEAR% instance to the current
// applications repository.
setHttpdConfFile("studio", "studio/httpd_studio.conf");


// Step 3.
//
// Copy conf dist file to current conf file (if no exist). put
// default values in parameters.
$szAppRep = getApplicationRepositoryDir();
$aszReplaceFrom = array("%CHAMELEON_PATH%", 
                        "%PROJECT_ROOT%", 
                        "%PROJECT_WEB_ROOT%");
$aszReplaceTo   = array(str_replace("\\","/",$gszApplicationsRepository.DS."chameleon".DS), 
                        str_replace("\\","/",$gszApplicationsRepository.DS."studio".DS."project".DS), 
                        "/studio/project/");

copyFileAndReplace($aszReplaceFrom, $aszReplaceTo, 
                   "studio/config/studio-dist.xml", 
                   "studio/config/studio.xml");

// Step 4.
//
// Make sure COMMON is set to something ok.
// for chameleon.php
$aszReplaceFrom = array("//%DMPEAR_WEBCOMMON%", "//%DMPEAR_COMMON%");
$aszReplaceTo   = array("define(\"WEBCOMMON\", \"/common/\");", 
                        "define(\"COMMON\", \"".str_replace("\\","/", $szAppRep.DS."php_utils".DS)."\");");

copyFileAndReplace($aszReplaceFrom, $aszReplaceTo, "/studio/htdocs/common.php");

// Step 5.
//
// Create project directory
if (!file_exists($gszApplicationsRepository.DS."studio".DS."project"))
    mkdir($gszApplicationsRepository.DS."studio".DS."project");
?>